-- Parser generated by Pappy - do not edit
module Lojban where

import Pappy.Pos
import Pappy.Parse
import Pappy.Basic

{-# LINE 18 "Lojban.pappy" #-}
import JboSyntax
import Logic hiding (Term,Connective)

import Data.Maybe
import Control.Monad.State
import Data.Map (Map)
import qualified Data.Map as Map
import Data.Char (isSpace, isDigit, digitToInt)

data JekJoik = JJJek LogJboConnective | JJJoik Joik
jjJboCon :: (Maybe Tag) -> JekJoik -> Connective
jjJboCon mtag (JJJek lcon) = jboConnLogOrQ mtag lcon
jjJboCon mtag (JJJoik joik) = JboConnJoik mtag joik

jboConnLogOrQ mtag (LogJboConnective _ 'i' _) = JboConnJoik mtag "??"
jboConnLogOrQ mtag lcon = JboConnLog mtag lcon


{-# LINE 1148 "Lojban.pappy" #-}

data LojbanDerivs = LojbanDerivs {
	lojbanSub0 :: LojbanDerivs0,
	lojbanSub1 :: LojbanDerivs1,
	lojbanSub2 :: LojbanDerivs2,
	lojbanSub3 :: LojbanDerivs3,
	lojbanSub4 :: LojbanDerivs4,
	lojbanChar :: Result LojbanDerivs Char,
	lojbanPos :: Pos
}

instance Derivs LojbanDerivs where
	dvChar d = lojbanChar d
	dvPos d = lojbanPos d

data LojbanDerivs0 = LojbanDerivs0 {
	lojbanSubStarRule0 :: Result LojbanDerivs ([String]),
	lojbanSubfree :: Result LojbanDerivs (Free),
	lojbanSubStarRule1 :: Result LojbanDerivs ([COI]),
	lojbanSubPlusRule1 :: Result LojbanDerivs ([COI]),
	lojbanSubcoi :: Result LojbanDerivs (COI),
	lojbanSubindicator :: Result LojbanDerivs (Free),
	lojbanSubStarRule3 :: Result LojbanDerivs ([String]),
	lojbanSubtext :: Result LojbanDerivs (Text),
	lojbanSubStarRule4 :: Result LojbanDerivs ([Free]),
	lojbanSubtext1 :: Result LojbanDerivs ([Paragraph]),
	lojbanSubPlusRule4 :: Result LojbanDerivs ([String]),
	lojbanSubparagraphs :: Result LojbanDerivs ([Paragraph]),
	lojbanSubStarRule5 :: Result LojbanDerivs ([Maybe (Either Fragment Statement)]),
	lojbanSubstatementOrFragment :: Result LojbanDerivs (Either Fragment Statement),
	lojbanSubstatement :: Result LojbanDerivs (Statement),
	lojbanSubStarRule9 :: Result LojbanDerivs ([(Connective, Statement1)]),
	lojbanSubstatement2 :: Result LojbanDerivs (Statement1),
	lojbanSubtermsAndTail :: Result LojbanDerivs (([Term],BridiTail)),
	lojbanSubsubsentence :: Result LojbanDerivs (Subsentence)}

data LojbanDerivs1 = LojbanDerivs1 {
	lojbanSubbridiTail :: Result LojbanDerivs (BridiTail),
	lojbanSubStarRule13 :: Result LojbanDerivs ([(Connective, BridiTail, [Term])]),
	lojbanSubbridiTail2 :: Result LojbanDerivs (BridiTail),
	lojbanSubgekSentence :: Result LojbanDerivs (GekSentence),
	lojbanSubStarRule14 :: Result LojbanDerivs ([Term]),
	lojbanSubPlusRule5 :: Result LojbanDerivs ([Term]),
	lojbanSubterms1 :: Result LojbanDerivs (Term),
	lojbanSubPlusRule6 :: Result LojbanDerivs ([Term]),
	lojbanSubterm :: Result LojbanDerivs (Term),
	lojbanSubtermsGikTerms :: Result LojbanDerivs (([Term],Bool,[Term])),
	lojbanSubsumti :: Result LojbanDerivs (Sumti),
	lojbanSubStarRule15 :: Result LojbanDerivs ([(Connective, Sumti)]),
	lojbanSubsumti3 :: Result LojbanDerivs (Sumti),
	lojbanSubsumti4 :: Result LojbanDerivs (Sumti),
	lojbanSubsumti6 :: Result LojbanDerivs (SumtiAtom),
	lojbanSubqualifier :: Result LojbanDerivs (SumtiQualifier),
	lojbanSubPlusRule7 :: Result LojbanDerivs ([String]),
	lojbanSubStarRule17 :: Result LojbanDerivs ([String])}

data LojbanDerivs2 = LojbanDerivs2 {
	lojbanSubStarRule18 :: Result LojbanDerivs ([String]),
	lojbanSubStarRule19 :: Result LojbanDerivs ([String]),
	lojbanSubsumtiTail1 :: Result LojbanDerivs ((Maybe Mex, Either Selbri Sumti, [RelClause])),
	lojbanSubStarRule20 :: Result LojbanDerivs ([RelClause]),
	lojbanSubrelativeClause :: Result LojbanDerivs (RelClause),
	lojbanSubselbri1 :: Result LojbanDerivs (Selbri),
	lojbanSubselbri2 :: Result LojbanDerivs (Selbri2),
	lojbanSubselbri3Tail :: Result LojbanDerivs ((Selbri3 -> Selbri3)),
	lojbanSubStarRule21 :: Result LojbanDerivs ([(Connective, Selbri3)]),
	lojbanSubselbri5 :: Result LojbanDerivs (Selbri3),
	lojbanSubselbri6 :: Result LojbanDerivs (Selbri3),
	lojbanSubtanruUnitTail :: Result LojbanDerivs ((Selbri3 -> Selbri3)),
	lojbanSubStarRule22 :: Result LojbanDerivs ([Free]),
	lojbanSubPlusRule8 :: Result LojbanDerivs ([String]),
	lojbanSubtanruUnit2 :: Result LojbanDerivs (TanruUnit),
	lojbanSubabstractor :: Result LojbanDerivs (Abstractor),
	lojbanSublinks :: Result LojbanDerivs ([Term]),
	lojbanSubStarRule23 :: Result LojbanDerivs ([Mex -> Mex]),
	lojbanSubmex1 :: Result LojbanDerivs (Mex)}

data LojbanDerivs3 = LojbanDerivs3 {
	lojbanSubmex2 :: Result LojbanDerivs (Mex),
	lojbanSubrpExpressionTail :: Result LojbanDerivs (Mex -> Mex),
	lojbanSubStarRule24 :: Result LojbanDerivs ([(Connective, Operator)]),
	lojbanSuboperator1 :: Result LojbanDerivs (Operator),
	lojbanSuboperator2 :: Result LojbanDerivs (Operator),
	lojbanSubmexOperator :: Result LojbanDerivs (Operator),
	lojbanSuboperand :: Result LojbanDerivs (Mex),
	lojbanSubStarRule25 :: Result LojbanDerivs ([Mex -> Mex]),
	lojbanSuboperand2 :: Result LojbanDerivs (Mex),
	lojbanSubPlusRule10 :: Result LojbanDerivs ([Mex]),
	lojbanSuboperand3 :: Result LojbanDerivs (Mex),
	lojbanSubStarRule26 :: Result LojbanDerivs ([Numeral]),
	lojbanSubPlusRule11 :: Result LojbanDerivs ([Int]),
	lojbanSubStarRule27 :: Result LojbanDerivs ([Lerfu]),
	lojbanSublerfuWord :: Result LojbanDerivs (Lerfu),
	lojbanSubek :: Result LojbanDerivs (LogJboConnective),
	lojbanSubgihek :: Result LojbanDerivs (LogJboConnective),
	lojbanSubjek :: Result LojbanDerivs (LogJboConnective)}

data LojbanDerivs4 = LojbanDerivs4 {
	lojbanSubjoik :: Result LojbanDerivs (String),
	lojbanSubinterval :: Result LojbanDerivs (String),
	lojbanSubgek :: Result LojbanDerivs (Bool -> Connective),
	lojbanSubguhek :: Result LojbanDerivs (Bool -> LogJboConnective),
	lojbanSubStarRule28 :: Result LojbanDerivs ([(Connective, Tag)]),
	lojbanSubPlusRule12 :: Result LojbanDerivs ([DecoratedTagUnit]),
	lojbanSubdecoratedTagUnit :: Result LojbanDerivs (DecoratedTagUnit),
	lojbanSubPlusRule13 :: Result LojbanDerivs ([()]),
	lojbanSubPlusRule14 :: Result LojbanDerivs ([Char]),
	lojbanSubPlusRule15 :: Result LojbanDerivs ([Char]),
	lojbanSubStarRule29 :: Result LojbanDerivs ([Char]),
	lojbanSubStarRule30 :: Result LojbanDerivs ([Char]),
	lojbanSubPlusRule16 :: Result LojbanDerivs ([Char]),
	lojbanSubBU :: Result LojbanDerivs (String),
	lojbanSubGOhA :: Result LojbanDerivs (String),
	lojbanSubKOhA :: Result LojbanDerivs (String),
	lojbanSubPA :: Result LojbanDerivs (String),
	lojbanSubUI :: Result LojbanDerivs (String)}

lojbanStarRule0 = lojbanSubStarRule0 . lojbanSub0
lojbanfree = lojbanSubfree . lojbanSub0
lojbanStarRule1 = lojbanSubStarRule1 . lojbanSub0
lojbanPlusRule1 = lojbanSubPlusRule1 . lojbanSub0
lojbancoi = lojbanSubcoi . lojbanSub0
lojbanindicator = lojbanSubindicator . lojbanSub0
lojbanStarRule3 = lojbanSubStarRule3 . lojbanSub0
lojbantext = lojbanSubtext . lojbanSub0
lojbanStarRule4 = lojbanSubStarRule4 . lojbanSub0
lojbantext1 = lojbanSubtext1 . lojbanSub0
lojbanPlusRule4 = lojbanSubPlusRule4 . lojbanSub0
lojbanparagraphs = lojbanSubparagraphs . lojbanSub0
lojbanStarRule5 = lojbanSubStarRule5 . lojbanSub0
lojbanstatementOrFragment = lojbanSubstatementOrFragment . lojbanSub0
lojbanstatement = lojbanSubstatement . lojbanSub0
lojbanStarRule9 = lojbanSubStarRule9 . lojbanSub0
lojbanstatement2 = lojbanSubstatement2 . lojbanSub0
lojbantermsAndTail = lojbanSubtermsAndTail . lojbanSub0
lojbansubsentence = lojbanSubsubsentence . lojbanSub0
lojbanbridiTail = lojbanSubbridiTail . lojbanSub1
lojbanStarRule13 = lojbanSubStarRule13 . lojbanSub1
lojbanbridiTail2 = lojbanSubbridiTail2 . lojbanSub1
lojbangekSentence = lojbanSubgekSentence . lojbanSub1
lojbanStarRule14 = lojbanSubStarRule14 . lojbanSub1
lojbanPlusRule5 = lojbanSubPlusRule5 . lojbanSub1
lojbanterms1 = lojbanSubterms1 . lojbanSub1
lojbanPlusRule6 = lojbanSubPlusRule6 . lojbanSub1
lojbanterm = lojbanSubterm . lojbanSub1
lojbantermsGikTerms = lojbanSubtermsGikTerms . lojbanSub1
lojbansumti = lojbanSubsumti . lojbanSub1
lojbanStarRule15 = lojbanSubStarRule15 . lojbanSub1
lojbansumti3 = lojbanSubsumti3 . lojbanSub1
lojbansumti4 = lojbanSubsumti4 . lojbanSub1
lojbansumti6 = lojbanSubsumti6 . lojbanSub1
lojbanqualifier = lojbanSubqualifier . lojbanSub1
lojbanPlusRule7 = lojbanSubPlusRule7 . lojbanSub1
lojbanStarRule17 = lojbanSubStarRule17 . lojbanSub1
lojbanStarRule18 = lojbanSubStarRule18 . lojbanSub2
lojbanStarRule19 = lojbanSubStarRule19 . lojbanSub2
lojbansumtiTail1 = lojbanSubsumtiTail1 . lojbanSub2
lojbanStarRule20 = lojbanSubStarRule20 . lojbanSub2
lojbanrelativeClause = lojbanSubrelativeClause . lojbanSub2
lojbanselbri1 = lojbanSubselbri1 . lojbanSub2
lojbanselbri2 = lojbanSubselbri2 . lojbanSub2
lojbanselbri3Tail = lojbanSubselbri3Tail . lojbanSub2
lojbanStarRule21 = lojbanSubStarRule21 . lojbanSub2
lojbanselbri5 = lojbanSubselbri5 . lojbanSub2
lojbanselbri6 = lojbanSubselbri6 . lojbanSub2
lojbantanruUnitTail = lojbanSubtanruUnitTail . lojbanSub2
lojbanStarRule22 = lojbanSubStarRule22 . lojbanSub2
lojbanPlusRule8 = lojbanSubPlusRule8 . lojbanSub2
lojbantanruUnit2 = lojbanSubtanruUnit2 . lojbanSub2
lojbanabstractor = lojbanSubabstractor . lojbanSub2
lojbanlinks = lojbanSublinks . lojbanSub2
lojbanStarRule23 = lojbanSubStarRule23 . lojbanSub2
lojbanmex1 = lojbanSubmex1 . lojbanSub2
lojbanmex2 = lojbanSubmex2 . lojbanSub3
lojbanrpExpressionTail = lojbanSubrpExpressionTail . lojbanSub3
lojbanStarRule24 = lojbanSubStarRule24 . lojbanSub3
lojbanoperator1 = lojbanSuboperator1 . lojbanSub3
lojbanoperator2 = lojbanSuboperator2 . lojbanSub3
lojbanmexOperator = lojbanSubmexOperator . lojbanSub3
lojbanoperand = lojbanSuboperand . lojbanSub3
lojbanStarRule25 = lojbanSubStarRule25 . lojbanSub3
lojbanoperand2 = lojbanSuboperand2 . lojbanSub3
lojbanPlusRule10 = lojbanSubPlusRule10 . lojbanSub3
lojbanoperand3 = lojbanSuboperand3 . lojbanSub3
lojbanStarRule26 = lojbanSubStarRule26 . lojbanSub3
lojbanPlusRule11 = lojbanSubPlusRule11 . lojbanSub3
lojbanStarRule27 = lojbanSubStarRule27 . lojbanSub3
lojbanlerfuWord = lojbanSublerfuWord . lojbanSub3
lojbanek = lojbanSubek . lojbanSub3
lojbangihek = lojbanSubgihek . lojbanSub3
lojbanjek = lojbanSubjek . lojbanSub3
lojbanjoik = lojbanSubjoik . lojbanSub4
lojbaninterval = lojbanSubinterval . lojbanSub4
lojbangek = lojbanSubgek . lojbanSub4
lojbanguhek = lojbanSubguhek . lojbanSub4
lojbanStarRule28 = lojbanSubStarRule28 . lojbanSub4
lojbanPlusRule12 = lojbanSubPlusRule12 . lojbanSub4
lojbandecoratedTagUnit = lojbanSubdecoratedTagUnit . lojbanSub4
lojbanPlusRule13 = lojbanSubPlusRule13 . lojbanSub4
lojbanPlusRule14 = lojbanSubPlusRule14 . lojbanSub4
lojbanPlusRule15 = lojbanSubPlusRule15 . lojbanSub4
lojbanStarRule29 = lojbanSubStarRule29 . lojbanSub4
lojbanStarRule30 = lojbanSubStarRule30 . lojbanSub4
lojbanPlusRule16 = lojbanSubPlusRule16 . lojbanSub4
lojbanBU = lojbanSubBU . lojbanSub4
lojbanGOhA = lojbanSubGOhA . lojbanSub4
lojbanKOhA = lojbanSubKOhA . lojbanSub4
lojbanPA = lojbanSubPA . lojbanSub4
lojbanUI = lojbanSubUI . lojbanSub4

lojbanParse :: String -> String -> LojbanDerivs
lojbanParse name text = lojbanDerivs (Pos name 1 1) text

lojbanDerivs :: Pos -> String -> LojbanDerivs
lojbanDerivs pos text = dvs where
  dvs = LojbanDerivs
    (lojbanDerivs0 dvs)
    (lojbanDerivs1 dvs)
    (lojbanDerivs2 dvs)
    (lojbanDerivs3 dvs)
    (lojbanDerivs4 dvs)
    chr pos
  chr = case text of
    [] -> NoParse (msgError (lojbanPos dvs) "end of input")
    (c:cs) -> Parsed c (lojbanDerivs (nextPos pos c) cs) (ParseError pos [])

lojbanDerivs0 dvs = LojbanDerivs0
	(lojbanParseStarRule0 dvs)
	(lojbanParsefree dvs)
	(lojbanParseStarRule1 dvs)
	(lojbanParsePlusRule1 dvs)
	(lojbanParsecoi dvs)
	(lojbanParseindicator dvs)
	(lojbanParseStarRule3 dvs)
	(lojbanParsetext dvs)
	(lojbanParseStarRule4 dvs)
	(lojbanParsetext1 dvs)
	(lojbanParsePlusRule4 dvs)
	(lojbanParseparagraphs dvs)
	(lojbanParseStarRule5 dvs)
	(lojbanParsestatementOrFragment dvs)
	(lojbanParsestatement dvs)
	(lojbanParseStarRule9 dvs)
	(lojbanParsestatement2 dvs)
	(lojbanParsetermsAndTail dvs)
	(lojbanParsesubsentence dvs)

lojbanDerivs1 dvs = LojbanDerivs1
	(lojbanParsebridiTail dvs)
	(lojbanParseStarRule13 dvs)
	(lojbanParsebridiTail2 dvs)
	(lojbanParsegekSentence dvs)
	(lojbanParseStarRule14 dvs)
	(lojbanParsePlusRule5 dvs)
	(lojbanParseterms1 dvs)
	(lojbanParsePlusRule6 dvs)
	(lojbanParseterm dvs)
	(lojbanParsetermsGikTerms dvs)
	(lojbanParsesumti dvs)
	(lojbanParseStarRule15 dvs)
	(lojbanParsesumti3 dvs)
	(lojbanParsesumti4 dvs)
	(lojbanParsesumti6 dvs)
	(lojbanParsequalifier dvs)
	(lojbanParsePlusRule7 dvs)
	(lojbanParseStarRule17 dvs)

lojbanDerivs2 dvs = LojbanDerivs2
	(lojbanParseStarRule18 dvs)
	(lojbanParseStarRule19 dvs)
	(lojbanParsesumtiTail1 dvs)
	(lojbanParseStarRule20 dvs)
	(lojbanParserelativeClause dvs)
	(lojbanParseselbri1 dvs)
	(lojbanParseselbri2 dvs)
	(lojbanParseselbri3Tail dvs)
	(lojbanParseStarRule21 dvs)
	(lojbanParseselbri5 dvs)
	(lojbanParseselbri6 dvs)
	(lojbanParsetanruUnitTail dvs)
	(lojbanParseStarRule22 dvs)
	(lojbanParsePlusRule8 dvs)
	(lojbanParsetanruUnit2 dvs)
	(lojbanParseabstractor dvs)
	(lojbanParselinks dvs)
	(lojbanParseStarRule23 dvs)
	(lojbanParsemex1 dvs)

lojbanDerivs3 dvs = LojbanDerivs3
	(lojbanParsemex2 dvs)
	(lojbanParserpExpressionTail dvs)
	(lojbanParseStarRule24 dvs)
	(lojbanParseoperator1 dvs)
	(lojbanParseoperator2 dvs)
	(lojbanParsemexOperator dvs)
	(lojbanParseoperand dvs)
	(lojbanParseStarRule25 dvs)
	(lojbanParseoperand2 dvs)
	(lojbanParsePlusRule10 dvs)
	(lojbanParseoperand3 dvs)
	(lojbanParseStarRule26 dvs)
	(lojbanParsePlusRule11 dvs)
	(lojbanParseStarRule27 dvs)
	(lojbanParselerfuWord dvs)
	(lojbanParseek dvs)
	(lojbanParsegihek dvs)
	(lojbanParsejek dvs)

lojbanDerivs4 dvs = LojbanDerivs4
	(lojbanParsejoik dvs)
	(lojbanParseinterval dvs)
	(lojbanParsegek dvs)
	(lojbanParseguhek dvs)
	(lojbanParseStarRule28 dvs)
	(lojbanParsePlusRule12 dvs)
	(lojbanParsedecoratedTagUnit dvs)
	(lojbanParsePlusRule13 dvs)
	(lojbanParsePlusRule14 dvs)
	(lojbanParsePlusRule15 dvs)
	(lojbanParseStarRule29 dvs)
	(lojbanParseStarRule30 dvs)
	(lojbanParsePlusRule16 dvs)
	(lojbanParseBU dvs)
	(lojbanParseGOhA dvs)
	(lojbanParseKOhA dvs)
	(lojbanParsePA dvs)
	(lojbanParseUI dvs)


lojbanwholeStatement :: LojbanDerivs -> Result LojbanDerivs (Statement)
lojbanwholeStatement d =
  case lojbanstatement d of
    Parsed s pappyDvs1 pappyErr1 ->
      case pappyResult3 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          pappyAlt5_1 (ParseError (lojbanPos pappyDvs1) []) where
            pappyAlt5_1 pappyErr5 =
              case lojbanPlusRule4 pappyDvs1 of
                Parsed _ pappyDvs7 pappyErr7 ->
                  Parsed (
                    ()) pappyDvs7 (max pappyErr7 pappyErr5)
                NoParse pappyErr7 -> pappyAlt5_2 (max pappyErr7 pappyErr5)
            pappyAlt5_2 pappyErr5 =
              case lojbanI pappyDvs1 of
                Parsed _ pappyDvs7 pappyErr7 ->
                  Parsed (
                    ()) pappyDvs7 (max pappyErr7 pappyErr5)
                NoParse pappyErr7 -> pappyAlt5_3 (max pappyErr7 pappyErr5)
            pappyAlt5_3 pappyErr5 =
              case lojbanChar pappyDvs1 of
                NoParse pappyErr7 ->
                  Parsed (
                    ()) pappyDvs1 (max pappyErr7 pappyErr5)
                Parsed _ _ pappyErr7 -> pappyAlt5_4 (max pappyErr7 pappyErr5)
            pappyAlt5_4 pappyErr5 = NoParse pappyErr5
    NoParse pappyErr1 -> NoParse pappyErr1

lojbanParseStarRule0 :: LojbanDerivs -> Result LojbanDerivs ([String])
lojbanParseStarRule0 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case pappyResult3 of
        Parsed v pappyDvs3 pappyErr3 ->
          case lojbanStarRule0 pappyDvs3 of
            Parsed vs pappyDvs5 pappyErr5 ->
              Parsed (
                v : vs) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          pappyAlt5_1 (ParseError (lojbanPos d) []) where
            pappyAlt5_1 pappyErr5 =
              case lojbanI d of
                Parsed i pappyDvs7 pappyErr7 ->
                  case pappyResult9 of
                    Parsed _ pappyDvs9 pappyErr9 ->
                      case pappyResult11 of
                        Parsed _ pappyDvs11 pappyErr11 ->
                          Parsed (i) pappyDvs11 (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5])
                        NoParse pappyErr11 -> pappyAlt5_2 (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5])
                      where
                        pappyResult11 =
                          case lojbanBO pappyDvs9 of
                            Parsed pappyVal13 pappyDvs13 pappyErr13 -> Parsed (Just pappyVal13) pappyDvs13 pappyErr13
                            NoParse pappyErr13 -> Parsed (Nothing) pappyDvs9 pappyErr13
                    NoParse pappyErr9 -> pappyAlt5_2 (maximum [pappyErr9,pappyErr7,pappyErr5])
                  where
                    pappyResult9 =
                      case lojbanjoikJek pappyDvs7 of
                        Parsed pappyVal11 pappyDvs11 pappyErr11 -> Parsed (Just pappyVal11) pappyDvs11 pappyErr11
                        NoParse pappyErr11 -> Parsed (Nothing) pappyDvs7 pappyErr11
                NoParse pappyErr7 -> pappyAlt5_2 (max pappyErr7 pappyErr5)
            pappyAlt5_2 pappyErr5 =
              case lojbanNIhO d of
                Parsed pappyVal7 pappyDvs7 pappyErr7 -> Parsed pappyVal7 pappyDvs7 (max pappyErr7 pappyErr5)
                NoParse pappyErr7 -> pappyAlt5_3 (max pappyErr7 pappyErr5)
            pappyAlt5_3 pappyErr5 = NoParse pappyErr5
    pappyAlt1_2 pappyErr1 =
      Parsed (
        []) d pappyErr1
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbantextHead :: LojbanDerivs -> Result LojbanDerivs (())
lojbantextHead d =
  case lojbanStarRule0 d of
    Parsed _ pappyDvs1 pappyErr1 ->
      Parsed (
        ()) pappyDvs1 pappyErr1
    NoParse pappyErr1 -> NoParse pappyErr1

lojbanterminatedText :: LojbanDerivs -> Result LojbanDerivs (Text)
lojbanterminatedText d =
  case lojbantext d of
    Parsed t pappyDvs1 pappyErr1 ->
      case pappyResult3 of
        Parsed _ pappyDvs3 pappyErr3 ->
          case lojbanChar pappyDvs3 of
            Parsed '%' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '%' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '%' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'E' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed 'N' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed 'D' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed '%' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed '%' pappyDvs19 _ ->
                                          case lojbanChar pappyDvs19 of
                                            Parsed '%' pappyDvs21 _ ->
                                              Parsed (t) pappyDvs21 (max pappyErr3 pappyErr1)
                                            _ -> NoParse (max pappyErr3 pappyErr1)
                                        _ -> NoParse (max pappyErr3 pappyErr1)
                                    _ -> NoParse (max pappyErr3 pappyErr1)
                                _ -> NoParse (max pappyErr3 pappyErr1)
                            _ -> NoParse (max pappyErr3 pappyErr1)
                        _ -> NoParse (max pappyErr3 pappyErr1)
                    _ -> NoParse (max pappyErr3 pappyErr1)
                _ -> NoParse (max pappyErr3 pappyErr1)
            _ -> NoParse (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case pappyResult5 of
            Parsed pappyVal5 pappyDvs5 pappyErr5 -> Parsed (Just pappyVal5) pappyDvs5 pappyErr5
            NoParse pappyErr5 -> Parsed (Nothing) pappyDvs1 pappyErr5
          where
            pappyResult5 =
              case lojbanPlusRule13 pappyDvs1 of
                Parsed _ pappyDvs7 pappyErr7 ->
                  Parsed (
                    ()) pappyDvs7 pappyErr7
                NoParse pappyErr7 -> NoParse pappyErr7
    NoParse pappyErr1 -> NoParse pappyErr1

lojbanParsefree :: LojbanDerivs -> Result LojbanDerivs (Free)
lojbanParsefree d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanSEI d of
        Parsed "sei" pappyDvs3 pappyErr3 ->
          case lojbanBU pappyDvs3 of
            NoParse pappyErr5 ->
              case pappyResult7 of
                Parsed mts pappyDvs7 pappyErr7 ->
                  case lojbanselbri pappyDvs7 of
                    Parsed sb pappyDvs9 pappyErr9 ->
                      case pappyResult11 of
                        Parsed _ pappyDvs11 pappyErr11 ->
                          Parsed (
                            Discursive $ BridiTail3 sb $ fromMaybe [] mts) pappyDvs11 (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                        NoParse pappyErr11 -> pappyAlt1_2 (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                      where
                        pappyResult11 =
                          case lojbanSEhU pappyDvs9 of
                            Parsed pappyVal13 pappyDvs13 pappyErr13 -> Parsed (Just pappyVal13) pappyDvs13 pappyErr13
                            NoParse pappyErr13 -> Parsed (Nothing) pappyDvs9 pappyErr13
                    NoParse pappyErr9 -> pappyAlt1_2 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_2 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case pappyResult9 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs3 pappyErr9
                  where
                    pappyResult9 =
                      case pappyResult11 of
                        Parsed ts pappyDvs11 pappyErr11 ->
                          case pappyResult13 of
                            Parsed _ pappyDvs13 pappyErr13 ->
                              Parsed (ts) pappyDvs13 (max pappyErr13 pappyErr11)
                            NoParse pappyErr13 -> NoParse (max pappyErr13 pappyErr11)
                          where
                            pappyResult13 =
                              case lojbanCU pappyDvs11 of
                                Parsed pappyVal15 pappyDvs15 pappyErr15 -> Parsed (Just pappyVal15) pappyDvs15 pappyErr15
                                NoParse pappyErr15 -> Parsed (Nothing) pappyDvs11 pappyErr15
                        NoParse pappyErr11 -> NoParse pappyErr11
                      where
                        pappyResult11 =
                          case lojbanPlusRule5 pappyDvs3 of
                            Parsed ts pappyDvs13 pappyErr13 ->
                              Parsed (
                                 ts ) pappyDvs13 pappyErr13
                            NoParse pappyErr13 -> NoParse pappyErr13
            Parsed _ _ pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        _ -> pappyAlt1_2 (max (ParseError (lojbanPos d) [Expected "sei"]) pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbanSEI d of
        Parsed "ti'o" pappyDvs3 pappyErr3 ->
          case lojbanBU pappyDvs3 of
            NoParse pappyErr5 ->
              case pappyResult7 of
                Parsed mts pappyDvs7 pappyErr7 ->
                  case lojbanselbri pappyDvs7 of
                    Parsed sb pappyDvs9 pappyErr9 ->
                      case pappyResult11 of
                        Parsed _ pappyDvs11 pappyErr11 ->
                          Parsed (
                            MexPrecedence $ BridiTail3 sb $ fromMaybe [] mts) pappyDvs11 (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                        NoParse pappyErr11 -> pappyAlt1_3 (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                      where
                        pappyResult11 =
                          case lojbanSEhU pappyDvs9 of
                            Parsed pappyVal13 pappyDvs13 pappyErr13 -> Parsed (Just pappyVal13) pappyDvs13 pappyErr13
                            NoParse pappyErr13 -> Parsed (Nothing) pappyDvs9 pappyErr13
                    NoParse pappyErr9 -> pappyAlt1_3 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_3 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case pappyResult9 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs3 pappyErr9
                  where
                    pappyResult9 =
                      case pappyResult11 of
                        Parsed ts pappyDvs11 pappyErr11 ->
                          case pappyResult13 of
                            Parsed _ pappyDvs13 pappyErr13 ->
                              Parsed (ts) pappyDvs13 (max pappyErr13 pappyErr11)
                            NoParse pappyErr13 -> NoParse (max pappyErr13 pappyErr11)
                          where
                            pappyResult13 =
                              case lojbanCU pappyDvs11 of
                                Parsed pappyVal15 pappyDvs15 pappyErr15 -> Parsed (Just pappyVal15) pappyDvs15 pappyErr15
                                NoParse pappyErr15 -> Parsed (Nothing) pappyDvs11 pappyErr15
                        NoParse pappyErr11 -> NoParse pappyErr11
                      where
                        pappyResult11 =
                          case lojbanPlusRule5 pappyDvs3 of
                            Parsed ts pappyDvs13 pappyErr13 ->
                              Parsed (
                                 ts ) pappyDvs13 pappyErr13
                            NoParse pappyErr13 -> NoParse pappyErr13
            Parsed _ _ pappyErr5 -> pappyAlt1_3 (maximum [pappyErr5,pappyErr3,pappyErr1])
        _ -> pappyAlt1_3 (max (ParseError (lojbanPos d) [Expected "ti'o"]) pappyErr1)
    pappyAlt1_3 pappyErr1 =
      case pappyResult3 of
        Parsed s pappyDvs3 pappyErr3 ->
          case lojbanpostClause pappyDvs3 of
            Parsed _ pappyDvs5 pappyErr5 ->
              case lojbanBU pappyDvs5 of
                NoParse pappyErr7 ->
                  case lojbansumti pappyDvs5 of
                    Parsed s pappyDvs9 pappyErr9 ->
                      case pappyResult11 of
                        Parsed ms pappyDvs11 pappyErr11 ->
                          case pappyResult13 of
                            Parsed _ pappyDvs13 pappyErr13 ->
                              Parsed (
                                 SOI s ms ) pappyDvs13 (maximum [pappyErr13,pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                            NoParse pappyErr13 -> pappyAlt1_4 (maximum [pappyErr13,pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                          where
                            pappyResult13 =
                              case lojbanSEhU pappyDvs11 of
                                Parsed pappyVal15 pappyDvs15 pappyErr15 -> Parsed (Just pappyVal15) pappyDvs15 pappyErr15
                                NoParse pappyErr15 -> Parsed (Nothing) pappyDvs11 pappyErr15
                        NoParse pappyErr11 -> pappyAlt1_4 (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                      where
                        pappyResult11 =
                          case lojbansumti pappyDvs9 of
                            Parsed pappyVal13 pappyDvs13 pappyErr13 -> Parsed (Just pappyVal13) pappyDvs13 pappyErr13
                            NoParse pappyErr13 -> Parsed (Nothing) pappyDvs9 pappyErr13
                    NoParse pappyErr9 -> pappyAlt1_4 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                Parsed _ _ pappyErr7 -> pappyAlt1_4 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_4 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_4 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanChar d of
            Parsed 's' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'o' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'i' pappyDvs9 _ ->
                      Parsed (
                        "soi") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos d) [])
    pappyAlt1_4 pappyErr1 =
      case lojbanvocative d of
        Parsed cs pappyDvs3 pappyErr3 ->
          case lojbanBU pappyDvs3 of
            NoParse pappyErr5 ->
              case lojbanmaybeRelativeClauses pappyDvs3 of
                Parsed rels1 pappyDvs7 pappyErr7 ->
                  case lojbanselbri pappyDvs7 of
                    Parsed sb pappyDvs9 pappyErr9 ->
                      case lojbanmaybeRelativeClauses pappyDvs9 of
                        Parsed rels2 pappyDvs11 pappyErr11 ->
                          case pappyResult13 of
                            Parsed _ pappyDvs13 pappyErr13 ->
                              Parsed (
                                 Vocative cs $ Just (QAtom [] Nothing (rels1++rels2)
                                	    (Description "le" Nothing Nothing (Left sb) [] [])) ) pappyDvs13 (maximum [pappyErr13,pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                            NoParse pappyErr13 -> pappyAlt1_5 (maximum [pappyErr13,pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                          where
                            pappyResult13 =
                              case lojbanDOhU pappyDvs11 of
                                Parsed pappyVal15 pappyDvs15 pappyErr15 -> Parsed (Just pappyVal15) pappyDvs15 pappyErr15
                                NoParse pappyErr15 -> Parsed (Nothing) pappyDvs11 pappyErr15
                        NoParse pappyErr11 -> pappyAlt1_5 (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                    NoParse pappyErr9 -> pappyAlt1_5 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_5 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            Parsed _ _ pappyErr5 -> pappyAlt1_5 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_5 (max pappyErr3 pappyErr1)
    pappyAlt1_5 pappyErr1 =
      case lojbanvocative d of
        Parsed cs pappyDvs3 pappyErr3 ->
          case lojbanBU pappyDvs3 of
            NoParse pappyErr5 ->
              case lojbanname pappyDvs3 of
                Parsed n pappyDvs7 pappyErr7 ->
                  case lojbanmaybeRelativeClauses pappyDvs7 of
                    Parsed rels pappyDvs9 pappyErr9 ->
                      case pappyResult11 of
                        Parsed _ pappyDvs11 pappyErr11 ->
                          Parsed (
                             Vocative cs $ Just (QAtom [] Nothing rels (n "la")) ) pappyDvs11 (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                        NoParse pappyErr11 -> pappyAlt1_6 (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                      where
                        pappyResult11 =
                          case lojbanDOhU pappyDvs9 of
                            Parsed pappyVal13 pappyDvs13 pappyErr13 -> Parsed (Just pappyVal13) pappyDvs13 pappyErr13
                            NoParse pappyErr13 -> Parsed (Nothing) pappyDvs9 pappyErr13
                    NoParse pappyErr9 -> pappyAlt1_6 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_6 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            Parsed _ _ pappyErr5 -> pappyAlt1_6 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_6 (max pappyErr3 pappyErr1)
    pappyAlt1_6 pappyErr1 =
      case lojbanvocative d of
        Parsed cs pappyDvs3 pappyErr3 ->
          case lojbanBU pappyDvs3 of
            NoParse pappyErr5 ->
              case lojbanfree pappyDvs3 of
                NoParse pappyErr7 ->
                  case pappyResult9 of
                    Parsed ms pappyDvs9 pappyErr9 ->
                      case pappyResult11 of
                        Parsed _ pappyDvs11 pappyErr11 ->
                          Parsed (
                             Vocative cs ms ) pappyDvs11 (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                        NoParse pappyErr11 -> pappyAlt1_7 (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                      where
                        pappyResult11 =
                          case lojbanDOhU pappyDvs9 of
                            Parsed pappyVal13 pappyDvs13 pappyErr13 -> Parsed (Just pappyVal13) pappyDvs13 pappyErr13
                            NoParse pappyErr13 -> Parsed (Nothing) pappyDvs9 pappyErr13
                    NoParse pappyErr9 -> pappyAlt1_7 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                  where
                    pappyResult9 =
                      case lojbansumti pappyDvs3 of
                        Parsed pappyVal11 pappyDvs11 pappyErr11 -> Parsed (Just pappyVal11) pappyDvs11 pappyErr11
                        NoParse pappyErr11 -> Parsed (Nothing) pappyDvs3 pappyErr11
                Parsed _ _ pappyErr7 -> pappyAlt1_7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            Parsed _ _ pappyErr5 -> pappyAlt1_7 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_7 (max pappyErr3 pappyErr1)
    pappyAlt1_7 pappyErr1 =
      case lojbannumberOrLerfuString d of
        Parsed q pappyDvs3 pappyErr3 ->
          case pappyResult5 of
            Parsed s pappyDvs5 pappyErr5 ->
              case lojbanpostClause pappyDvs5 of
                Parsed _ pappyDvs7 pappyErr7 ->
                  Parsed (
                     MAI q ) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_8 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_8 (maximum [pappyErr5,pappyErr3,pappyErr1])
          where
            pappyResult5 =
              case lojbanChar pappyDvs3 of
                Parsed 'm' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'o' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed '\'' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed 'o' pappyDvs13 _ ->
                              Parsed (
                                "mo'o") pappyDvs13 (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'a' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'i' pappyDvs11 _ ->
                          Parsed (
                            "mai") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        NoParse pappyErr3 -> pappyAlt1_8 (max pappyErr3 pappyErr1)
    pappyAlt1_8 pappyErr1 =
      case pappyResult3 of
        Parsed s pappyDvs3 pappyErr3 ->
          case lojbanpostClause pappyDvs3 of
            Parsed _ pappyDvs5 pappyErr5 ->
              case lojbanBU pappyDvs5 of
                NoParse pappyErr7 ->
                  case lojbantext pappyDvs5 of
                    Parsed t pappyDvs9 pappyErr9 ->
                      case pappyResult11 of
                        Parsed _ pappyDvs11 pappyErr11 ->
                          Parsed (
                            Bracketed t) pappyDvs11 (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                        NoParse pappyErr11 -> pappyAlt1_9 (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                      where
                        pappyResult11 =
                          case pappyResult13 of
                            Parsed pappyVal13 pappyDvs13 pappyErr13 -> Parsed (Just pappyVal13) pappyDvs13 pappyErr13
                            NoParse pappyErr13 -> Parsed (Nothing) pappyDvs9 pappyErr13
                          where
                            pappyResult13 =
                              case pappyResult15 of
                                Parsed s pappyDvs15 pappyErr15 ->
                                  case lojbanpostClause pappyDvs15 of
                                    Parsed _ pappyDvs17 pappyErr17 ->
                                      Parsed (s) pappyDvs17 (max pappyErr17 pappyErr15)
                                    NoParse pappyErr17 -> NoParse (max pappyErr17 pappyErr15)
                                NoParse pappyErr15 -> NoParse pappyErr15
                              where
                                pappyResult15 =
                                  case lojbanChar pappyDvs9 of
                                    Parsed 't' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed 'o' pappyDvs19 _ ->
                                          case lojbanChar pappyDvs19 of
                                            Parsed 'i' pappyDvs21 _ ->
                                              Parsed (
                                                "toi") pappyDvs21 (ParseError (lojbanPos pappyDvs21) [])
                                            _ -> NoParse (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    NoParse pappyErr9 -> pappyAlt1_9 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                Parsed _ _ pappyErr7 -> pappyAlt1_9 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_9 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_9 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanChar d of
            Parsed 't' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'o' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'i' pappyDvs11 _ ->
                          Parsed (
                            "to'i") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ ->
                      Parsed (
                        "to") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos d) [])
    pappyAlt1_9 pappyErr1 =
      case pappyResult3 of
        Parsed q pappyDvs3 pappyErr3 ->
          Parsed (
            XI q) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_10 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          pappyAlt5_1 (ParseError (lojbanPos d) []) where
            pappyAlt5_1 pappyErr5 =
              case lojbanXI d of
                Parsed _ pappyDvs7 pappyErr7 ->
                  case lojbanBU pappyDvs7 of
                    NoParse pappyErr9 ->
                      case lojbannumberOrLerfuString pappyDvs7 of
                        Parsed q pappyDvs11 pappyErr11 ->
                          case pappyResult13 of
                            Parsed _ pappyDvs13 pappyErr13 ->
                              Parsed (q) pappyDvs13 (maximum [pappyErr13,pappyErr11,pappyErr9,pappyErr7,pappyErr5])
                            NoParse pappyErr13 -> pappyAlt5_2 (maximum [pappyErr13,pappyErr11,pappyErr9,pappyErr7,pappyErr5])
                          where
                            pappyResult13 =
                              case lojbanBOI pappyDvs11 of
                                Parsed pappyVal15 pappyDvs15 pappyErr15 -> Parsed (Just pappyVal15) pappyDvs15 pappyErr15
                                NoParse pappyErr15 -> Parsed (Nothing) pappyDvs11 pappyErr15
                        NoParse pappyErr11 -> pappyAlt5_2 (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5])
                    Parsed _ _ pappyErr9 -> pappyAlt5_2 (maximum [pappyErr9,pappyErr7,pappyErr5])
                NoParse pappyErr7 -> pappyAlt5_2 (max pappyErr7 pappyErr5)
            pappyAlt5_2 pappyErr5 =
              case lojbanXI d of
                Parsed _ pappyDvs7 pappyErr7 ->
                  case lojbanBU pappyDvs7 of
                    NoParse pappyErr9 ->
                      case lojbanVEI pappyDvs7 of
                        Parsed _ pappyDvs11 pappyErr11 ->
                          case lojbanmex pappyDvs11 of
                            Parsed q pappyDvs13 pappyErr13 ->
                              case pappyResult15 of
                                Parsed _ pappyDvs15 pappyErr15 ->
                                  Parsed (q) pappyDvs15 (maximum [pappyErr15,pappyErr13,pappyErr11,pappyErr9,pappyErr7,pappyErr5])
                                NoParse pappyErr15 -> pappyAlt5_3 (maximum [pappyErr15,pappyErr13,pappyErr11,pappyErr9,pappyErr7,pappyErr5])
                              where
                                pappyResult15 =
                                  case lojbanVEhO pappyDvs13 of
                                    Parsed pappyVal17 pappyDvs17 pappyErr17 -> Parsed (Just pappyVal17) pappyDvs17 pappyErr17
                                    NoParse pappyErr17 -> Parsed (Nothing) pappyDvs13 pappyErr17
                            NoParse pappyErr13 -> pappyAlt5_3 (maximum [pappyErr13,pappyErr11,pappyErr9,pappyErr7,pappyErr5])
                        NoParse pappyErr11 -> pappyAlt5_3 (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5])
                    Parsed _ _ pappyErr9 -> pappyAlt5_3 (maximum [pappyErr9,pappyErr7,pappyErr5])
                NoParse pappyErr7 -> pappyAlt5_3 (max pappyErr7 pappyErr5)
            pappyAlt5_3 pappyErr5 = NoParse pappyErr5
    pappyAlt1_10 pappyErr1 =
      case pappyResult3 of
        Parsed _ pappyDvs3 pappyErr3 ->
          case lojbanindicator pappyDvs3 of
            Parsed i pappyDvs5 pappyErr5 ->
              Parsed (i) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_11 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_11 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case pappyResult5 of
            Parsed pappyVal5 pappyDvs5 pappyErr5 -> Parsed (Just pappyVal5) pappyDvs5 pappyErr5
            NoParse pappyErr5 -> Parsed (Nothing) d pappyErr5
          where
            pappyResult5 =
              case pappyResult7 of
                Parsed s pappyDvs7 pappyErr7 ->
                  case lojbanpostClause pappyDvs7 of
                    Parsed _ pappyDvs9 pappyErr9 ->
                      Parsed (s) pappyDvs9 (max pappyErr9 pappyErr7)
                    NoParse pappyErr9 -> NoParse (max pappyErr9 pappyErr7)
                NoParse pappyErr7 -> NoParse pappyErr7
              where
                pappyResult7 =
                  case lojbanChar d of
                    Parsed 'f' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'u' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed '\'' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed 'e' pappyDvs15 _ ->
                                  Parsed (
                                    "fu'e") pappyDvs15 (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos d) [])
    pappyAlt1_11 pappyErr1 =
      case pappyResult3 of
        Parsed s pappyDvs3 pappyErr3 ->
          case lojbanpostClause pappyDvs3 of
            Parsed _ pappyDvs5 pappyErr5 ->
              Parsed (
                NullFree) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_12 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_12 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanChar d of
            Parsed 'b' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'a' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'e' pappyDvs11 _ ->
                          Parsed (
                            "ba'e") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'z' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'a' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'e' pappyDvs11 _ ->
                          Parsed (
                            "za'e") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos d) [])
    pappyAlt1_12 pappyErr1 =
      case pappyResult3 of
        Parsed s pappyDvs3 pappyErr3 ->
          case lojbanpostClause pappyDvs3 of
            Parsed _ pappyDvs5 pappyErr5 ->
              case lojbanBU pappyDvs5 of
                NoParse pappyErr7 ->
                  Parsed (
                    NullFree) pappyDvs5 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                Parsed _ _ pappyErr7 -> pappyAlt1_13 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_13 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_13 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanChar d of
            Parsed 'y' pappyDvs5 _ ->
              Parsed (
                "y") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos d) [])
    pappyAlt1_13 pappyErr1 = NoParse pappyErr1

lojbanParseStarRule1 :: LojbanDerivs -> Result LojbanDerivs ([COI])
lojbanParseStarRule1 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbancoi d of
        Parsed v pappyDvs3 pappyErr3 ->
          case lojbanStarRule1 pappyDvs3 of
            Parsed vs pappyDvs5 pappyErr5 ->
              Parsed (
                v : vs) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      Parsed (
        []) d pappyErr1
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanParsePlusRule1 :: LojbanDerivs -> Result LojbanDerivs ([COI])
lojbanParsePlusRule1 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbancoi d of
        Parsed v pappyDvs3 pappyErr3 ->
          case lojbanPlusRule1 pappyDvs3 of
            Parsed vs pappyDvs5 pappyErr5 ->
              Parsed (
                v : vs) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbancoi d of
        Parsed v pappyDvs3 pappyErr3 ->
          Parsed (
            [v]) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanvocative :: LojbanDerivs -> Result LojbanDerivs ([COI])
lojbanvocative d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanStarRule1 d of
        Parsed cs pappyDvs3 pappyErr3 ->
          case pappyResult5 of
            Parsed s pappyDvs5 pappyErr5 ->
              case lojbanpostClause pappyDvs5 of
                Parsed _ pappyDvs7 pappyErr7 ->
                  Parsed (cs) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_2 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
          where
            pappyResult5 =
              case lojbanChar pappyDvs3 of
                Parsed 'd' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'o' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'i' pappyDvs11 _ ->
                          Parsed (
                            "doi") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbanPlusRule1 d of
        Parsed pappyVal3 pappyDvs3 pappyErr3 -> Parsed pappyVal3 pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanParsecoi :: LojbanDerivs -> Result LojbanDerivs (COI)
lojbanParsecoi d =
  case pappyResult1 of
    Parsed c pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          case pappyResult5 of
            Parsed mn pappyDvs5 pappyErr5 ->
              Parsed (
                COI c $ isJust mn) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> NoParse (maximum [pappyErr5,pappyErr3,pappyErr1])
          where
            pappyResult5 =
              case lojbanNAI pappyDvs3 of
                Parsed pappyVal7 pappyDvs7 pappyErr7 -> Parsed (Just pappyVal7) pappyDvs7 pappyErr7
                NoParse pappyErr7 -> Parsed (Nothing) pappyDvs3 pappyErr7
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'j' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'u' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'i' pappyDvs9 _ ->
                      Parsed (
                        "ju'i") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'e' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'e' pappyDvs9 _ ->
                      Parsed (
                        "je'e") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'c' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'o' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'i' pappyDvs7 _ ->
                  Parsed (
                    "coi") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'o' pappyDvs9 _ ->
                      Parsed (
                        "co'o") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'f' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'i' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'i' pappyDvs9 _ ->
                      Parsed (
                        "fi'i") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'e' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'o' pappyDvs9 _ ->
                      Parsed (
                        "fe'o") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 't' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'a' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'a' pappyDvs9 _ ->
                      Parsed (
                        "ta'a") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'm' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'u' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'o' pappyDvs9 _ ->
                      Parsed (
                        "mu'o") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'i' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'e' pappyDvs9 _ ->
                      Parsed (
                        "mi'e") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'p' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'e' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "pe'u") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'k' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'e' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'o' pappyDvs9 _ ->
                      Parsed (
                        "ke'o") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'i' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'e' pappyDvs9 _ ->
                      Parsed (
                        "ki'e") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'n' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'u' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'e' pappyDvs9 _ ->
                      Parsed (
                        "nu'e") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'r' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'e' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'i' pappyDvs9 _ ->
                      Parsed (
                        "re'i") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'b' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'e' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'e' pappyDvs9 _ ->
                      Parsed (
                        "be'e") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'v' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'i' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'o' pappyDvs9 _ ->
                      Parsed (
                        "vi'o") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanParseindicator :: LojbanDerivs -> Result LojbanDerivs (Free)
lojbanParseindicator d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanUI d of
        Parsed "xu" pappyDvs3 pappyErr3 ->
          case lojbanBU pappyDvs3 of
            NoParse pappyErr5 ->
              case pappyResult7 of
                Parsed k pappyDvs7 pappyErr7 ->
                  Parsed (
                    TruthQ k) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_2 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case pappyResult9 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs3 pappyErr9
                  where
                    pappyResult9 =
                      case lojbanUI pappyDvs3 of
                        Parsed "kau" pappyDvs11 pappyErr11 ->
                          case lojbanBU pappyDvs11 of
                            NoParse pappyErr13 ->
                              case pappyResult15 of
                                Parsed x pappyDvs15 pappyErr15 ->
                                  Parsed (
                                    fromMaybe 1 x) pappyDvs15 (maximum [pappyErr15,pappyErr13,pappyErr11])
                                NoParse pappyErr15 -> NoParse (maximum [pappyErr15,pappyErr13,pappyErr11])
                              where
                                pappyResult15 =
                                  case lojbanxiLit pappyDvs11 of
                                    Parsed pappyVal17 pappyDvs17 pappyErr17 -> Parsed (Just pappyVal17) pappyDvs17 pappyErr17
                                    NoParse pappyErr17 -> Parsed (Nothing) pappyDvs11 pappyErr17
                            Parsed _ _ pappyErr13 -> NoParse (max pappyErr13 pappyErr11)
                        _ -> NoParse (ParseError (lojbanPos pappyDvs3) [Expected "kau"])
            Parsed _ _ pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        _ -> pappyAlt1_2 (max (ParseError (lojbanPos d) [Expected "xu"]) pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case pappyResult3 of
        Parsed c pappyDvs3 pappyErr3 ->
          case pappyResult5 of
            Parsed nai pappyDvs5 pappyErr5 ->
              case lojbanBU pappyDvs5 of
                NoParse pappyErr7 ->
                  Parsed (
                     Indicator (isJust nai) c ) pappyDvs5 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                Parsed _ _ pappyErr7 -> pappyAlt1_3 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_3 (maximum [pappyErr5,pappyErr3,pappyErr1])
          where
            pappyResult5 =
              case lojbanNAI pappyDvs3 of
                Parsed pappyVal7 pappyDvs7 pappyErr7 -> Parsed (Just pappyVal7) pappyDvs7 pappyErr7
                NoParse pappyErr7 -> Parsed (Nothing) pappyDvs3 pappyErr7
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          pappyAlt5_1 (ParseError (lojbanPos d) []) where
            pappyAlt5_1 pappyErr5 =
              case lojbanUI d of
                Parsed pappyVal7 pappyDvs7 pappyErr7 -> Parsed pappyVal7 pappyDvs7 (max pappyErr7 pappyErr5)
                NoParse pappyErr7 -> pappyAlt5_2 (max pappyErr7 pappyErr5)
            pappyAlt5_2 pappyErr5 =
              case pappyResult7 of
                Parsed s pappyDvs7 pappyErr7 ->
                  case lojbanpostClause pappyDvs7 of
                    Parsed _ pappyDvs9 pappyErr9 ->
                      Parsed (s) pappyDvs9 (maximum [pappyErr9,pappyErr7,pappyErr5])
                    NoParse pappyErr9 -> pappyAlt5_3 (maximum [pappyErr9,pappyErr7,pappyErr5])
                NoParse pappyErr7 -> pappyAlt5_3 (max pappyErr7 pappyErr5)
              where
                pappyResult7 =
                  case lojbanChar d of
                    Parsed 'p' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'e' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed 'i' pappyDvs13 _ ->
                              Parsed (
                                "pei") pappyDvs13 (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'c' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'a' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed 'i' pappyDvs13 _ ->
                              Parsed (
                                "cai") pappyDvs13 (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        Parsed 'u' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed '\'' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed 'i' pappyDvs15 _ ->
                                  Parsed (
                                    "cu'i") pappyDvs15 (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 's' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'a' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed 'i' pappyDvs13 _ ->
                              Parsed (
                                "sai") pappyDvs13 (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'r' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'u' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed '\'' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed 'e' pappyDvs15 _ ->
                                  Parsed (
                                    "ru'e") pappyDvs15 (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos d) [])
            pappyAlt5_3 pappyErr5 = NoParse pappyErr5
    pappyAlt1_3 pappyErr1 =
      case pappyResult3 of
        Parsed c pappyDvs3 pappyErr3 ->
          case lojbanBU pappyDvs3 of
            NoParse pappyErr5 ->
              Parsed (
                 Indicator False c ) pappyDvs3 (maximum [pappyErr5,pappyErr3,pappyErr1])
            Parsed _ _ pappyErr5 -> pappyAlt1_4 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_4 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          pappyAlt5_1 (ParseError (lojbanPos d) []) where
            pappyAlt5_1 pappyErr5 =
              case pappyResult7 of
                Parsed s pappyDvs7 pappyErr7 ->
                  case lojbanpostClause pappyDvs7 of
                    Parsed _ pappyDvs9 pappyErr9 ->
                      Parsed (s) pappyDvs9 (maximum [pappyErr9,pappyErr7,pappyErr5])
                    NoParse pappyErr9 -> pappyAlt5_2 (maximum [pappyErr9,pappyErr7,pappyErr5])
                NoParse pappyErr7 -> pappyAlt5_2 (max pappyErr7 pappyErr5)
              where
                pappyResult7 =
                  case lojbanChar d of
                    Parsed 'd' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'a' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed '\'' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed 'o' pappyDvs15 _ ->
                                  Parsed (
                                    "da'o") pappyDvs15 (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos d) [])
            pappyAlt5_2 pappyErr5 =
              case pappyResult7 of
                Parsed s pappyDvs7 pappyErr7 ->
                  case lojbanpostClause pappyDvs7 of
                    Parsed _ pappyDvs9 pappyErr9 ->
                      Parsed (s) pappyDvs9 (maximum [pappyErr9,pappyErr7,pappyErr5])
                    NoParse pappyErr9 -> pappyAlt5_3 (maximum [pappyErr9,pappyErr7,pappyErr5])
                NoParse pappyErr7 -> pappyAlt5_3 (max pappyErr7 pappyErr5)
              where
                pappyResult7 =
                  case lojbanChar d of
                    Parsed 'f' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'u' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed '\'' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed 'o' pappyDvs15 _ ->
                                  Parsed (
                                    "fu'o") pappyDvs15 (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos d) [])
            pappyAlt5_3 pappyErr5 = NoParse pappyErr5
    pappyAlt1_4 pappyErr1 = NoParse pappyErr1

lojbanParseStarRule3 :: LojbanDerivs -> Result LojbanDerivs ([String])
lojbanParseStarRule3 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanNAI d of
        Parsed v pappyDvs3 pappyErr3 ->
          case lojbanStarRule3 pappyDvs3 of
            Parsed vs pappyDvs5 pappyErr5 ->
              Parsed (
                v : vs) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      Parsed (
        []) d pappyErr1
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanParsetext :: LojbanDerivs -> Result LojbanDerivs (Text)
lojbanParsetext d =
  case lojbanStarRule22 d of
    Parsed fs1 pappyDvs1 pappyErr1 ->
      case lojbanStarRule3 pappyDvs1 of
        Parsed ns pappyDvs3 pappyErr3 ->
          case pappyResult5 of
            Parsed fs2 pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed mjjfrag pappyDvs7 pappyErr7 ->
                  case pappyResult9 of
                    Parsed mps pappyDvs9 pappyErr9 ->
                      case pappyResult11 of
                        Parsed _ pappyDvs11 pappyErr11 ->
                          Parsed (
                            Text (fs1++fs2) (not $ null ns) $
                            	    maybe [] (\jjfrag -> [[Left $ FragCon $ jjJboCon Nothing jjfrag]]) mjjfrag ++
                            	    fromMaybe [] mps) pappyDvs11 (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                        NoParse pappyErr11 -> NoParse (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                      where
                        pappyResult11 =
                          case pappyResult13 of
                            Parsed pappyVal13 pappyDvs13 pappyErr13 -> Parsed (Just pappyVal13) pappyDvs13 pappyErr13
                            NoParse pappyErr13 -> Parsed (Nothing) pappyDvs9 pappyErr13
                          where
                            pappyResult13 =
                              case pappyResult15 of
                                Parsed s pappyDvs15 pappyErr15 ->
                                  case lojbanpostClause pappyDvs15 of
                                    Parsed _ pappyDvs17 pappyErr17 ->
                                      Parsed (s) pappyDvs17 (max pappyErr17 pappyErr15)
                                    NoParse pappyErr17 -> NoParse (max pappyErr17 pappyErr15)
                                NoParse pappyErr15 -> NoParse pappyErr15
                              where
                                pappyResult15 =
                                  case lojbanChar pappyDvs9 of
                                    Parsed 'f' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed 'a' pappyDvs19 _ ->
                                          case lojbanChar pappyDvs19 of
                                            Parsed '\'' pappyDvs21 _ ->
                                              case lojbanChar pappyDvs21 of
                                                Parsed 'o' pappyDvs23 _ ->
                                                  Parsed (
                                                    "fa'o") pappyDvs23 (ParseError (lojbanPos pappyDvs23) [])
                                                _ -> NoParse (ParseError (lojbanPos pappyDvs21) [])
                                            _ -> NoParse (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    NoParse pappyErr9 -> NoParse (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                  where
                    pappyResult9 =
                      case lojbantext1 pappyDvs7 of
                        Parsed pappyVal11 pappyDvs11 pappyErr11 -> Parsed (Just pappyVal11) pappyDvs11 pappyErr11
                        NoParse pappyErr11 -> Parsed (Nothing) pappyDvs7 pappyErr11
                NoParse pappyErr7 -> NoParse (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case pappyResult9 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs5 pappyErr9
                  where
                    pappyResult9 =
                      case lojbantext1 pappyDvs5 of
                        NoParse pappyErr11 ->
                          case lojbanjoikJek pappyDvs5 of
                            Parsed jjfrag pappyDvs13 pappyErr13 ->
                              Parsed (jjfrag) pappyDvs13 (max pappyErr13 pappyErr11)
                            NoParse pappyErr13 -> NoParse (max pappyErr13 pappyErr11)
                        Parsed _ _ pappyErr11 -> NoParse pappyErr11
            NoParse pappyErr5 -> NoParse (maximum [pappyErr5,pappyErr3,pappyErr1])
          where
            pappyResult5 =
              pappyAlt7_1 (ParseError (lojbanPos pappyDvs3) []) where
                pappyAlt7_1 pappyErr7 =
                  case lojbanPlusRule7 pappyDvs3 of
                    Parsed cs pappyDvs9 pappyErr9 ->
                      Parsed (
                         [Vocative [] $ Just $ QAtom [] Nothing [] $ Name "la" [] $ unwords cs] ) pappyDvs9 (max pappyErr9 pappyErr7)
                    NoParse pappyErr9 -> pappyAlt7_2 (max pappyErr9 pappyErr7)
                pappyAlt7_2 pappyErr7 =
                  case lojbanStarRule4 pappyDvs3 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed pappyVal9 pappyDvs9 (max pappyErr9 pappyErr7)
                    NoParse pappyErr9 -> pappyAlt7_3 (max pappyErr9 pappyErr7)
                pappyAlt7_3 pappyErr7 = NoParse pappyErr7
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1

lojbanParseStarRule4 :: LojbanDerivs -> Result LojbanDerivs ([Free])
lojbanParseStarRule4 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanindicator d of
        Parsed v pappyDvs3 pappyErr3 ->
          case lojbanStarRule4 pappyDvs3 of
            Parsed vs pappyDvs5 pappyErr5 ->
              Parsed (
                v : vs) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      Parsed (
        []) d pappyErr1
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanParsetext1 :: LojbanDerivs -> Result LojbanDerivs ([Paragraph])
lojbanParsetext1 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanI d of
        Parsed _ pappyDvs3 pappyErr3 ->
          case pappyResult5 of
            Parsed mjj pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed mmtag pappyDvs7 pappyErr7 ->
                  case pappyResult9 of
                    Parsed mt pappyDvs9 pappyErr9 ->
                      Parsed (
                        if isNothing mt && isNothing mmtag && isJust mjj
                        		then [[Left $ FragCon $ jjJboCon Nothing $ fromJust mjj]]
                        		else fromMaybe [] mt) pappyDvs9 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                    NoParse pappyErr9 -> pappyAlt1_2 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                  where
                    pappyResult9 =
                      case lojbantext1 pappyDvs7 of
                        Parsed pappyVal11 pappyDvs11 pappyErr11 -> Parsed (Just pappyVal11) pappyDvs11 pappyErr11
                        NoParse pappyErr11 -> Parsed (Nothing) pappyDvs7 pappyErr11
                NoParse pappyErr7 -> pappyAlt1_2 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case pappyResult9 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs5 pappyErr9
                  where
                    pappyResult9 =
                      case pappyResult11 of
                        Parsed mtag pappyDvs11 pappyErr11 ->
                          case lojbanBO pappyDvs11 of
                            Parsed _ pappyDvs13 pappyErr13 ->
                              Parsed (mtag) pappyDvs13 (max pappyErr13 pappyErr11)
                            NoParse pappyErr13 -> NoParse (max pappyErr13 pappyErr11)
                        NoParse pappyErr11 -> NoParse pappyErr11
                      where
                        pappyResult11 =
                          case lojbantag pappyDvs5 of
                            Parsed pappyVal13 pappyDvs13 pappyErr13 -> Parsed (Just pappyVal13) pappyDvs13 pappyErr13
                            NoParse pappyErr13 -> Parsed (Nothing) pappyDvs5 pappyErr13
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
          where
            pappyResult5 =
              case lojbanjoikJek pappyDvs3 of
                Parsed pappyVal7 pappyDvs7 pappyErr7 -> Parsed (Just pappyVal7) pappyDvs7 pappyErr7
                NoParse pappyErr7 -> Parsed (Nothing) pappyDvs3 pappyErr7
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbanPlusRule4 d of
        Parsed _ pappyDvs3 pappyErr3 ->
          case pappyResult5 of
            Parsed mps pappyDvs5 pappyErr5 ->
              Parsed (
                fromMaybe [] mps) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_3 (maximum [pappyErr5,pappyErr3,pappyErr1])
          where
            pappyResult5 =
              case lojbanparagraphs pappyDvs3 of
                Parsed pappyVal7 pappyDvs7 pappyErr7 -> Parsed (Just pappyVal7) pappyDvs7 pappyErr7
                NoParse pappyErr7 -> Parsed (Nothing) pappyDvs3 pappyErr7
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 =
      case lojbanparagraphs d of
        Parsed pappyVal3 pappyDvs3 pappyErr3 -> Parsed pappyVal3 pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_4 (max pappyErr3 pappyErr1)
    pappyAlt1_4 pappyErr1 = NoParse pappyErr1

lojbanParsePlusRule4 :: LojbanDerivs -> Result LojbanDerivs ([String])
lojbanParsePlusRule4 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanNIhO d of
        Parsed v pappyDvs3 pappyErr3 ->
          case lojbanPlusRule4 pappyDvs3 of
            Parsed vs pappyDvs5 pappyErr5 ->
              Parsed (
                v : vs) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbanNIhO d of
        Parsed v pappyDvs3 pappyErr3 ->
          Parsed (
            [v]) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanParseparagraphs :: LojbanDerivs -> Result LojbanDerivs ([Paragraph])
lojbanParseparagraphs d =
  case pappyResult1 of
    Parsed p pappyDvs1 pappyErr1 ->
      case pappyResult3 of
        Parsed mps pappyDvs3 pappyErr3 ->
          Parsed (
            p : fromMaybe [] mps) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case pappyResult5 of
            Parsed pappyVal5 pappyDvs5 pappyErr5 -> Parsed (Just pappyVal5) pappyDvs5 pappyErr5
            NoParse pappyErr5 -> Parsed (Nothing) pappyDvs1 pappyErr5
          where
            pappyResult5 =
              case lojbanPlusRule4 pappyDvs1 of
                Parsed _ pappyDvs7 pappyErr7 ->
                  case lojbanparagraphs pappyDvs7 of
                    Parsed ps pappyDvs9 pappyErr9 ->
                      Parsed (ps) pappyDvs9 (max pappyErr9 pappyErr7)
                    NoParse pappyErr9 -> NoParse (max pappyErr9 pappyErr7)
                NoParse pappyErr7 -> NoParse pappyErr7
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanstatementOrFragment d of
        Parsed sf pappyDvs3 pappyErr3 ->
          case lojbanStarRule5 pappyDvs3 of
            Parsed msfs pappyDvs5 pappyErr5 ->
              Parsed (
                (sf:) $ concat $ map maybeToList msfs) pappyDvs5 (max pappyErr5 pappyErr3)
            NoParse pappyErr5 -> NoParse (max pappyErr5 pappyErr3)
        NoParse pappyErr3 -> NoParse pappyErr3

lojbanParseStarRule5 :: LojbanDerivs -> Result LojbanDerivs ([Maybe (Either Fragment Statement)])
lojbanParseStarRule5 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanI d of
        Parsed _ pappyDvs3 pappyErr3 ->
          case lojbanjek pappyDvs3 of
            NoParse pappyErr5 ->
              case lojbanjoik pappyDvs3 of
                NoParse pappyErr7 ->
                  case lojbanjoikJek pappyDvs3 of
                    NoParse pappyErr9 ->
                      case pappyResult11 of
                        Parsed v pappyDvs11 pappyErr11 ->
                          case lojbanStarRule5 pappyDvs11 of
                            Parsed vs pappyDvs13 pappyErr13 ->
                              Parsed (
                                v : vs) pappyDvs13 (maximum [pappyErr13,pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                            NoParse pappyErr13 -> pappyAlt1_2 (maximum [pappyErr13,pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                        NoParse pappyErr11 -> pappyAlt1_2 (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                      where
                        pappyResult11 =
                          case lojbanstatementOrFragment pappyDvs3 of
                            Parsed pappyVal13 pappyDvs13 pappyErr13 -> Parsed (Just pappyVal13) pappyDvs13 pappyErr13
                            NoParse pappyErr13 -> Parsed (Nothing) pappyDvs3 pappyErr13
                    Parsed _ _ pappyErr9 -> pappyAlt1_2 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                Parsed _ _ pappyErr7 -> pappyAlt1_2 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            Parsed _ _ pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      Parsed (
        []) d pappyErr1
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanParsestatementOrFragment :: LojbanDerivs -> Result LojbanDerivs (Either Fragment Statement)
lojbanParsestatementOrFragment d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanstatement d of
        Parsed s pappyDvs3 pappyErr3 ->
          Parsed (
            Right s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbanStarRule22 d of
        Parsed _ pappyDvs3 pappyErr3 ->
          case pappyResult5 of
            Parsed f pappyDvs5 pappyErr5 ->
              Parsed (
                Left f) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_3 (maximum [pappyErr5,pappyErr3,pappyErr1])
          where
            pappyResult5 =
              pappyAlt7_1 (ParseError (lojbanPos pappyDvs3) []) where
                pappyAlt7_1 pappyErr7 =
                  case lojbanprenex pappyDvs3 of
                    Parsed p pappyDvs9 pappyErr9 ->
                      Parsed (
                        FragPrenex p) pappyDvs9 (max pappyErr9 pappyErr7)
                    NoParse pappyErr9 -> pappyAlt7_2 (max pappyErr9 pappyErr7)
                pappyAlt7_2 pappyErr7 =
                  case pappyResult9 of
                    Parsed ts pappyDvs9 pappyErr9 ->
                      case pappyResult11 of
                        Parsed _ pappyDvs11 pappyErr11 ->
                          Parsed (
                            FragTerms ts) pappyDvs11 (maximum [pappyErr11,pappyErr9,pappyErr7])
                        NoParse pappyErr11 -> pappyAlt7_3 (maximum [pappyErr11,pappyErr9,pappyErr7])
                      where
                        pappyResult11 =
                          case lojbanVAU pappyDvs9 of
                            Parsed pappyVal13 pappyDvs13 pappyErr13 -> Parsed (Just pappyVal13) pappyDvs13 pappyErr13
                            NoParse pappyErr13 -> Parsed (Nothing) pappyDvs9 pappyErr13
                    NoParse pappyErr9 -> pappyAlt7_3 (max pappyErr9 pappyErr7)
                  where
                    pappyResult9 =
                      case lojbanPlusRule5 pappyDvs3 of
                        Parsed ts pappyDvs11 pappyErr11 ->
                          Parsed (
                             ts ) pappyDvs11 pappyErr11
                        NoParse pappyErr11 -> NoParse pappyErr11
                pappyAlt7_3 pappyErr7 =
                  case lojbanek pappyDvs3 of
                    Parsed c pappyDvs9 pappyErr9 ->
                      Parsed (
                        FragCon $ jboConnLogOrQ Nothing c) pappyDvs9 (max pappyErr9 pappyErr7)
                    NoParse pappyErr9 -> pappyAlt7_4 (max pappyErr9 pappyErr7)
                pappyAlt7_4 pappyErr7 =
                  case lojbangihek pappyDvs3 of
                    Parsed c pappyDvs9 pappyErr9 ->
                      Parsed (
                        FragCon $ jboConnLogOrQ Nothing c) pappyDvs9 (max pappyErr9 pappyErr7)
                    NoParse pappyErr9 -> pappyAlt7_5 (max pappyErr9 pappyErr7)
                pappyAlt7_5 pappyErr7 =
                  case lojbanquantifier pappyDvs3 of
                    Parsed m pappyDvs9 pappyErr9 ->
                      Parsed (
                        FragQuantifier m) pappyDvs9 (max pappyErr9 pappyErr7)
                    NoParse pappyErr9 -> pappyAlt7_6 (max pappyErr9 pappyErr7)
                pappyAlt7_6 pappyErr7 =
                  case lojbanNA pappyDvs3 of
                    Parsed n pappyDvs9 pappyErr9 ->
                      case lojbanJA pappyDvs9 of
                        NoParse pappyErr11 ->
                          Parsed (
                            FragNA n) pappyDvs9 (maximum [pappyErr11,pappyErr9,pappyErr7])
                        Parsed _ _ pappyErr11 -> pappyAlt7_7 (maximum [pappyErr11,pappyErr9,pappyErr7])
                    NoParse pappyErr9 -> pappyAlt7_7 (max pappyErr9 pappyErr7)
                pappyAlt7_7 pappyErr7 =
                  case lojbanrelativeClauses pappyDvs3 of
                    Parsed rels pappyDvs9 pappyErr9 ->
                      Parsed (
                        FragRels rels) pappyDvs9 (max pappyErr9 pappyErr7)
                    NoParse pappyErr9 -> pappyAlt7_8 (max pappyErr9 pappyErr7)
                pappyAlt7_8 pappyErr7 =
                  case lojbanlinks pappyDvs3 of
                    Parsed ts pappyDvs9 pappyErr9 ->
                      Parsed (
                        FragLinks ts) pappyDvs9 (max pappyErr9 pappyErr7)
                    NoParse pappyErr9 -> pappyAlt7_9 (max pappyErr9 pappyErr7)
                pappyAlt7_9 pappyErr7 =
                  case lojbanlinkargs pappyDvs3 of
                    Parsed ts pappyDvs9 pappyErr9 ->
                      Parsed (
                        FragLinks ts) pappyDvs9 (max pappyErr9 pappyErr7)
                    NoParse pappyErr9 -> pappyAlt7_10 (max pappyErr9 pappyErr7)
                pappyAlt7_10 pappyErr7 = NoParse pappyErr7
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanParsestatement :: LojbanDerivs -> Result LojbanDerivs (Statement)
lojbanParsestatement d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanStarRule22 d of
        Parsed fs pappyDvs3 pappyErr3 ->
          case pappyResult5 of
            Parsed s pappyDvs5 pappyErr5 ->
              Parsed (
                Statement fs [] s) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
          where
            pappyResult5 =
              case lojbanstatement2 pappyDvs3 of
                Parsed s pappyDvs7 pappyErr7 ->
                  case lojbanStarRule9 pappyDvs7 of
                    Parsed jekss pappyDvs9 pappyErr9 ->
                      Parsed (
                         foldl (\s1 -> \(con,s2) -> ConnectedStatement con s1 s2) s jekss ) pappyDvs9 (max pappyErr9 pappyErr7)
                    NoParse pappyErr9 -> NoParse (max pappyErr9 pappyErr7)
                NoParse pappyErr7 -> NoParse pappyErr7
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbanStarRule22 d of
        Parsed fs pappyDvs3 pappyErr3 ->
          case lojbanprenex pappyDvs3 of
            Parsed ps pappyDvs5 pappyErr5 ->
              case lojbanstatement pappyDvs5 of
                Parsed (Statement fs' ps' s) pappyDvs7 pappyErr7 ->
                  Parsed (
                    Statement (fs++fs') (ps++ps') s) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                Parsed _ _ _ -> pappyAlt1_3 (maximum [pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_3 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_3 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanParseStarRule9 :: LojbanDerivs -> Result LojbanDerivs ([(Connective, Statement1)])
lojbanParseStarRule9 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case pappyResult3 of
        Parsed v pappyDvs3 pappyErr3 ->
          case lojbanStarRule9 pappyDvs3 of
            Parsed vs pappyDvs5 pappyErr5 ->
              Parsed (
                v : vs) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanI d of
            Parsed _ pappyDvs5 pappyErr5 ->
              case lojbanjoikJek pappyDvs5 of
                Parsed jj pappyDvs7 pappyErr7 ->
                  case lojbanstatement2 pappyDvs7 of
                    Parsed s pappyDvs9 pappyErr9 ->
                      Parsed (
                        (jjJboCon Nothing jj,s)) pappyDvs9 (maximum [pappyErr9,pappyErr7,pappyErr5])
                    NoParse pappyErr9 -> NoParse (maximum [pappyErr9,pappyErr7,pappyErr5])
                NoParse pappyErr7 -> NoParse (max pappyErr7 pappyErr5)
            NoParse pappyErr5 -> NoParse pappyErr5
    pappyAlt1_2 pappyErr1 =
      Parsed (
        []) d pappyErr1
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanParsestatement2 :: LojbanDerivs -> Result LojbanDerivs (Statement1)
lojbanParsestatement2 d =
  case pappyResult1 of
    Parsed s1 pappyDvs1 pappyErr1 ->
      case pappyResult3 of
        Parsed boSt pappyDvs3 pappyErr3 ->
          Parsed (
             case boSt of
            	    Nothing -> s1
            	    Just (con,s2) -> ConnectedStatement con s1 s2 ) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case pappyResult5 of
            Parsed pappyVal5 pappyDvs5 pappyErr5 -> Parsed (Just pappyVal5) pappyDvs5 pappyErr5
            NoParse pappyErr5 -> Parsed (Nothing) pappyDvs1 pappyErr5
          where
            pappyResult5 =
              case lojbanI pappyDvs1 of
                Parsed _ pappyDvs7 pappyErr7 ->
                  case pappyResult9 of
                    Parsed mjj pappyDvs9 pappyErr9 ->
                      case pappyResult11 of
                        Parsed mtag pappyDvs11 pappyErr11 ->
                          case lojbanBO pappyDvs11 of
                            Parsed _ pappyDvs13 pappyErr13 ->
                              case lojbanstatement2 pappyDvs13 of
                                Parsed s pappyDvs15 pappyErr15 ->
                                  Parsed (
                                    (jjJboCon mtag $ fromMaybe (JJJek $ LogJboConnective True 'e' True) mjj,s)) pappyDvs15 (maximum [pappyErr15,pappyErr13,pappyErr11,pappyErr9,pappyErr7])
                                NoParse pappyErr15 -> NoParse (maximum [pappyErr15,pappyErr13,pappyErr11,pappyErr9,pappyErr7])
                            NoParse pappyErr13 -> NoParse (maximum [pappyErr13,pappyErr11,pappyErr9,pappyErr7])
                        NoParse pappyErr11 -> NoParse (maximum [pappyErr11,pappyErr9,pappyErr7])
                      where
                        pappyResult11 =
                          case lojbantag pappyDvs9 of
                            Parsed pappyVal13 pappyDvs13 pappyErr13 -> Parsed (Just pappyVal13) pappyDvs13 pappyErr13
                            NoParse pappyErr13 -> Parsed (Nothing) pappyDvs9 pappyErr13
                    NoParse pappyErr9 -> NoParse (max pappyErr9 pappyErr7)
                  where
                    pappyResult9 =
                      case lojbanjoikJek pappyDvs7 of
                        Parsed pappyVal11 pappyDvs11 pappyErr11 -> Parsed (Just pappyVal11) pappyDvs11 pappyErr11
                        NoParse pappyErr11 -> Parsed (Nothing) pappyDvs7 pappyErr11
                NoParse pappyErr7 -> NoParse pappyErr7
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      pappyAlt3_1 (ParseError (lojbanPos d) []) where
        pappyAlt3_1 pappyErr3 =
          case lojbanStarRule22 d of
            Parsed fs pappyDvs5 pappyErr5 ->
              case lojbansentence pappyDvs5 of
                Parsed s pappyDvs7 pappyErr7 ->
                  Parsed (
                    StatementSentence fs s) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3])
                NoParse pappyErr7 -> pappyAlt3_2 (maximum [pappyErr7,pappyErr5,pappyErr3])
            NoParse pappyErr5 -> pappyAlt3_2 (max pappyErr5 pappyErr3)
        pappyAlt3_2 pappyErr3 =
          case pappyResult5 of
            Parsed mtag pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed s pappyDvs7 pappyErr7 ->
                  case lojbanpostClause pappyDvs7 of
                    Parsed _ pappyDvs9 pappyErr9 ->
                      case lojbantext1 pappyDvs9 of
                        Parsed ps pappyDvs11 pappyErr11 ->
                          case pappyResult13 of
                            Parsed _ pappyDvs13 pappyErr13 ->
                              Parsed (
                                StatementParas mtag ps) pappyDvs13 (maximum [pappyErr13,pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3])
                            NoParse pappyErr13 -> pappyAlt3_3 (maximum [pappyErr13,pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3])
                          where
                            pappyResult13 =
                              case pappyResult15 of
                                Parsed pappyVal15 pappyDvs15 pappyErr15 -> Parsed (Just pappyVal15) pappyDvs15 pappyErr15
                                NoParse pappyErr15 -> Parsed (Nothing) pappyDvs11 pappyErr15
                              where
                                pappyResult15 =
                                  case pappyResult17 of
                                    Parsed s pappyDvs17 pappyErr17 ->
                                      case lojbanpostClause pappyDvs17 of
                                        Parsed _ pappyDvs19 pappyErr19 ->
                                          Parsed (s) pappyDvs19 (max pappyErr19 pappyErr17)
                                        NoParse pappyErr19 -> NoParse (max pappyErr19 pappyErr17)
                                    NoParse pappyErr17 -> NoParse pappyErr17
                                  where
                                    pappyResult17 =
                                      case lojbanChar pappyDvs11 of
                                        Parsed 't' pappyDvs19 _ ->
                                          case lojbanChar pappyDvs19 of
                                            Parsed 'u' pappyDvs21 _ ->
                                              case lojbanChar pappyDvs21 of
                                                Parsed '\'' pappyDvs23 _ ->
                                                  case lojbanChar pappyDvs23 of
                                                    Parsed 'u' pappyDvs25 _ ->
                                                      Parsed (
                                                        "tu'u") pappyDvs25 (ParseError (lojbanPos pappyDvs25) [])
                                                    _ -> NoParse (ParseError (lojbanPos pappyDvs23) [])
                                                _ -> NoParse (ParseError (lojbanPos pappyDvs21) [])
                                            _ -> NoParse (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        NoParse pappyErr11 -> pappyAlt3_3 (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3])
                    NoParse pappyErr9 -> pappyAlt3_3 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3])
                NoParse pappyErr7 -> pappyAlt3_3 (maximum [pappyErr7,pappyErr5,pappyErr3])
              where
                pappyResult7 =
                  case lojbanChar pappyDvs5 of
                    Parsed 't' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'u' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed '\'' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed 'e' pappyDvs15 _ ->
                                  Parsed (
                                    "tu'e") pappyDvs15 (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            NoParse pappyErr5 -> pappyAlt3_3 (max pappyErr5 pappyErr3)
          where
            pappyResult5 =
              case lojbantag d of
                Parsed pappyVal7 pappyDvs7 pappyErr7 -> Parsed (Just pappyVal7) pappyDvs7 pappyErr7
                NoParse pappyErr7 -> Parsed (Nothing) d pappyErr7
        pappyAlt3_3 pappyErr3 = NoParse pappyErr3

lojbanprenex :: LojbanDerivs -> Result LojbanDerivs ([Term])
lojbanprenex d =
  case pappyResult1 of
    Parsed ps pappyDvs1 pappyErr1 ->
      case pappyResult3 of
        Parsed s pappyDvs3 pappyErr3 ->
          case lojbanpostClause pappyDvs3 of
            Parsed _ pappyDvs5 pappyErr5 ->
              Parsed (ps) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> NoParse (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanChar pappyDvs1 of
            Parsed 'z' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'o' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'u' pappyDvs11 _ ->
                          Parsed (
                            "zo'u") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs1) [])
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanPlusRule5 d of
        Parsed ts pappyDvs3 pappyErr3 ->
          Parsed (
             ts ) pappyDvs3 pappyErr3
        NoParse pappyErr3 -> NoParse pappyErr3

lojbansentence :: LojbanDerivs -> Result LojbanDerivs (Sentence)
lojbansentence d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanbridiTail d of
        Parsed bt pappyDvs3 pappyErr3 ->
          Parsed (
             Sentence [] bt ) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbantermsAndTail d of
        Parsed ((ts,bt)) pappyDvs3 pappyErr3 ->
          Parsed (
            Sentence ts bt) pappyDvs3 (max pappyErr3 pappyErr1)
        Parsed _ _ _ -> pappyAlt1_3 pappyErr1
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanParsetermsAndTail :: LojbanDerivs -> Result LojbanDerivs (([Term],BridiTail))
lojbanParsetermsAndTail d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case pappyResult3 of
        Parsed _ pappyDvs3 pappyErr3 ->
          case lojbanbridiTail pappyDvs3 of
            Parsed bt pappyDvs5 pappyErr5 ->
              Parsed (
                ([],bt)) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanCU d of
            Parsed pappyVal5 pappyDvs5 pappyErr5 -> Parsed (Just pappyVal5) pappyDvs5 pappyErr5
            NoParse pappyErr5 -> Parsed (Nothing) d pappyErr5
    pappyAlt1_2 pappyErr1 =
      case lojbanterms1 d of
        Parsed t pappyDvs3 pappyErr3 ->
          case lojbantermsAndTail pappyDvs3 of
            Parsed ((ts,bt)) pappyDvs5 pappyErr5 ->
              Parsed (
                t:ts,bt) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            Parsed _ _ _ -> pappyAlt1_3 (max pappyErr3 pappyErr1)
            NoParse pappyErr5 -> pappyAlt1_3 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanParsesubsentence :: LojbanDerivs -> Result LojbanDerivs (Subsentence)
lojbanParsesubsentence d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanStarRule22 d of
        Parsed fs pappyDvs3 pappyErr3 ->
          case lojbansentence pappyDvs3 of
            Parsed s pappyDvs5 pappyErr5 ->
              Parsed (
                Subsentence fs [] s) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbanStarRule22 d of
        Parsed fs pappyDvs3 pappyErr3 ->
          case lojbanprenex pappyDvs3 of
            Parsed ps pappyDvs5 pappyErr5 ->
              case lojbansubsentence pappyDvs5 of
                Parsed (Subsentence fs' ps' s) pappyDvs7 pappyErr7 ->
                  Parsed (
                     Subsentence (fs++fs') (ps++ps') s ) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                Parsed _ _ _ -> pappyAlt1_3 (maximum [pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_3 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_3 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanParsebridiTail :: LojbanDerivs -> Result LojbanDerivs (BridiTail)
lojbanParsebridiTail d =
  case pappyResult1 of
    Parsed bt1 pappyDvs1 pappyErr1 ->
      case pappyResult3 of
        Parsed gihek pappyDvs3 pappyErr3 ->
          Parsed (
            
            	    case gihek of
            		Nothing -> bt1
            		Just (con, bt2, tts) -> ConnectedBT con bt1 bt2 tts ) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case pappyResult5 of
            Parsed pappyVal5 pappyDvs5 pappyErr5 -> Parsed (Just pappyVal5) pappyDvs5 pappyErr5
            NoParse pappyErr5 -> Parsed (Nothing) pappyDvs1 pappyErr5
          where
            pappyResult5 =
              case lojbangihek pappyDvs1 of
                Parsed lcon pappyDvs7 pappyErr7 ->
                  case pappyResult9 of
                    Parsed mtag pappyDvs9 pappyErr9 ->
                      case lojbanKE pappyDvs9 of
                        Parsed _ pappyDvs11 pappyErr11 ->
                          case lojbanbridiTail pappyDvs11 of
                            Parsed bt2 pappyDvs13 pappyErr13 ->
                              case pappyResult15 of
                                Parsed _ pappyDvs15 pappyErr15 ->
                                  case lojbantailTerms pappyDvs15 of
                                    Parsed tts pappyDvs17 pappyErr17 ->
                                      Parsed (
                                        (jboConnLogOrQ mtag lcon, bt2, tts)) pappyDvs17 (maximum [pappyErr17,pappyErr15,pappyErr13,pappyErr11,pappyErr9,pappyErr7])
                                    NoParse pappyErr17 -> NoParse (maximum [pappyErr17,pappyErr15,pappyErr13,pappyErr11,pappyErr9,pappyErr7])
                                NoParse pappyErr15 -> NoParse (maximum [pappyErr15,pappyErr13,pappyErr11,pappyErr9,pappyErr7])
                              where
                                pappyResult15 =
                                  case lojbanKEhE pappyDvs13 of
                                    Parsed pappyVal17 pappyDvs17 pappyErr17 -> Parsed (Just pappyVal17) pappyDvs17 pappyErr17
                                    NoParse pappyErr17 -> Parsed (Nothing) pappyDvs13 pappyErr17
                            NoParse pappyErr13 -> NoParse (maximum [pappyErr13,pappyErr11,pappyErr9,pappyErr7])
                        NoParse pappyErr11 -> NoParse (maximum [pappyErr11,pappyErr9,pappyErr7])
                    NoParse pappyErr9 -> NoParse (max pappyErr9 pappyErr7)
                  where
                    pappyResult9 =
                      case lojbantag pappyDvs7 of
                        Parsed pappyVal11 pappyDvs11 pappyErr11 -> Parsed (Just pappyVal11) pappyDvs11 pappyErr11
                        NoParse pappyErr11 -> Parsed (Nothing) pappyDvs7 pappyErr11
                NoParse pappyErr7 -> NoParse pappyErr7
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanbridiTail2 d of
        Parsed bt pappyDvs3 pappyErr3 ->
          case lojbanStarRule13 pappyDvs3 of
            Parsed giheks pappyDvs5 pappyErr5 ->
              Parsed (
                 foldl (\bt1 -> \(con,bt2,tts) ->
                		    ConnectedBT con bt1 bt2 tts
                		) bt giheks ) pappyDvs5 (max pappyErr5 pappyErr3)
            NoParse pappyErr5 -> NoParse (max pappyErr5 pappyErr3)
        NoParse pappyErr3 -> NoParse pappyErr3

lojbanParseStarRule13 :: LojbanDerivs -> Result LojbanDerivs ([(Connective, BridiTail, [Term])])
lojbanParseStarRule13 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case pappyResult3 of
        Parsed v pappyDvs3 pappyErr3 ->
          case lojbanStarRule13 pappyDvs3 of
            Parsed vs pappyDvs5 pappyErr5 ->
              Parsed (
                v : vs) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbangihek d of
            Parsed lcon pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                NoParse pappyErr7 ->
                  case pappyResult9 of
                    NoParse pappyErr9 ->
                      case lojbanbridiTail2 pappyDvs5 of
                        Parsed bt pappyDvs11 pappyErr11 ->
                          case lojbantailTerms pappyDvs11 of
                            Parsed tts pappyDvs13 pappyErr13 ->
                              Parsed (
                                (jboConnLogOrQ Nothing lcon, bt, tts)) pappyDvs13 (maximum [pappyErr13,pappyErr11,pappyErr9,pappyErr7,pappyErr5])
                            NoParse pappyErr13 -> NoParse (maximum [pappyErr13,pappyErr11,pappyErr9,pappyErr7,pappyErr5])
                        NoParse pappyErr11 -> NoParse (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5])
                    Parsed _ _ pappyErr9 -> NoParse (maximum [pappyErr9,pappyErr7,pappyErr5])
                  where
                    pappyResult9 =
                      case pappyResult11 of
                        Parsed _ pappyDvs11 pappyErr11 ->
                          case lojbanKE pappyDvs11 of
                            Parsed _ pappyDvs13 pappyErr13 ->
                              Parsed (
                                ()) pappyDvs13 (max pappyErr13 pappyErr11)
                            NoParse pappyErr13 -> NoParse (max pappyErr13 pappyErr11)
                        NoParse pappyErr11 -> NoParse pappyErr11
                      where
                        pappyResult11 =
                          case lojbantag pappyDvs5 of
                            Parsed pappyVal13 pappyDvs13 pappyErr13 -> Parsed (Just pappyVal13) pappyDvs13 pappyErr13
                            NoParse pappyErr13 -> Parsed (Nothing) pappyDvs5 pappyErr13
                Parsed _ _ pappyErr7 -> NoParse (max pappyErr7 pappyErr5)
              where
                pappyResult7 =
                  case pappyResult9 of
                    Parsed _ pappyDvs9 pappyErr9 ->
                      case lojbanBO pappyDvs9 of
                        Parsed _ pappyDvs11 pappyErr11 ->
                          Parsed (
                            ()) pappyDvs11 (max pappyErr11 pappyErr9)
                        NoParse pappyErr11 -> NoParse (max pappyErr11 pappyErr9)
                    NoParse pappyErr9 -> NoParse pappyErr9
                  where
                    pappyResult9 =
                      case lojbantag pappyDvs5 of
                        Parsed pappyVal11 pappyDvs11 pappyErr11 -> Parsed (Just pappyVal11) pappyDvs11 pappyErr11
                        NoParse pappyErr11 -> Parsed (Nothing) pappyDvs5 pappyErr11
            NoParse pappyErr5 -> NoParse pappyErr5
    pappyAlt1_2 pappyErr1 =
      Parsed (
        []) d pappyErr1
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanParsebridiTail2 :: LojbanDerivs -> Result LojbanDerivs (BridiTail)
lojbanParsebridiTail2 d =
  case pappyResult1 of
    Parsed bt1 pappyDvs1 pappyErr1 ->
      case pappyResult3 of
        Parsed gihek pappyDvs3 pappyErr3 ->
          Parsed (
             case gihek of
            		Nothing -> bt1
            		Just (con, bt2, tts) -> ConnectedBT con bt1 bt2 tts ) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case pappyResult5 of
            Parsed pappyVal5 pappyDvs5 pappyErr5 -> Parsed (Just pappyVal5) pappyDvs5 pappyErr5
            NoParse pappyErr5 -> Parsed (Nothing) pappyDvs1 pappyErr5
          where
            pappyResult5 =
              case lojbangihek pappyDvs1 of
                Parsed lcon pappyDvs7 pappyErr7 ->
                  case pappyResult9 of
                    Parsed mtag pappyDvs9 pappyErr9 ->
                      case lojbanBO pappyDvs9 of
                        Parsed _ pappyDvs11 pappyErr11 ->
                          case lojbanbridiTail2 pappyDvs11 of
                            Parsed bt2 pappyDvs13 pappyErr13 ->
                              case lojbantailTerms pappyDvs13 of
                                Parsed tts pappyDvs15 pappyErr15 ->
                                  Parsed (
                                    (jboConnLogOrQ mtag lcon,bt2,tts)) pappyDvs15 (maximum [pappyErr15,pappyErr13,pappyErr11,pappyErr9,pappyErr7])
                                NoParse pappyErr15 -> NoParse (maximum [pappyErr15,pappyErr13,pappyErr11,pappyErr9,pappyErr7])
                            NoParse pappyErr13 -> NoParse (maximum [pappyErr13,pappyErr11,pappyErr9,pappyErr7])
                        NoParse pappyErr11 -> NoParse (maximum [pappyErr11,pappyErr9,pappyErr7])
                    NoParse pappyErr9 -> NoParse (max pappyErr9 pappyErr7)
                  where
                    pappyResult9 =
                      case lojbantag pappyDvs7 of
                        Parsed pappyVal11 pappyDvs11 pappyErr11 -> Parsed (Just pappyVal11) pappyDvs11 pappyErr11
                        NoParse pappyErr11 -> Parsed (Nothing) pappyDvs7 pappyErr11
                NoParse pappyErr7 -> NoParse pappyErr7
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      pappyAlt3_1 (ParseError (lojbanPos d) []) where
        pappyAlt3_1 pappyErr3 =
          case lojbanselbri d of
            Parsed sb pappyDvs5 pappyErr5 ->
              case lojbantailTerms pappyDvs5 of
                Parsed ts pappyDvs7 pappyErr7 ->
                  Parsed (
                     BridiTail3 sb ts ) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3])
                NoParse pappyErr7 -> pappyAlt3_2 (maximum [pappyErr7,pappyErr5,pappyErr3])
            NoParse pappyErr5 -> pappyAlt3_2 (max pappyErr5 pappyErr3)
        pappyAlt3_2 pappyErr3 =
          case lojbangekSentence d of
            Parsed gs pappyDvs5 pappyErr5 ->
              Parsed (
                 GekSentence gs ) pappyDvs5 (max pappyErr5 pappyErr3)
            NoParse pappyErr5 -> pappyAlt3_3 (max pappyErr5 pappyErr3)
        pappyAlt3_3 pappyErr3 = NoParse pappyErr3

lojbanParsegekSentence :: LojbanDerivs -> Result LojbanDerivs (GekSentence)
lojbanParsegekSentence d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbangek d of
        Parsed pcon pappyDvs3 pappyErr3 ->
          case lojbansubsentence pappyDvs3 of
            Parsed s1 pappyDvs5 pappyErr5 ->
              case lojbangik pappyDvs5 of
                Parsed b pappyDvs7 pappyErr7 ->
                  case lojbansubsentence pappyDvs7 of
                    Parsed s2 pappyDvs9 pappyErr9 ->
                      case lojbantailTerms pappyDvs9 of
                        Parsed tts pappyDvs11 pappyErr11 ->
                          Parsed (
                             ConnectedGS (pcon b) s1 s2 tts ) pappyDvs11 (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                        NoParse pappyErr11 -> pappyAlt1_2 (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                    NoParse pappyErr9 -> pappyAlt1_2 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_2 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case pappyResult3 of
        Parsed mtag pappyDvs3 pappyErr3 ->
          case lojbanKE pappyDvs3 of
            Parsed _ pappyDvs5 pappyErr5 ->
              case lojbangekSentence pappyDvs5 of
                Parsed gs pappyDvs7 pappyErr7 ->
                  case pappyResult9 of
                    Parsed _ pappyDvs9 pappyErr9 ->
                      Parsed (
                         maybe gs (flip TaggedGS gs) mtag ) pappyDvs9 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                    NoParse pappyErr9 -> pappyAlt1_3 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                  where
                    pappyResult9 =
                      case lojbanKEhE pappyDvs7 of
                        Parsed pappyVal11 pappyDvs11 pappyErr11 -> Parsed (Just pappyVal11) pappyDvs11 pappyErr11
                        NoParse pappyErr11 -> Parsed (Nothing) pappyDvs7 pappyErr11
                NoParse pappyErr7 -> pappyAlt1_3 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_3 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbantag d of
            Parsed pappyVal5 pappyDvs5 pappyErr5 -> Parsed (Just pappyVal5) pappyDvs5 pappyErr5
            NoParse pappyErr5 -> Parsed (Nothing) d pappyErr5
    pappyAlt1_3 pappyErr1 =
      case lojbanNA d of
        Parsed "na" pappyDvs3 pappyErr3 ->
          case lojbangekSentence pappyDvs3 of
            Parsed gs pappyDvs5 pappyErr5 ->
              Parsed (
                NegatedGS gs) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_4 (maximum [pappyErr5,pappyErr3,pappyErr1])
        _ -> pappyAlt1_4 (max (ParseError (lojbanPos d) [Expected "na"]) pappyErr1)
    pappyAlt1_4 pappyErr1 =
      case lojbanNA d of
        Parsed "ja'a" pappyDvs3 pappyErr3 ->
          case lojbangekSentence pappyDvs3 of
            Parsed gs pappyDvs5 pappyErr5 ->
              Parsed (gs) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_5 (maximum [pappyErr5,pappyErr3,pappyErr1])
        _ -> pappyAlt1_5 (max (ParseError (lojbanPos d) [Expected "ja'a"]) pappyErr1)
    pappyAlt1_5 pappyErr1 = NoParse pappyErr1

lojbanParseStarRule14 :: LojbanDerivs -> Result LojbanDerivs ([Term])
lojbanParseStarRule14 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanterms1 d of
        Parsed v pappyDvs3 pappyErr3 ->
          case lojbanStarRule14 pappyDvs3 of
            Parsed vs pappyDvs5 pappyErr5 ->
              Parsed (
                v : vs) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      Parsed (
        []) d pappyErr1
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbantailTerms :: LojbanDerivs -> Result LojbanDerivs ([Term])
lojbantailTerms d =
  case lojbanStarRule14 d of
    Parsed ts pappyDvs1 pappyErr1 ->
      case pappyResult3 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (ts) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanVAU pappyDvs1 of
            Parsed pappyVal5 pappyDvs5 pappyErr5 -> Parsed (Just pappyVal5) pappyDvs5 pappyErr5
            NoParse pappyErr5 -> Parsed (Nothing) pappyDvs1 pappyErr5
    NoParse pappyErr1 -> NoParse pappyErr1

lojbanParsePlusRule5 :: LojbanDerivs -> Result LojbanDerivs ([Term])
lojbanParsePlusRule5 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanterms1 d of
        Parsed v pappyDvs3 pappyErr3 ->
          case lojbanPlusRule5 pappyDvs3 of
            Parsed vs pappyDvs5 pappyErr5 ->
              Parsed (
                v : vs) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbanterms1 d of
        Parsed v pappyDvs3 pappyErr3 ->
          Parsed (
            [v]) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanParseterms1 :: LojbanDerivs -> Result LojbanDerivs (Term)
lojbanParseterms1 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanterms2 d of
        Parsed ts1 pappyDvs3 pappyErr3 ->
          case pappyResult5 of
            Parsed s pappyDvs5 pappyErr5 ->
              case lojbanpostClause pappyDvs5 of
                Parsed _ pappyDvs7 pappyErr7 ->
                  case lojbanjoikJek pappyDvs7 of
                    Parsed jj pappyDvs9 pappyErr9 ->
                      case lojbanterms2 pappyDvs9 of
                        Parsed ts2 pappyDvs11 pappyErr11 ->
                          Parsed (
                             ConnectedTerms False (jjJboCon Nothing jj) ts1 ts2 ) pappyDvs11 (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                        NoParse pappyErr11 -> pappyAlt1_2 (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                    NoParse pappyErr9 -> pappyAlt1_2 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_2 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
          where
            pappyResult5 =
              case lojbanChar pappyDvs3 of
                Parsed 'p' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'e' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed '\'' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed 'e' pappyDvs13 _ ->
                              Parsed (
                                "pe'e") pappyDvs13 (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbanterms2 d of
        Parsed pappyVal3 pappyDvs3 pappyErr3 -> Parsed pappyVal3 pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanParsePlusRule6 :: LojbanDerivs -> Result LojbanDerivs ([Term])
lojbanParsePlusRule6 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanCEhE d of
        Parsed _ pappyDvs3 pappyErr3 ->
          case lojbanterms2 pappyDvs3 of
            Parsed v pappyDvs5 pappyErr5 ->
              case lojbanPlusRule6 pappyDvs5 of
                Parsed vs pappyDvs7 pappyErr7 ->
                  Parsed (
                    v : vs) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_2 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbanCEhE d of
        Parsed _ pappyDvs3 pappyErr3 ->
          case lojbanterms2 pappyDvs3 of
            Parsed v pappyDvs5 pappyErr5 ->
              Parsed (
                [v]) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_3 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanterms2 :: LojbanDerivs -> Result LojbanDerivs (Term)
lojbanterms2 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanterm d of
        Parsed t pappyDvs3 pappyErr3 ->
          case lojbanPlusRule6 pappyDvs3 of
            Parsed ts pappyDvs5 pappyErr5 ->
              Parsed (
                 Termset (t:ts) ) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbanterm d of
        Parsed pappyVal3 pappyDvs3 pappyErr3 -> Parsed pappyVal3 pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanParseterm :: LojbanDerivs -> Result LojbanDerivs (Term)
lojbanParseterm d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbansumti d of
        Parsed s pappyDvs3 pappyErr3 ->
          Parsed (
            Sumti Untagged s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbangek d of
        NoParse pappyErr3 ->
          case lojbantag d of
            Parsed tag pappyDvs5 pappyErr5 ->
              case lojbansumti pappyDvs5 of
                Parsed s pappyDvs7 pappyErr7 ->
                  Parsed (
                    Sumti (Tagged tag) s) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_3 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_3 (maximum [pappyErr5,pappyErr3,pappyErr1])
        Parsed _ _ pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 =
      case lojbangek d of
        NoParse pappyErr3 ->
          case lojbantag d of
            Parsed tag pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed _ pappyDvs7 pappyErr7 ->
                  Parsed (
                    BareTag tag) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_4 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case lojbanKU pappyDvs5 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs5 pappyErr9
            NoParse pappyErr5 -> pappyAlt1_4 (maximum [pappyErr5,pappyErr3,pappyErr1])
        Parsed _ _ pappyErr3 -> pappyAlt1_4 (max pappyErr3 pappyErr1)
    pappyAlt1_4 pappyErr1 =
      case lojbantagFA d of
        Parsed n pappyDvs3 pappyErr3 ->
          case lojbansumti pappyDvs3 of
            Parsed s pappyDvs5 pappyErr5 ->
              Parsed (
                Sumti (FATagged n) s) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_5 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_5 (max pappyErr3 pappyErr1)
    pappyAlt1_5 pappyErr1 =
      case lojbantagFA d of
        Parsed n pappyDvs3 pappyErr3 ->
          case pappyResult5 of
            Parsed _ pappyDvs5 pappyErr5 ->
              Parsed (
                BareFA $ Just n) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_6 (maximum [pappyErr5,pappyErr3,pappyErr1])
          where
            pappyResult5 =
              case lojbanKU pappyDvs3 of
                Parsed pappyVal7 pappyDvs7 pappyErr7 -> Parsed (Just pappyVal7) pappyDvs7 pappyErr7
                NoParse pappyErr7 -> Parsed (Nothing) pappyDvs3 pappyErr7
        NoParse pappyErr3 -> pappyAlt1_6 (max pappyErr3 pappyErr1)
    pappyAlt1_6 pappyErr1 =
      case lojbanFA d of
        Parsed "fai" pappyDvs3 pappyErr3 ->
          case lojbansumti pappyDvs3 of
            Parsed s pappyDvs5 pappyErr5 ->
              Parsed (
                Sumti FAITagged s) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_7 (maximum [pappyErr5,pappyErr3,pappyErr1])
        _ -> pappyAlt1_7 (max (ParseError (lojbanPos d) [Expected "fai"]) pappyErr1)
    pappyAlt1_7 pappyErr1 =
      case lojbanFA d of
        Parsed _ pappyDvs3 pappyErr3 ->
          case pappyResult5 of
            Parsed _ pappyDvs5 pappyErr5 ->
              Parsed (
                NullTerm) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_8 (maximum [pappyErr5,pappyErr3,pappyErr1])
          where
            pappyResult5 =
              case lojbanKU pappyDvs3 of
                Parsed pappyVal7 pappyDvs7 pappyErr7 -> Parsed (Just pappyVal7) pappyDvs7 pappyErr7
                NoParse pappyErr7 -> Parsed (Nothing) pappyDvs3 pappyErr7
        NoParse pappyErr3 -> pappyAlt1_8 (max pappyErr3 pappyErr1)
    pappyAlt1_8 pappyErr1 =
      pappyAlt3_1 pappyErr1 where
        pappyAlt3_1 pappyErr3 =
          case lojbanNUhI d of
            Parsed _ pappyDvs5 pappyErr5 ->
              case lojbangek pappyDvs5 of
                Parsed pcon pappyDvs7 pappyErr7 ->
                  case pappyResult9 of
                    Parsed ts1 pappyDvs9 pappyErr9 ->
                      case lojbanNUhU pappyDvs9 of
                        Parsed _ pappyDvs11 pappyErr11 ->
                          case lojbangik pappyDvs11 of
                            Parsed b pappyDvs13 pappyErr13 ->
                              case pappyResult15 of
                                Parsed ts2 pappyDvs15 pappyErr15 ->
                                  case pappyResult17 of
                                    Parsed _ pappyDvs17 pappyErr17 ->
                                      Parsed (
                                         ConnectedTerms True (pcon b) (Termset ts1) (Termset ts2) ) pappyDvs17 (maximum [pappyErr17,pappyErr15,pappyErr13,pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3])
                                    NoParse pappyErr17 -> pappyAlt3_2 (maximum [pappyErr17,pappyErr15,pappyErr13,pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3])
                                  where
                                    pappyResult17 =
                                      case lojbanNUhU pappyDvs15 of
                                        Parsed pappyVal19 pappyDvs19 pappyErr19 -> Parsed (Just pappyVal19) pappyDvs19 pappyErr19
                                        NoParse pappyErr19 -> Parsed (Nothing) pappyDvs15 pappyErr19
                                NoParse pappyErr15 -> pappyAlt3_2 (maximum [pappyErr15,pappyErr13,pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3])
                              where
                                pappyResult15 =
                                  case lojbanPlusRule5 pappyDvs13 of
                                    Parsed ts pappyDvs17 pappyErr17 ->
                                      Parsed (
                                         ts ) pappyDvs17 pappyErr17
                                    NoParse pappyErr17 -> NoParse pappyErr17
                            NoParse pappyErr13 -> pappyAlt3_2 (maximum [pappyErr13,pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3])
                        NoParse pappyErr11 -> pappyAlt3_2 (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3])
                    NoParse pappyErr9 -> pappyAlt3_2 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3])
                  where
                    pappyResult9 =
                      case lojbanPlusRule5 pappyDvs7 of
                        Parsed ts pappyDvs11 pappyErr11 ->
                          Parsed (
                             ts ) pappyDvs11 pappyErr11
                        NoParse pappyErr11 -> NoParse pappyErr11
                NoParse pappyErr7 -> pappyAlt3_2 (maximum [pappyErr7,pappyErr5,pappyErr3])
            NoParse pappyErr5 -> pappyAlt3_2 (max pappyErr5 pappyErr3)
        pappyAlt3_2 pappyErr3 =
          case lojbanNUhI d of
            Parsed _ pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed ts pappyDvs7 pappyErr7 ->
                  case pappyResult9 of
                    Parsed _ pappyDvs9 pappyErr9 ->
                      Parsed (
                         Termset ts ) pappyDvs9 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3])
                    NoParse pappyErr9 -> pappyAlt3_3 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3])
                  where
                    pappyResult9 =
                      case lojbanNUhU pappyDvs7 of
                        Parsed pappyVal11 pappyDvs11 pappyErr11 -> Parsed (Just pappyVal11) pappyDvs11 pappyErr11
                        NoParse pappyErr11 -> Parsed (Nothing) pappyDvs7 pappyErr11
                NoParse pappyErr7 -> pappyAlt3_3 (maximum [pappyErr7,pappyErr5,pappyErr3])
              where
                pappyResult7 =
                  case lojbanPlusRule5 pappyDvs5 of
                    Parsed ts pappyDvs9 pappyErr9 ->
                      Parsed (
                         ts ) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> NoParse pappyErr9
            NoParse pappyErr5 -> pappyAlt3_3 (max pappyErr5 pappyErr3)
        pappyAlt3_3 pappyErr3 =
          case lojbangek d of
            Parsed pcon pappyDvs5 pappyErr5 ->
              case lojbantermsGikTerms pappyDvs5 of
                Parsed ((ts1,b,ts2)) pappyDvs7 pappyErr7 ->
                  Parsed (
                     ConnectedTerms True (pcon b) (Termset ts1) (Termset ts2) ) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3])
                Parsed _ _ _ -> pappyAlt3_4 (max pappyErr5 pappyErr3)
                NoParse pappyErr7 -> pappyAlt3_4 (maximum [pappyErr7,pappyErr5,pappyErr3])
            NoParse pappyErr5 -> pappyAlt3_4 (max pappyErr5 pappyErr3)
        pappyAlt3_4 pappyErr3 = pappyAlt1_9 pappyErr3
    pappyAlt1_9 pappyErr1 =
      case lojbanNA d of
        Parsed "na" pappyDvs3 pappyErr3 ->
          case lojbanKU pappyDvs3 of
            Parsed _ pappyDvs5 pappyErr5 ->
              Parsed (
                Negation) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_10 (maximum [pappyErr5,pappyErr3,pappyErr1])
        _ -> pappyAlt1_10 (max (ParseError (lojbanPos d) [Expected "na"]) pappyErr1)
    pappyAlt1_10 pappyErr1 =
      case lojbanNA d of
        Parsed "ja'a" pappyDvs3 pappyErr3 ->
          case lojbanKU pappyDvs3 of
            Parsed _ pappyDvs5 pappyErr5 ->
              Parsed (
                NullTerm) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_11 (maximum [pappyErr5,pappyErr3,pappyErr1])
        _ -> pappyAlt1_11 (max (ParseError (lojbanPos d) [Expected "ja'a"]) pappyErr1)
    pappyAlt1_11 pappyErr1 = NoParse pappyErr1

lojbanParsetermsGikTerms :: LojbanDerivs -> Result LojbanDerivs (([Term],Bool,[Term]))
lojbanParsetermsGikTerms d =
  case lojbanterm d of
    Parsed t1 pappyDvs1 pappyErr1 ->
      case pappyResult3 of
        Parsed ((ts1,b,ts2)) pappyDvs3 pappyErr3 ->
          case lojbanterm pappyDvs3 of
            Parsed t2 pappyDvs5 pappyErr5 ->
              Parsed (
                (t1:ts1,b,ts2++[t2])) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> NoParse (maximum [pappyErr5,pappyErr3,pappyErr1])
        Parsed _ _ _ -> NoParse pappyErr1
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          pappyAlt5_1 (ParseError (lojbanPos pappyDvs1) []) where
            pappyAlt5_1 pappyErr5 =
              case lojbangik pappyDvs1 of
                Parsed b pappyDvs7 pappyErr7 ->
                  Parsed (
                    ([],b,[])) pappyDvs7 (max pappyErr7 pappyErr5)
                NoParse pappyErr7 -> pappyAlt5_2 (max pappyErr7 pappyErr5)
            pappyAlt5_2 pappyErr5 =
              case lojbantermsGikTerms pappyDvs1 of
                Parsed pappyVal7 pappyDvs7 pappyErr7 -> Parsed pappyVal7 pappyDvs7 (max pappyErr7 pappyErr5)
                NoParse pappyErr7 -> pappyAlt5_3 (max pappyErr7 pappyErr5)
            pappyAlt5_3 pappyErr5 = NoParse pappyErr5
    NoParse pappyErr1 -> NoParse pappyErr1

lojbanParsesumti :: LojbanDerivs -> Result LojbanDerivs (Sumti)
lojbanParsesumti d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case pappyResult3 of
        Parsed rels pappyDvs3 pappyErr3 ->
          Parsed (
             case rels of
            	    Nothing -> s
            	    Just rels -> appendRelsToSumti rels s ) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case pappyResult5 of
            Parsed pappyVal5 pappyDvs5 pappyErr5 -> Parsed (Just pappyVal5) pappyDvs5 pappyErr5
            NoParse pappyErr5 -> Parsed (Nothing) pappyDvs1 pappyErr5
          where
            pappyResult5 =
              case pappyResult7 of
                Parsed s pappyDvs7 pappyErr7 ->
                  case lojbanpostClause pappyDvs7 of
                    Parsed _ pappyDvs9 pappyErr9 ->
                      case lojbanrelativeClauses pappyDvs9 of
                        Parsed rels pappyDvs11 pappyErr11 ->
                          Parsed (rels) pappyDvs11 (maximum [pappyErr11,pappyErr9,pappyErr7])
                        NoParse pappyErr11 -> NoParse (maximum [pappyErr11,pappyErr9,pappyErr7])
                    NoParse pappyErr9 -> NoParse (max pappyErr9 pappyErr7)
                NoParse pappyErr7 -> NoParse pappyErr7
              where
                pappyResult7 =
                  case lojbanChar pappyDvs1 of
                    Parsed 'v' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'u' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed '\'' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed 'o' pappyDvs15 _ ->
                                  Parsed (
                                    "vu'o") pappyDvs15 (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs1) [])
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case pappyResult3 of
        Parsed s1 pappyDvs3 pappyErr3 ->
          case pappyResult5 of
            Parsed eks pappyDvs5 pappyErr5 ->
              Parsed (
                 case eks of
                	    Nothing -> s1
                	    Just (con,s2) -> ConnectedSumti False con s1 s2 [] ) pappyDvs5 (max pappyErr5 pappyErr3)
            NoParse pappyErr5 -> NoParse (max pappyErr5 pappyErr3)
          where
            pappyResult5 =
              case pappyResult7 of
                Parsed pappyVal7 pappyDvs7 pappyErr7 -> Parsed (Just pappyVal7) pappyDvs7 pappyErr7
                NoParse pappyErr7 -> Parsed (Nothing) pappyDvs3 pappyErr7
              where
                pappyResult7 =
                  case lojbanjoikEk pappyDvs3 of
                    Parsed jj pappyDvs9 pappyErr9 ->
                      case pappyResult11 of
                        Parsed mtag pappyDvs11 pappyErr11 ->
                          case lojbanKE pappyDvs11 of
                            Parsed _ pappyDvs13 pappyErr13 ->
                              case lojbansumti pappyDvs13 of
                                Parsed s pappyDvs15 pappyErr15 ->
                                  case pappyResult17 of
                                    Parsed _ pappyDvs17 pappyErr17 ->
                                      Parsed (
                                        (jjJboCon mtag jj,s)) pappyDvs17 (maximum [pappyErr17,pappyErr15,pappyErr13,pappyErr11,pappyErr9])
                                    NoParse pappyErr17 -> NoParse (maximum [pappyErr17,pappyErr15,pappyErr13,pappyErr11,pappyErr9])
                                  where
                                    pappyResult17 =
                                      case lojbanKEhE pappyDvs15 of
                                        Parsed pappyVal19 pappyDvs19 pappyErr19 -> Parsed (Just pappyVal19) pappyDvs19 pappyErr19
                                        NoParse pappyErr19 -> Parsed (Nothing) pappyDvs15 pappyErr19
                                NoParse pappyErr15 -> NoParse (maximum [pappyErr15,pappyErr13,pappyErr11,pappyErr9])
                            NoParse pappyErr13 -> NoParse (maximum [pappyErr13,pappyErr11,pappyErr9])
                        NoParse pappyErr11 -> NoParse (max pappyErr11 pappyErr9)
                      where
                        pappyResult11 =
                          case lojbantag pappyDvs9 of
                            Parsed pappyVal13 pappyDvs13 pappyErr13 -> Parsed (Just pappyVal13) pappyDvs13 pappyErr13
                            NoParse pappyErr13 -> Parsed (Nothing) pappyDvs9 pappyErr13
                    NoParse pappyErr9 -> NoParse pappyErr9
        NoParse pappyErr3 -> NoParse pappyErr3
      where
        pappyResult3 =
          case lojbansumti3 d of
            Parsed s pappyDvs5 pappyErr5 ->
              case lojbanStarRule15 pappyDvs5 of
                Parsed ekss pappyDvs7 pappyErr7 ->
                  Parsed (
                     foldl (\s1 -> \(con,s2) -> ConnectedSumti False con s1 s2 []) s ekss ) pappyDvs7 (max pappyErr7 pappyErr5)
                NoParse pappyErr7 -> NoParse (max pappyErr7 pappyErr5)
            NoParse pappyErr5 -> NoParse pappyErr5

lojbanParseStarRule15 :: LojbanDerivs -> Result LojbanDerivs ([(Connective, Sumti)])
lojbanParseStarRule15 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case pappyResult3 of
        Parsed v pappyDvs3 pappyErr3 ->
          case lojbanStarRule15 pappyDvs3 of
            Parsed vs pappyDvs5 pappyErr5 ->
              Parsed (
                v : vs) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanjoikEk d of
            Parsed jj pappyDvs5 pappyErr5 ->
              case lojbansumti3 pappyDvs5 of
                Parsed s pappyDvs7 pappyErr7 ->
                  Parsed (
                    (jjJboCon Nothing jj,s)) pappyDvs7 (max pappyErr7 pappyErr5)
                NoParse pappyErr7 -> NoParse (max pappyErr7 pappyErr5)
            NoParse pappyErr5 -> NoParse pappyErr5
    pappyAlt1_2 pappyErr1 =
      Parsed (
        []) d pappyErr1
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanParsesumti3 :: LojbanDerivs -> Result LojbanDerivs (Sumti)
lojbanParsesumti3 d =
  case lojbansumti4 d of
    Parsed s1 pappyDvs1 pappyErr1 ->
      case pappyResult3 of
        Parsed eks pappyDvs3 pappyErr3 ->
          Parsed (
             case eks of
            		Nothing -> s1
            		Just (con,s2) -> ConnectedSumti False con s1 s2 [] ) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case pappyResult5 of
            Parsed pappyVal5 pappyDvs5 pappyErr5 -> Parsed (Just pappyVal5) pappyDvs5 pappyErr5
            NoParse pappyErr5 -> Parsed (Nothing) pappyDvs1 pappyErr5
          where
            pappyResult5 =
              case lojbanjoikEk pappyDvs1 of
                Parsed jj pappyDvs7 pappyErr7 ->
                  case pappyResult9 of
                    Parsed mtag pappyDvs9 pappyErr9 ->
                      case lojbanBO pappyDvs9 of
                        Parsed _ pappyDvs11 pappyErr11 ->
                          case lojbansumti3 pappyDvs11 of
                            Parsed s pappyDvs13 pappyErr13 ->
                              Parsed (
                                (jjJboCon mtag jj,s)) pappyDvs13 (maximum [pappyErr13,pappyErr11,pappyErr9,pappyErr7])
                            NoParse pappyErr13 -> NoParse (maximum [pappyErr13,pappyErr11,pappyErr9,pappyErr7])
                        NoParse pappyErr11 -> NoParse (maximum [pappyErr11,pappyErr9,pappyErr7])
                    NoParse pappyErr9 -> NoParse (max pappyErr9 pappyErr7)
                  where
                    pappyResult9 =
                      case lojbantag pappyDvs7 of
                        Parsed pappyVal11 pappyDvs11 pappyErr11 -> Parsed (Just pappyVal11) pappyDvs11 pappyErr11
                        NoParse pappyErr11 -> Parsed (Nothing) pappyDvs7 pappyErr11
                NoParse pappyErr7 -> NoParse pappyErr7
    NoParse pappyErr1 -> NoParse pappyErr1

lojbanParsesumti4 :: LojbanDerivs -> Result LojbanDerivs (Sumti)
lojbanParsesumti4 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case pappyResult3 of
        Parsed q pappyDvs3 pappyErr3 ->
          case lojbansumti6 pappyDvs3 of
            Parsed s pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed k pappyDvs7 pappyErr7 ->
                  case lojbanStarRule22 pappyDvs7 of
                    Parsed fs pappyDvs9 pappyErr9 ->
                      case lojbanmaybeRelativeClauses pappyDvs9 of
                        Parsed rels pappyDvs11 pappyErr11 ->
                          Parsed (
                            QAtom fs q rels (maybe s (SumtiQ . Just) k)) pappyDvs11 (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                        NoParse pappyErr11 -> pappyAlt1_2 (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                    NoParse pappyErr9 -> pappyAlt1_2 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_2 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case pappyResult9 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs5 pappyErr9
                  where
                    pappyResult9 =
                      case lojbanUI pappyDvs5 of
                        Parsed "kau" pappyDvs11 pappyErr11 ->
                          case pappyResult13 of
                            Parsed x pappyDvs13 pappyErr13 ->
                              Parsed (
                                fromMaybe 1 x) pappyDvs13 (max pappyErr13 pappyErr11)
                            NoParse pappyErr13 -> NoParse (max pappyErr13 pappyErr11)
                          where
                            pappyResult13 =
                              case lojbanxiLit pappyDvs11 of
                                Parsed pappyVal15 pappyDvs15 pappyErr15 -> Parsed (Just pappyVal15) pappyDvs15 pappyErr15
                                NoParse pappyErr15 -> Parsed (Nothing) pappyDvs11 pappyErr15
                        _ -> NoParse (ParseError (lojbanPos pappyDvs5) [Expected "kau"])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanquantifier d of
            Parsed pappyVal5 pappyDvs5 pappyErr5 -> Parsed (Just pappyVal5) pappyDvs5 pappyErr5
            NoParse pappyErr5 -> Parsed (Nothing) d pappyErr5
    pappyAlt1_2 pappyErr1 =
      case lojbanquantifier d of
        Parsed q pappyDvs3 pappyErr3 ->
          case lojbanselbri pappyDvs3 of
            Parsed sb pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed _ pappyDvs7 pappyErr7 ->
                  case lojbanmaybeRelativeClauses pappyDvs7 of
                    Parsed rels pappyDvs9 pappyErr9 ->
                      Parsed (
                        QSelbri q rels sb) pappyDvs9 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                    NoParse pappyErr9 -> pappyAlt1_3 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_3 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case lojbanKU pappyDvs5 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs5 pappyErr9
            NoParse pappyErr5 -> pappyAlt1_3 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 =
      case lojbangek d of
        Parsed pcon pappyDvs3 pappyErr3 ->
          case lojbansumti pappyDvs3 of
            Parsed s1 pappyDvs5 pappyErr5 ->
              case lojbangik pappyDvs5 of
                Parsed b pappyDvs7 pappyErr7 ->
                  case lojbansumti4 pappyDvs7 of
                    Parsed s2 pappyDvs9 pappyErr9 ->
                      Parsed (
                         ConnectedSumti True (pcon b) s1 s2 [] ) pappyDvs9 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                    NoParse pappyErr9 -> pappyAlt1_4 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_4 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_4 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_4 (max pappyErr3 pappyErr1)
    pappyAlt1_4 pappyErr1 = NoParse pappyErr1

lojbanParsesumti6 :: LojbanDerivs -> Result LojbanDerivs (SumtiAtom)
lojbanParsesumti6 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case pappyResult3 of
        Parsed s pappyDvs3 pappyErr3 ->
          case lojbanPlusRule13 pappyDvs3 of
            Parsed _ pappyDvs5 pappyErr5 ->
              case lojbanValsi pappyDvs5 of
                Parsed s pappyDvs7 pappyErr7 ->
                  Parsed (
                    Word s) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_2 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanChar d of
            Parsed 'z' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'o' pappyDvs7 _ ->
                  Parsed (
                    "zo") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos d) [])
    pappyAlt1_2 pappyErr1 =
      case pappyResult3 of
        Parsed "zoi" pappyDvs3 pappyErr3 ->
          case lojbanpostClause pappyDvs3 of
            Parsed _ pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed s pappyDvs7 pappyErr7 ->
                  Parsed (
                    NonJboQuote s) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_3 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  pappyAlt9_1 (ParseError (lojbanPos pappyDvs5) []) where
                    pappyAlt9_1 pappyErr9 =
                      case lojbanValsi pappyDvs5 of
                        Parsed "zoi" pappyDvs11 pappyErr11 ->
                          case lojbanStarRule17 pappyDvs11 of
                            Parsed ws pappyDvs13 pappyErr13 ->
                              case lojbanValsi pappyDvs13 of
                                Parsed "zoi" pappyDvs15 pappyErr15 ->
                                  Parsed (
                                    unwords ws) pappyDvs15 (maximum [pappyErr15,pappyErr13,pappyErr11,pappyErr9])
                                _ -> pappyAlt9_2 (maximum [(ParseError (lojbanPos pappyDvs13) [Expected "zoi"]),pappyErr13,pappyErr11,pappyErr9])
                            NoParse pappyErr13 -> pappyAlt9_2 (maximum [pappyErr13,pappyErr11,pappyErr9])
                        _ -> pappyAlt9_2 (max (ParseError (lojbanPos pappyDvs5) [Expected "zoi"]) pappyErr9)
                    pappyAlt9_2 pappyErr9 =
                      case lojbanValsi pappyDvs5 of
                        Parsed "gy" pappyDvs11 pappyErr11 ->
                          case lojbanStarRule18 pappyDvs11 of
                            Parsed ws pappyDvs13 pappyErr13 ->
                              case lojbanValsi pappyDvs13 of
                                Parsed "gy" pappyDvs15 pappyErr15 ->
                                  Parsed (
                                    unwords ws) pappyDvs15 (maximum [pappyErr15,pappyErr13,pappyErr11,pappyErr9])
                                _ -> pappyAlt9_3 (maximum [(ParseError (lojbanPos pappyDvs13) [Expected "gy"]),pappyErr13,pappyErr11,pappyErr9])
                            NoParse pappyErr13 -> pappyAlt9_3 (maximum [pappyErr13,pappyErr11,pappyErr9])
                        _ -> pappyAlt9_3 (max (ParseError (lojbanPos pappyDvs5) [Expected "gy"]) pappyErr9)
                    pappyAlt9_3 pappyErr9 = NoParse pappyErr9
            NoParse pappyErr5 -> pappyAlt1_3 (maximum [pappyErr5,pappyErr3,pappyErr1])
        _ -> pappyAlt1_3 (max (ParseError (lojbanPos d) [Expected "zoi"]) pappyErr1)
      where
        pappyResult3 =
          case lojbanChar d of
            Parsed 'z' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'o' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'i' pappyDvs9 _ ->
                      Parsed (
                        "zoi") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'l' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'a' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'o' pappyDvs11 _ ->
                          Parsed (
                            "la'o") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos d) [])
    pappyAlt1_3 pappyErr1 =
      case pappyResult3 of
        Parsed s pappyDvs3 pappyErr3 ->
          case lojbanpostClause pappyDvs3 of
            Parsed _ pappyDvs5 pappyErr5 ->
              case lojbanStarRule19 pappyDvs5 of
                Parsed vs pappyDvs7 pappyErr7 ->
                  case lojbanLEhU pappyDvs7 of
                    Parsed _ pappyDvs9 pappyErr9 ->
                      Parsed (
                        ErrorQuote vs) pappyDvs9 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                    NoParse pappyErr9 -> pappyAlt1_4 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_4 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_4 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_4 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanChar d of
            Parsed 'l' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'o' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'u' pappyDvs11 _ ->
                          Parsed (
                            "lo'u") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos d) [])
    pappyAlt1_4 pappyErr1 =
      case lojbanlerfuString d of
        Parsed l pappyDvs3 pappyErr3 ->
          case lojbanMOI pappyDvs3 of
            NoParse pappyErr5 ->
              case pappyResult7 of
                Parsed _ pappyDvs7 pappyErr7 ->
                  Parsed (
                    LerfuString l) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_5 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case lojbanBOI pappyDvs3 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs3 pappyErr9
            Parsed _ _ pappyErr5 -> pappyAlt1_5 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_5 (max pappyErr3 pappyErr1)
    pappyAlt1_5 pappyErr1 =
      case pappyResult3 of
        Parsed s pappyDvs3 pappyErr3 ->
          case lojbanpostClause pappyDvs3 of
            Parsed _ pappyDvs5 pappyErr5 ->
              case lojbantext pappyDvs5 of
                Parsed t pappyDvs7 pappyErr7 ->
                  case pappyResult9 of
                    Parsed _ pappyDvs9 pappyErr9 ->
                      Parsed (
                        Quote t) pappyDvs9 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                    NoParse pappyErr9 -> pappyAlt1_6 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                  where
                    pappyResult9 =
                      case pappyResult11 of
                        Parsed pappyVal11 pappyDvs11 pappyErr11 -> Parsed (Just pappyVal11) pappyDvs11 pappyErr11
                        NoParse pappyErr11 -> Parsed (Nothing) pappyDvs7 pappyErr11
                      where
                        pappyResult11 =
                          case pappyResult13 of
                            Parsed s pappyDvs13 pappyErr13 ->
                              case lojbanpostClause pappyDvs13 of
                                Parsed _ pappyDvs15 pappyErr15 ->
                                  Parsed (s) pappyDvs15 (max pappyErr15 pappyErr13)
                                NoParse pappyErr15 -> NoParse (max pappyErr15 pappyErr13)
                            NoParse pappyErr13 -> NoParse pappyErr13
                          where
                            pappyResult13 =
                              case lojbanChar pappyDvs7 of
                                Parsed 'l' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'i' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed '\'' pappyDvs19 _ ->
                                          case lojbanChar pappyDvs19 of
                                            Parsed 'u' pappyDvs21 _ ->
                                              Parsed (
                                                "li'u") pappyDvs21 (ParseError (lojbanPos pappyDvs21) [])
                                            _ -> NoParse (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                NoParse pappyErr7 -> pappyAlt1_6 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_6 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_6 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanChar d of
            Parsed 'l' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'u' pappyDvs7 _ ->
                  Parsed (
                    "lu") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos d) [])
    pappyAlt1_6 pappyErr1 =
      case lojbanqualifier d of
        Parsed qual pappyDvs3 pappyErr3 ->
          case lojbanmaybeRelativeClauses pappyDvs3 of
            Parsed rels pappyDvs5 pappyErr5 ->
              case lojbansumti pappyDvs5 of
                Parsed s pappyDvs7 pappyErr7 ->
                  case pappyResult9 of
                    Parsed _ pappyDvs9 pappyErr9 ->
                      Parsed (
                        QualifiedSumti qual rels s) pappyDvs9 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                    NoParse pappyErr9 -> pappyAlt1_7 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                  where
                    pappyResult9 =
                      case lojbanLUhU pappyDvs7 of
                        Parsed pappyVal11 pappyDvs11 pappyErr11 -> Parsed (Just pappyVal11) pappyDvs11 pappyErr11
                        NoParse pappyErr11 -> Parsed (Nothing) pappyDvs7 pappyErr11
                NoParse pappyErr7 -> pappyAlt1_7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_7 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_7 (max pappyErr3 pappyErr1)
    pappyAlt1_7 pappyErr1 =
      case lojbanKOhA d of
        Parsed k pappyDvs3 pappyErr3 ->
          case (k `elem` ["do","ko","do'o","mi","ma'a","mi'a","mi'o"]) of
            True ->
              Parsed (
                NonAnaphoricProsumti k) pappyDvs3 (max pappyErr3 pappyErr1)
            False -> pappyAlt1_8 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_8 (max pappyErr3 pappyErr1)
    pappyAlt1_8 pappyErr1 =
      case lojbanKOhA d of
        Parsed k pappyDvs3 pappyErr3 ->
          case (k `elem` ["ti","ta","tu"]) of
            True ->
              Parsed (
                NonAnaphoricProsumti k) pappyDvs3 (max pappyErr3 pappyErr1)
            False -> pappyAlt1_9 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_9 (max pappyErr3 pappyErr1)
    pappyAlt1_9 pappyErr1 =
      case lojbanKOhA d of
        Parsed k pappyDvs3 pappyErr3 ->
          case (k `elem` ["da'e","de'e","di'e","da'u","de'u","di'u","dei","do'i"]) of
            True ->
              Parsed (
                NonAnaphoricProsumti k) pappyDvs3 (max pappyErr3 pappyErr1)
            False -> pappyAlt1_10 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_10 (max pappyErr3 pappyErr1)
    pappyAlt1_10 pappyErr1 =
      case pappyResult3 of
        Parsed n pappyDvs3 pappyErr3 ->
          case pappyResult5 of
            Parsed mn pappyDvs5 pappyErr5 ->
              Parsed (
                Variable $ fromMaybe n mn) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_11 (maximum [pappyErr5,pappyErr3,pappyErr1])
          where
            pappyResult5 =
              case lojbanxiLit pappyDvs3 of
                Parsed pappyVal7 pappyDvs7 pappyErr7 -> Parsed (Just pappyVal7) pappyDvs7 pappyErr7
                NoParse pappyErr7 -> Parsed (Nothing) pappyDvs3 pappyErr7
        NoParse pappyErr3 -> pappyAlt1_11 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          pappyAlt5_1 (ParseError (lojbanPos d) []) where
            pappyAlt5_1 pappyErr5 =
              case lojbanKOhA d of
                Parsed "da" pappyDvs7 pappyErr7 ->
                  Parsed (
                    1) pappyDvs7 (max pappyErr7 pappyErr5)
                _ -> pappyAlt5_2 (max (ParseError (lojbanPos d) [Expected "da"]) pappyErr5)
            pappyAlt5_2 pappyErr5 =
              case lojbanKOhA d of
                Parsed "de" pappyDvs7 pappyErr7 ->
                  Parsed (
                    2) pappyDvs7 (max pappyErr7 pappyErr5)
                _ -> pappyAlt5_3 (max (ParseError (lojbanPos d) [Expected "de"]) pappyErr5)
            pappyAlt5_3 pappyErr5 =
              case lojbanKOhA d of
                Parsed "di" pappyDvs7 pappyErr7 ->
                  Parsed (
                    3) pappyDvs7 (max pappyErr7 pappyErr5)
                _ -> pappyAlt5_4 (max (ParseError (lojbanPos d) [Expected "di"]) pappyErr5)
            pappyAlt5_4 pappyErr5 = NoParse pappyErr5
    pappyAlt1_11 pappyErr1 =
      case lojbanKOhA d of
        Parsed "ke'a" pappyDvs3 pappyErr3 ->
          case pappyResult5 of
            Parsed mn pappyDvs5 pappyErr5 ->
              Parsed (
                RelVar $ fromMaybe 1 mn) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_12 (maximum [pappyErr5,pappyErr3,pappyErr1])
          where
            pappyResult5 =
              case lojbanxiLit pappyDvs3 of
                Parsed pappyVal7 pappyDvs7 pappyErr7 -> Parsed (Just pappyVal7) pappyDvs7 pappyErr7
                NoParse pappyErr7 -> Parsed (Nothing) pappyDvs3 pappyErr7
        _ -> pappyAlt1_12 (max (ParseError (lojbanPos d) [Expected "ke'a"]) pappyErr1)
    pappyAlt1_12 pappyErr1 =
      case lojbanKOhA d of
        Parsed "ce'u" pappyDvs3 pappyErr3 ->
          case pappyResult5 of
            Parsed ml pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed mn pappyDvs7 pappyErr7 ->
                  Parsed (
                    LambdaVar ml mn) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_13 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case lojbanxiLit pappyDvs5 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs5 pappyErr9
            NoParse pappyErr5 -> pappyAlt1_13 (maximum [pappyErr5,pappyErr3,pappyErr1])
          where
            pappyResult5 =
              case lojbanxiLit pappyDvs3 of
                Parsed pappyVal7 pappyDvs7 pappyErr7 -> Parsed (Just pappyVal7) pappyDvs7 pappyErr7
                NoParse pappyErr7 -> Parsed (Nothing) pappyDvs3 pappyErr7
        _ -> pappyAlt1_13 (max (ParseError (lojbanPos d) [Expected "ce'u"]) pappyErr1)
    pappyAlt1_13 pappyErr1 =
      case lojbanKOhA d of
        Parsed "ri" pappyDvs3 pappyErr3 ->
          case pappyResult5 of
            Parsed mn pappyDvs5 pappyErr5 ->
              Parsed (
                Ri $ fromMaybe 1 mn) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_14 (maximum [pappyErr5,pappyErr3,pappyErr1])
          where
            pappyResult5 =
              case lojbanxiLit pappyDvs3 of
                Parsed pappyVal7 pappyDvs7 pappyErr7 -> Parsed (Just pappyVal7) pappyDvs7 pappyErr7
                NoParse pappyErr7 -> Parsed (Nothing) pappyDvs3 pappyErr7
        _ -> pappyAlt1_14 (max (ParseError (lojbanPos d) [Expected "ri"]) pappyErr1)
    pappyAlt1_14 pappyErr1 =
      case lojbanKOhA d of
        Parsed "ra" pappyDvs3 pappyErr3 ->
          Parsed (
            Ra "ra") pappyDvs3 (max pappyErr3 pappyErr1)
        _ -> pappyAlt1_15 (max (ParseError (lojbanPos d) [Expected "ra"]) pappyErr1)
    pappyAlt1_15 pappyErr1 =
      case lojbanKOhA d of
        Parsed "ru" pappyDvs3 pappyErr3 ->
          Parsed (
            Ra "ru") pappyDvs3 (max pappyErr3 pappyErr1)
        _ -> pappyAlt1_16 (max (ParseError (lojbanPos d) [Expected "ru"]) pappyErr1)
    pappyAlt1_16 pappyErr1 =
      case pappyResult3 of
        Parsed n pappyDvs3 pappyErr3 ->
          case pappyResult5 of
            Parsed mn pappyDvs5 pappyErr5 ->
              Parsed (
                Assignable $ fromMaybe n mn) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_17 (maximum [pappyErr5,pappyErr3,pappyErr1])
          where
            pappyResult5 =
              case lojbanxiLit pappyDvs3 of
                Parsed pappyVal7 pappyDvs7 pappyErr7 -> Parsed (Just pappyVal7) pappyDvs7 pappyErr7
                NoParse pappyErr7 -> Parsed (Nothing) pappyDvs3 pappyErr7
        NoParse pappyErr3 -> pappyAlt1_17 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          pappyAlt5_1 (ParseError (lojbanPos d) []) where
            pappyAlt5_1 pappyErr5 =
              case lojbanKOhA d of
                Parsed "ko'a" pappyDvs7 pappyErr7 ->
                  Parsed (
                    1) pappyDvs7 (max pappyErr7 pappyErr5)
                _ -> pappyAlt5_2 (max (ParseError (lojbanPos d) [Expected "ko'a"]) pappyErr5)
            pappyAlt5_2 pappyErr5 =
              case lojbanKOhA d of
                Parsed "ko'e" pappyDvs7 pappyErr7 ->
                  Parsed (
                    2) pappyDvs7 (max pappyErr7 pappyErr5)
                _ -> pappyAlt5_3 (max (ParseError (lojbanPos d) [Expected "ko'e"]) pappyErr5)
            pappyAlt5_3 pappyErr5 =
              case lojbanKOhA d of
                Parsed "ko'i" pappyDvs7 pappyErr7 ->
                  Parsed (
                    3) pappyDvs7 (max pappyErr7 pappyErr5)
                _ -> pappyAlt5_4 (max (ParseError (lojbanPos d) [Expected "ko'i"]) pappyErr5)
            pappyAlt5_4 pappyErr5 =
              case lojbanKOhA d of
                Parsed "ko'o" pappyDvs7 pappyErr7 ->
                  Parsed (
                    4) pappyDvs7 (max pappyErr7 pappyErr5)
                _ -> pappyAlt5_5 (max (ParseError (lojbanPos d) [Expected "ko'o"]) pappyErr5)
            pappyAlt5_5 pappyErr5 =
              case lojbanKOhA d of
                Parsed "ko'u" pappyDvs7 pappyErr7 ->
                  Parsed (
                    5) pappyDvs7 (max pappyErr7 pappyErr5)
                _ -> pappyAlt5_6 (max (ParseError (lojbanPos d) [Expected "ko'u"]) pappyErr5)
            pappyAlt5_6 pappyErr5 =
              case lojbanKOhA d of
                Parsed "fo'a" pappyDvs7 pappyErr7 ->
                  Parsed (
                    6) pappyDvs7 (max pappyErr7 pappyErr5)
                _ -> pappyAlt5_7 (max (ParseError (lojbanPos d) [Expected "fo'a"]) pappyErr5)
            pappyAlt5_7 pappyErr5 =
              case lojbanKOhA d of
                Parsed "fo'e" pappyDvs7 pappyErr7 ->
                  Parsed (
                    7) pappyDvs7 (max pappyErr7 pappyErr5)
                _ -> pappyAlt5_8 (max (ParseError (lojbanPos d) [Expected "fo'e"]) pappyErr5)
            pappyAlt5_8 pappyErr5 =
              case lojbanKOhA d of
                Parsed "fo'i" pappyDvs7 pappyErr7 ->
                  Parsed (
                    8) pappyDvs7 (max pappyErr7 pappyErr5)
                _ -> pappyAlt5_9 (max (ParseError (lojbanPos d) [Expected "fo'i"]) pappyErr5)
            pappyAlt5_9 pappyErr5 =
              case lojbanKOhA d of
                Parsed "fo'o" pappyDvs7 pappyErr7 ->
                  Parsed (
                    9) pappyDvs7 (max pappyErr7 pappyErr5)
                _ -> pappyAlt5_10 (max (ParseError (lojbanPos d) [Expected "fo'o"]) pappyErr5)
            pappyAlt5_10 pappyErr5 =
              case lojbanKOhA d of
                Parsed "fo'u" pappyDvs7 pappyErr7 ->
                  Parsed (
                    10) pappyDvs7 (max pappyErr7 pappyErr5)
                _ -> pappyAlt5_11 (max (ParseError (lojbanPos d) [Expected "fo'u"]) pappyErr5)
            pappyAlt5_11 pappyErr5 = NoParse pappyErr5
    pappyAlt1_17 pappyErr1 =
      case pappyResult3 of
        Parsed n pappyDvs3 pappyErr3 ->
          case pappyResult5 of
            Parsed mn pappyDvs5 pappyErr5 ->
              Parsed (
                MainBridiSumbasti $ fromMaybe n mn) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_18 (maximum [pappyErr5,pappyErr3,pappyErr1])
          where
            pappyResult5 =
              case lojbanxiLit pappyDvs3 of
                Parsed pappyVal7 pappyDvs7 pappyErr7 -> Parsed (Just pappyVal7) pappyDvs7 pappyErr7
                NoParse pappyErr7 -> Parsed (Nothing) pappyDvs3 pappyErr7
        NoParse pappyErr3 -> pappyAlt1_18 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          pappyAlt5_1 (ParseError (lojbanPos d) []) where
            pappyAlt5_1 pappyErr5 =
              case lojbanKOhA d of
                Parsed "vo'a" pappyDvs7 pappyErr7 ->
                  Parsed (
                    1) pappyDvs7 (max pappyErr7 pappyErr5)
                _ -> pappyAlt5_2 (max (ParseError (lojbanPos d) [Expected "vo'a"]) pappyErr5)
            pappyAlt5_2 pappyErr5 =
              case lojbanKOhA d of
                Parsed "vo'e" pappyDvs7 pappyErr7 ->
                  Parsed (
                    2) pappyDvs7 (max pappyErr7 pappyErr5)
                _ -> pappyAlt5_3 (max (ParseError (lojbanPos d) [Expected "vo'e"]) pappyErr5)
            pappyAlt5_3 pappyErr5 =
              case lojbanKOhA d of
                Parsed "vo'i" pappyDvs7 pappyErr7 ->
                  Parsed (
                    3) pappyDvs7 (max pappyErr7 pappyErr5)
                _ -> pappyAlt5_4 (max (ParseError (lojbanPos d) [Expected "vo'i"]) pappyErr5)
            pappyAlt5_4 pappyErr5 =
              case lojbanKOhA d of
                Parsed "vo'o" pappyDvs7 pappyErr7 ->
                  Parsed (
                    4) pappyDvs7 (max pappyErr7 pappyErr5)
                _ -> pappyAlt5_5 (max (ParseError (lojbanPos d) [Expected "vo'o"]) pappyErr5)
            pappyAlt5_5 pappyErr5 =
              case lojbanKOhA d of
                Parsed "vo'u" pappyDvs7 pappyErr7 ->
                  Parsed (
                    5) pappyDvs7 (max pappyErr7 pappyErr5)
                _ -> pappyAlt5_6 (max (ParseError (lojbanPos d) [Expected "vo'u"]) pappyErr5)
            pappyAlt5_6 pappyErr5 = NoParse pappyErr5
    pappyAlt1_18 pappyErr1 =
      case lojbanKOhA d of
        Parsed "zo'e" pappyDvs3 pappyErr3 ->
          Parsed (
            Zohe) pappyDvs3 (max pappyErr3 pappyErr1)
        _ -> pappyAlt1_19 (max (ParseError (lojbanPos d) [Expected "zo'e"]) pappyErr1)
    pappyAlt1_19 pappyErr1 =
      case lojbanKOhA d of
        Parsed k pappyDvs3 pappyErr3 ->
          case (k `elem` ["zi'o","zu'i"]) of
            True ->
              Parsed (
                NonAnaphoricProsumti k) pappyDvs3 (max pappyErr3 pappyErr1)
            False -> pappyAlt1_20 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_20 (max pappyErr3 pappyErr1)
    pappyAlt1_20 pappyErr1 =
      case lojbanKOhA d of
        Parsed "ma" pappyDvs3 pappyErr3 ->
          Parsed (
            SumtiQ Nothing) pappyDvs3 (max pappyErr3 pappyErr1)
        _ -> pappyAlt1_21 (max (ParseError (lojbanPos d) [Expected "ma"]) pappyErr1)
    pappyAlt1_21 pappyErr1 =
      case lojbanLA d of
        Parsed g pappyDvs3 pappyErr3 ->
          case lojbanname pappyDvs3 of
            Parsed n pappyDvs5 pappyErr5 ->
              Parsed (
                n g) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_22 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_22 (max pappyErr3 pappyErr1)
    pappyAlt1_22 pappyErr1 =
      case pappyResult3 of
        Parsed g pappyDvs3 pappyErr3 ->
          case pappyResult5 of
            Parsed ((is,q,ssb,rels,irels)) pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed _ pappyDvs7 pappyErr7 ->
                  Parsed (
                    Description g is q ssb rels irels) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_23 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case lojbanKU pappyDvs5 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs5 pappyErr9
            Parsed _ _ _ -> pappyAlt1_23 (max pappyErr3 pappyErr1)
            NoParse pappyErr5 -> pappyAlt1_23 (maximum [pappyErr5,pappyErr3,pappyErr1])
          where
            pappyResult5 =
              pappyAlt7_1 (ParseError (lojbanPos pappyDvs3) []) where
                pappyAlt7_1 pappyErr7 =
                  case lojbansumti6 pappyDvs3 of
                    Parsed s pappyDvs9 pappyErr9 ->
                      case lojbanmaybeRelativeClauses pappyDvs9 of
                        Parsed srels pappyDvs11 pappyErr11 ->
                          case lojbansumtiTail1 pappyDvs11 of
                            Parsed ((q,ssb,irels)) pappyDvs13 pappyErr13 ->
                              Parsed (
                                (Just (QAtom [] Nothing srels s),q,ssb,[],irels)) pappyDvs13 (maximum [pappyErr13,pappyErr11,pappyErr9,pappyErr7])
                            Parsed _ _ _ -> pappyAlt7_2 (maximum [pappyErr11,pappyErr9,pappyErr7])
                            NoParse pappyErr13 -> pappyAlt7_2 (maximum [pappyErr13,pappyErr11,pappyErr9,pappyErr7])
                        NoParse pappyErr11 -> pappyAlt7_2 (maximum [pappyErr11,pappyErr9,pappyErr7])
                    NoParse pappyErr9 -> pappyAlt7_2 (max pappyErr9 pappyErr7)
                pappyAlt7_2 pappyErr7 =
                  case lojbanmaybeRelativeClauses pappyDvs3 of
                    Parsed rels pappyDvs9 pappyErr9 ->
                      case lojbansumtiTail1 pappyDvs9 of
                        Parsed ((q,ssb,irels)) pappyDvs11 pappyErr11 ->
                          Parsed (
                            (Nothing,q,ssb,rels,irels)) pappyDvs11 (maximum [pappyErr11,pappyErr9,pappyErr7])
                        Parsed _ _ _ -> pappyAlt7_3 (max pappyErr9 pappyErr7)
                        NoParse pappyErr11 -> pappyAlt7_3 (maximum [pappyErr11,pappyErr9,pappyErr7])
                    NoParse pappyErr9 -> pappyAlt7_3 (max pappyErr9 pappyErr7)
                pappyAlt7_3 pappyErr7 = NoParse pappyErr7
        NoParse pappyErr3 -> pappyAlt1_23 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          pappyAlt5_1 (ParseError (lojbanPos d) []) where
            pappyAlt5_1 pappyErr5 =
              case lojbanLA d of
                Parsed pappyVal7 pappyDvs7 pappyErr7 -> Parsed pappyVal7 pappyDvs7 (max pappyErr7 pappyErr5)
                NoParse pappyErr7 -> pappyAlt5_2 (max pappyErr7 pappyErr5)
            pappyAlt5_2 pappyErr5 =
              case pappyResult7 of
                Parsed s pappyDvs7 pappyErr7 ->
                  case lojbanpostClause pappyDvs7 of
                    Parsed _ pappyDvs9 pappyErr9 ->
                      Parsed (s) pappyDvs9 (maximum [pappyErr9,pappyErr7,pappyErr5])
                    NoParse pappyErr9 -> pappyAlt5_3 (maximum [pappyErr9,pappyErr7,pappyErr5])
                NoParse pappyErr7 -> pappyAlt5_3 (max pappyErr7 pappyErr5)
              where
                pappyResult7 =
                  case lojbanChar d of
                    Parsed 'l' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'e' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed '\'' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed 'i' pappyDvs15 _ ->
                                  Parsed (
                                    "le'i") pappyDvs15 (ParseError (lojbanPos pappyDvs15) [])
                                Parsed 'e' pappyDvs15 _ ->
                                  Parsed (
                                    "le'e") pappyDvs15 (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            Parsed 'i' pappyDvs13 _ ->
                              Parsed (
                                "lei") pappyDvs13 (ParseError (lojbanPos pappyDvs13) [])
                            _ ->
                              Parsed (
                                "le") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        Parsed 'o' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed '\'' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed 'i' pappyDvs15 _ ->
                                  Parsed (
                                    "lo'i") pappyDvs15 (ParseError (lojbanPos pappyDvs15) [])
                                Parsed 'e' pappyDvs15 _ ->
                                  Parsed (
                                    "lo'e") pappyDvs15 (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            Parsed 'i' pappyDvs13 _ ->
                              Parsed (
                                "loi") pappyDvs13 (ParseError (lojbanPos pappyDvs13) [])
                            _ ->
                              Parsed (
                                "lo") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos d) [])
            pappyAlt5_3 pappyErr5 = NoParse pappyErr5
    pappyAlt1_23 pappyErr1 =
      pappyAlt3_1 pappyErr1 where
        pappyAlt3_1 pappyErr3 =
          case lojbanLI d of
            Parsed "li" pappyDvs5 pappyErr5 ->
              case lojbanmex pappyDvs5 of
                Parsed m pappyDvs7 pappyErr7 ->
                  case pappyResult9 of
                    Parsed _ pappyDvs9 pappyErr9 ->
                      Parsed (
                         MexLi m ) pappyDvs9 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3])
                    NoParse pappyErr9 -> pappyAlt3_2 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3])
                  where
                    pappyResult9 =
                      case lojbanLOhO pappyDvs7 of
                        Parsed pappyVal11 pappyDvs11 pappyErr11 -> Parsed (Just pappyVal11) pappyDvs11 pappyErr11
                        NoParse pappyErr11 -> Parsed (Nothing) pappyDvs7 pappyErr11
                NoParse pappyErr7 -> pappyAlt3_2 (maximum [pappyErr7,pappyErr5,pappyErr3])
            _ -> pappyAlt3_2 (max (ParseError (lojbanPos d) [Expected "li"]) pappyErr3)
        pappyAlt3_2 pappyErr3 =
          case lojbanLI d of
            Parsed "me'o" pappyDvs5 pappyErr5 ->
              case lojbanmex pappyDvs5 of
                Parsed m pappyDvs7 pappyErr7 ->
                  case pappyResult9 of
                    Parsed _ pappyDvs9 pappyErr9 ->
                      Parsed (
                         MexMex m ) pappyDvs9 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3])
                    NoParse pappyErr9 -> pappyAlt3_3 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3])
                  where
                    pappyResult9 =
                      case lojbanLOhO pappyDvs7 of
                        Parsed pappyVal11 pappyDvs11 pappyErr11 -> Parsed (Just pappyVal11) pappyDvs11 pappyErr11
                        NoParse pappyErr11 -> Parsed (Nothing) pappyDvs7 pappyErr11
                NoParse pappyErr7 -> pappyAlt3_3 (maximum [pappyErr7,pappyErr5,pappyErr3])
            _ -> pappyAlt3_3 (max (ParseError (lojbanPos d) [Expected "me'o"]) pappyErr3)
        pappyAlt3_3 pappyErr3 = pappyAlt1_24 pappyErr3
    pappyAlt1_24 pappyErr1 = NoParse pappyErr1

lojbanParsequalifier :: LojbanDerivs -> Result LojbanDerivs (SumtiQualifier)
lojbanParsequalifier d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case pappyResult3 of
        Parsed l pappyDvs3 pappyErr3 ->
          case lojbanpostClause pappyDvs3 of
            Parsed _ pappyDvs5 pappyErr5 ->
              Parsed (
                LAhE l) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanChar d of
            Parsed 't' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'u' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'a' pappyDvs11 _ ->
                          Parsed (
                            "tu'a") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'l' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'u' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'a' pappyDvs11 _ ->
                          Parsed (
                            "lu'a") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        Parsed 'o' pappyDvs11 _ ->
                          Parsed (
                            "lu'o") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        Parsed 'i' pappyDvs11 _ ->
                          Parsed (
                            "lu'i") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        Parsed 'e' pappyDvs11 _ ->
                          Parsed (
                            "lu'e") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'a' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'e' pappyDvs11 _ ->
                          Parsed (
                            "la'e") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'v' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'u' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'i' pappyDvs11 _ ->
                          Parsed (
                            "vu'i") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos d) [])
    pappyAlt1_2 pappyErr1 =
      case lojbanNAhE d of
        Parsed n pappyDvs3 pappyErr3 ->
          case lojbanBO pappyDvs3 of
            Parsed _ pappyDvs5 pappyErr5 ->
              Parsed (
                NAhE_BO n) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_3 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanParsePlusRule7 :: LojbanDerivs -> Result LojbanDerivs ([String])
lojbanParsePlusRule7 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanCMENE d of
        Parsed v pappyDvs3 pappyErr3 ->
          case lojbanPlusRule7 pappyDvs3 of
            Parsed vs pappyDvs5 pappyErr5 ->
              Parsed (
                v : vs) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbanCMENE d of
        Parsed v pappyDvs3 pappyErr3 ->
          Parsed (
            [v]) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanname :: LojbanDerivs -> Result LojbanDerivs (Gadri -> SumtiAtom)
lojbanname d =
  case lojbanmaybeRelativeClauses d of
    Parsed rels pappyDvs1 pappyErr1 ->
      case lojbanPlusRule7 pappyDvs1 of
        Parsed cs pappyDvs3 pappyErr3 ->
          Parsed (
            \g -> Name g rels $ unwords cs) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1

lojbanParseStarRule17 :: LojbanDerivs -> Result LojbanDerivs ([String])
lojbanParseStarRule17 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case pappyResult3 of
        Parsed v pappyDvs3 pappyErr3 ->
          case lojbanStarRule17 pappyDvs3 of
            Parsed vs pappyDvs5 pappyErr5 ->
              Parsed (
                v : vs) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanWord d of
            Parsed w pappyDvs5 pappyErr5 ->
              case (w/="zoi") of
                True ->
                  Parsed (w) pappyDvs5 pappyErr5
                False -> NoParse pappyErr5
            NoParse pappyErr5 -> NoParse pappyErr5
    pappyAlt1_2 pappyErr1 =
      Parsed (
        []) d pappyErr1
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanParseStarRule18 :: LojbanDerivs -> Result LojbanDerivs ([String])
lojbanParseStarRule18 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case pappyResult3 of
        Parsed v pappyDvs3 pappyErr3 ->
          case lojbanStarRule18 pappyDvs3 of
            Parsed vs pappyDvs5 pappyErr5 ->
              Parsed (
                v : vs) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanWord d of
            Parsed w pappyDvs5 pappyErr5 ->
              case (w/="gy") of
                True ->
                  Parsed (w) pappyDvs5 pappyErr5
                False -> NoParse pappyErr5
            NoParse pappyErr5 -> NoParse pappyErr5
    pappyAlt1_2 pappyErr1 =
      Parsed (
        []) d pappyErr1
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanParseStarRule19 :: LojbanDerivs -> Result LojbanDerivs ([String])
lojbanParseStarRule19 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanLEhU d of
        NoParse pappyErr3 ->
          case lojbanValsi d of
            Parsed v pappyDvs5 pappyErr5 ->
              case lojbanStarRule19 pappyDvs5 of
                Parsed vs pappyDvs7 pappyErr7 ->
                  Parsed (
                    v : vs) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_2 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        Parsed _ _ pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      Parsed (
        []) d pappyErr1
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanParsesumtiTail1 :: LojbanDerivs -> Result LojbanDerivs ((Maybe Mex, Either Selbri Sumti, [RelClause]))
lojbanParsesumtiTail1 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanselbri d of
        Parsed sb pappyDvs3 pappyErr3 ->
          case lojbanmaybeRelativeClauses pappyDvs3 of
            Parsed rels pappyDvs5 pappyErr5 ->
              Parsed (
                (Nothing,Left sb,rels)) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case pappyResult3 of
        Parsed mq pappyDvs3 pappyErr3 ->
          case lojbanselbri pappyDvs3 of
            Parsed sb pappyDvs5 pappyErr5 ->
              case lojbanmaybeRelativeClauses pappyDvs5 of
                Parsed rels pappyDvs7 pappyErr7 ->
                  Parsed (
                    (mq,Left sb,rels)) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_3 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_3 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanquantifier d of
            Parsed pappyVal5 pappyDvs5 pappyErr5 -> Parsed (Just pappyVal5) pappyDvs5 pappyErr5
            NoParse pappyErr5 -> Parsed (Nothing) d pappyErr5
    pappyAlt1_3 pappyErr1 =
      case lojbanquantifier d of
        Parsed q pappyDvs3 pappyErr3 ->
          case lojbansumti pappyDvs3 of
            Parsed s pappyDvs5 pappyErr5 ->
              Parsed (
                (Just q,Right s,[])) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_4 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_4 (max pappyErr3 pappyErr1)
    pappyAlt1_4 pappyErr1 = NoParse pappyErr1

lojbanmaybeRelativeClauses :: LojbanDerivs -> Result LojbanDerivs ([RelClause])
lojbanmaybeRelativeClauses d =
  case pappyResult1 of
    Parsed mrels pappyDvs1 pappyErr1 ->
      Parsed (
        fromMaybe [] mrels) pappyDvs1 pappyErr1
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanrelativeClauses d of
        Parsed pappyVal3 pappyDvs3 pappyErr3 -> Parsed (Just pappyVal3) pappyDvs3 pappyErr3
        NoParse pappyErr3 -> Parsed (Nothing) d pappyErr3

lojbanParseStarRule20 :: LojbanDerivs -> Result LojbanDerivs ([RelClause])
lojbanParseStarRule20 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case pappyResult3 of
        Parsed s pappyDvs3 pappyErr3 ->
          case lojbanpostClause pappyDvs3 of
            Parsed _ pappyDvs5 pappyErr5 ->
              case lojbanrelativeClause pappyDvs5 of
                Parsed v pappyDvs7 pappyErr7 ->
                  case lojbanStarRule20 pappyDvs7 of
                    Parsed vs pappyDvs9 pappyErr9 ->
                      Parsed (
                        v : vs) pappyDvs9 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                    NoParse pappyErr9 -> pappyAlt1_2 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_2 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanChar d of
            Parsed 'z' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'i' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'e' pappyDvs11 _ ->
                          Parsed (
                            "zi'e") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos d) [])
    pappyAlt1_2 pappyErr1 =
      Parsed (
        []) d pappyErr1
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanrelativeClauses :: LojbanDerivs -> Result LojbanDerivs ([RelClause])
lojbanrelativeClauses d =
  case lojbanrelativeClause d of
    Parsed r pappyDvs1 pappyErr1 ->
      case lojbanStarRule20 pappyDvs1 of
        Parsed rs pappyDvs3 pappyErr3 ->
          Parsed (
            (r:rs)) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1

lojbanParserelativeClause :: LojbanDerivs -> Result LojbanDerivs (RelClause)
lojbanParserelativeClause d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanNOI d of
        Parsed "poi" pappyDvs3 pappyErr3 ->
          case lojbansubsentence pappyDvs3 of
            Parsed subs pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed _ pappyDvs7 pappyErr7 ->
                  Parsed (
                    Restrictive subs) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_2 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case lojbanKUhO pappyDvs5 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs5 pappyErr9
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        _ -> pappyAlt1_2 (max (ParseError (lojbanPos d) [Expected "poi"]) pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbanNOI d of
        Parsed "noi" pappyDvs3 pappyErr3 ->
          case lojbansubsentence pappyDvs3 of
            Parsed subs pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed _ pappyDvs7 pappyErr7 ->
                  Parsed (
                    Incidental subs) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_3 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case lojbanKUhO pappyDvs5 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs5 pappyErr9
            NoParse pappyErr5 -> pappyAlt1_3 (maximum [pappyErr5,pappyErr3,pappyErr1])
        _ -> pappyAlt1_3 (max (ParseError (lojbanPos d) [Expected "noi"]) pappyErr1)
    pappyAlt1_3 pappyErr1 =
      case lojbanNOI d of
        Parsed "voi" pappyDvs3 pappyErr3 ->
          case lojbansubsentence pappyDvs3 of
            Parsed subs pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed _ pappyDvs7 pappyErr7 ->
                  Parsed (
                    Descriptive subs) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_4 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case lojbanKUhO pappyDvs5 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs5 pappyErr9
            NoParse pappyErr5 -> pappyAlt1_4 (maximum [pappyErr5,pappyErr3,pappyErr1])
        _ -> pappyAlt1_4 (max (ParseError (lojbanPos d) [Expected "voi"]) pappyErr1)
    pappyAlt1_4 pappyErr1 =
      case lojbanGOI d of
        Parsed "goi" pappyDvs3 pappyErr3 ->
          case lojbanterm pappyDvs3 of
            Parsed t pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed _ pappyDvs7 pappyErr7 ->
                  Parsed (
                    Assignment t) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_5 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case lojbanGEhU pappyDvs5 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs5 pappyErr9
            NoParse pappyErr5 -> pappyAlt1_5 (maximum [pappyErr5,pappyErr3,pappyErr1])
        _ -> pappyAlt1_5 (max (ParseError (lojbanPos d) [Expected "goi"]) pappyErr1)
    pappyAlt1_5 pappyErr1 =
      case lojbanGOI d of
        Parsed "ne" pappyDvs3 pappyErr3 ->
          case lojbanterm pappyDvs3 of
            Parsed t pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed _ pappyDvs7 pappyErr7 ->
                  Parsed (
                    IncidentalGOI "ne" t) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_6 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case lojbanGEhU pappyDvs5 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs5 pappyErr9
            NoParse pappyErr5 -> pappyAlt1_6 (maximum [pappyErr5,pappyErr3,pappyErr1])
        _ -> pappyAlt1_6 (max (ParseError (lojbanPos d) [Expected "ne"]) pappyErr1)
    pappyAlt1_6 pappyErr1 =
      case lojbanGOI d of
        Parsed "no'u" pappyDvs3 pappyErr3 ->
          case lojbanterm pappyDvs3 of
            Parsed t pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed _ pappyDvs7 pappyErr7 ->
                  Parsed (
                    IncidentalGOI "no'u" t) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case lojbanGEhU pappyDvs5 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs5 pappyErr9
            NoParse pappyErr5 -> pappyAlt1_7 (maximum [pappyErr5,pappyErr3,pappyErr1])
        _ -> pappyAlt1_7 (max (ParseError (lojbanPos d) [Expected "no'u"]) pappyErr1)
    pappyAlt1_7 pappyErr1 =
      case lojbanGOI d of
        Parsed "pe" pappyDvs3 pappyErr3 ->
          case lojbanterm pappyDvs3 of
            Parsed t pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed _ pappyDvs7 pappyErr7 ->
                  Parsed (
                    RestrictiveGOI "pe" t) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_8 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case lojbanGEhU pappyDvs5 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs5 pappyErr9
            NoParse pappyErr5 -> pappyAlt1_8 (maximum [pappyErr5,pappyErr3,pappyErr1])
        _ -> pappyAlt1_8 (max (ParseError (lojbanPos d) [Expected "pe"]) pappyErr1)
    pappyAlt1_8 pappyErr1 =
      case lojbanGOI d of
        Parsed "po'u" pappyDvs3 pappyErr3 ->
          case lojbanterm pappyDvs3 of
            Parsed t pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed _ pappyDvs7 pappyErr7 ->
                  Parsed (
                    RestrictiveGOI "po'u" t) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_9 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case lojbanGEhU pappyDvs5 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs5 pappyErr9
            NoParse pappyErr5 -> pappyAlt1_9 (maximum [pappyErr5,pappyErr3,pappyErr1])
        _ -> pappyAlt1_9 (max (ParseError (lojbanPos d) [Expected "po'u"]) pappyErr1)
    pappyAlt1_9 pappyErr1 =
      case lojbanGOI d of
        Parsed "po" pappyDvs3 pappyErr3 ->
          case lojbanterm pappyDvs3 of
            Parsed t pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed _ pappyDvs7 pappyErr7 ->
                  Parsed (
                    RestrictiveGOI "po" t) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_10 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case lojbanGEhU pappyDvs5 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs5 pappyErr9
            NoParse pappyErr5 -> pappyAlt1_10 (maximum [pappyErr5,pappyErr3,pappyErr1])
        _ -> pappyAlt1_10 (max (ParseError (lojbanPos d) [Expected "po"]) pappyErr1)
    pappyAlt1_10 pappyErr1 =
      case lojbanGOI d of
        Parsed "po'e" pappyDvs3 pappyErr3 ->
          case lojbanterm pappyDvs3 of
            Parsed t pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed _ pappyDvs7 pappyErr7 ->
                  Parsed (
                    RestrictiveGOI "po'e" t) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_11 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case lojbanGEhU pappyDvs5 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs5 pappyErr9
            NoParse pappyErr5 -> pappyAlt1_11 (maximum [pappyErr5,pappyErr3,pappyErr1])
        _ -> pappyAlt1_11 (max (ParseError (lojbanPos d) [Expected "po'e"]) pappyErr1)
    pappyAlt1_11 pappyErr1 = NoParse pappyErr1

lojbanselbri :: LojbanDerivs -> Result LojbanDerivs (Selbri)
lojbanselbri d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbantag d of
        Parsed tag pappyDvs3 pappyErr3 ->
          case lojbanselbri1 pappyDvs3 of
            Parsed sb pappyDvs5 pappyErr5 ->
              Parsed (
                TaggedSelbri tag sb) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbanselbri1 d of
        Parsed pappyVal3 pappyDvs3 pappyErr3 -> Parsed pappyVal3 pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanParseselbri1 :: LojbanDerivs -> Result LojbanDerivs (Selbri)
lojbanParseselbri1 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanNA d of
        Parsed "na" pappyDvs3 pappyErr3 ->
          case lojbanselbri pappyDvs3 of
            Parsed sb pappyDvs5 pappyErr5 ->
              Parsed (
                Negated sb) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        _ -> pappyAlt1_2 (max (ParseError (lojbanPos d) [Expected "na"]) pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbanNA d of
        Parsed "ja'a" pappyDvs3 pappyErr3 ->
          case lojbanselbri pappyDvs3 of
            Parsed sb pappyDvs5 pappyErr5 ->
              Parsed (sb) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_3 (maximum [pappyErr5,pappyErr3,pappyErr1])
        _ -> pappyAlt1_3 (max (ParseError (lojbanPos d) [Expected "ja'a"]) pappyErr1)
    pappyAlt1_3 pappyErr1 =
      case lojbanselbri2 d of
        Parsed sb pappyDvs3 pappyErr3 ->
          Parsed (
            Selbri2 sb) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_4 (max pappyErr3 pappyErr1)
    pappyAlt1_4 pappyErr1 = NoParse pappyErr1

lojbanParseselbri2 :: LojbanDerivs -> Result LojbanDerivs (Selbri2)
lojbanParseselbri2 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanselbri3 d of
        Parsed sb pappyDvs3 pappyErr3 ->
          case pappyResult5 of
            Parsed s pappyDvs5 pappyErr5 ->
              case lojbanpostClause pappyDvs5 of
                Parsed _ pappyDvs7 pappyErr7 ->
                  case lojbanselbri2 pappyDvs7 of
                    Parsed sb' pappyDvs9 pappyErr9 ->
                      Parsed (
                        SBInverted sb sb') pappyDvs9 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                    NoParse pappyErr9 -> pappyAlt1_2 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_2 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
          where
            pappyResult5 =
              case lojbanChar pappyDvs3 of
                Parsed 'c' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'o' pappyDvs9 _ ->
                      Parsed (
                        "co") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbanselbri3 d of
        Parsed sb pappyDvs3 pappyErr3 ->
          Parsed (
            Selbri3 sb) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanParseselbri3Tail :: LojbanDerivs -> Result LojbanDerivs ((Selbri3 -> Selbri3))
lojbanParseselbri3Tail d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanselbri4 d of
        Parsed sb' pappyDvs3 pappyErr3 ->
          case lojbanselbri3Tail pappyDvs3 of
            Parsed pappyTail pappyDvs5 pappyErr5 ->
              Parsed (
                \sb -> pappyTail (SBTanru sb sb')) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      Parsed (
        \v -> v) d pappyErr1
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanselbri3 :: LojbanDerivs -> Result LojbanDerivs (Selbri3)
lojbanselbri3 d =
  case lojbanselbri4 d of
    Parsed l pappyDvs1 pappyErr1 ->
      case lojbanselbri3Tail pappyDvs1 of
        Parsed t pappyDvs3 pappyErr3 ->
          Parsed (
            t l) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1

lojbanParseStarRule21 :: LojbanDerivs -> Result LojbanDerivs ([(Connective, Selbri3)])
lojbanParseStarRule21 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case pappyResult3 of
        Parsed v pappyDvs3 pappyErr3 ->
          case lojbanStarRule21 pappyDvs3 of
            Parsed vs pappyDvs5 pappyErr5 ->
              Parsed (
                v : vs) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          pappyAlt5_1 (ParseError (lojbanPos d) []) where
            pappyAlt5_1 pappyErr5 =
              case lojbanjoikJek d of
                Parsed jj pappyDvs7 pappyErr7 ->
                  case lojbanselbri5 pappyDvs7 of
                    Parsed sb pappyDvs9 pappyErr9 ->
                      Parsed (
                        (jjJboCon Nothing jj,sb)) pappyDvs9 (maximum [pappyErr9,pappyErr7,pappyErr5])
                    NoParse pappyErr9 -> pappyAlt5_2 (maximum [pappyErr9,pappyErr7,pappyErr5])
                NoParse pappyErr7 -> pappyAlt5_2 (max pappyErr7 pappyErr5)
            pappyAlt5_2 pappyErr5 =
              case lojbanjoik d of
                Parsed joik pappyDvs7 pappyErr7 ->
                  case pappyResult9 of
                    Parsed mtag pappyDvs9 pappyErr9 ->
                      case lojbanKE pappyDvs9 of
                        Parsed _ pappyDvs11 pappyErr11 ->
                          case lojbanselbri3 pappyDvs11 of
                            Parsed sb pappyDvs13 pappyErr13 ->
                              case pappyResult15 of
                                Parsed _ pappyDvs15 pappyErr15 ->
                                  Parsed (
                                    (JboConnJoik mtag joik,sb)) pappyDvs15 (maximum [pappyErr15,pappyErr13,pappyErr11,pappyErr9,pappyErr7,pappyErr5])
                                NoParse pappyErr15 -> pappyAlt5_3 (maximum [pappyErr15,pappyErr13,pappyErr11,pappyErr9,pappyErr7,pappyErr5])
                              where
                                pappyResult15 =
                                  case lojbanKEhE pappyDvs13 of
                                    Parsed pappyVal17 pappyDvs17 pappyErr17 -> Parsed (Just pappyVal17) pappyDvs17 pappyErr17
                                    NoParse pappyErr17 -> Parsed (Nothing) pappyDvs13 pappyErr17
                            NoParse pappyErr13 -> pappyAlt5_3 (maximum [pappyErr13,pappyErr11,pappyErr9,pappyErr7,pappyErr5])
                        NoParse pappyErr11 -> pappyAlt5_3 (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5])
                    NoParse pappyErr9 -> pappyAlt5_3 (maximum [pappyErr9,pappyErr7,pappyErr5])
                  where
                    pappyResult9 =
                      case lojbantag pappyDvs7 of
                        Parsed pappyVal11 pappyDvs11 pappyErr11 -> Parsed (Just pappyVal11) pappyDvs11 pappyErr11
                        NoParse pappyErr11 -> Parsed (Nothing) pappyDvs7 pappyErr11
                NoParse pappyErr7 -> pappyAlt5_3 (max pappyErr7 pappyErr5)
            pappyAlt5_3 pappyErr5 = NoParse pappyErr5
    pappyAlt1_2 pappyErr1 =
      Parsed (
        []) d pappyErr1
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanselbri4 :: LojbanDerivs -> Result LojbanDerivs (Selbri3)
lojbanselbri4 d =
  case lojbanselbri5 d of
    Parsed sb pappyDvs1 pappyErr1 ->
      case lojbanStarRule21 pappyDvs1 of
        Parsed jekss pappyDvs3 pappyErr3 ->
          Parsed (
             foldl (\sb1 -> \(con,sb2) -> ConnectedSB False con (sb3tosb sb1) sb2) sb jekss ) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1

lojbanParseselbri5 :: LojbanDerivs -> Result LojbanDerivs (Selbri3)
lojbanParseselbri5 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanselbri6 d of
        Parsed sb1 pappyDvs3 pappyErr3 ->
          case lojbanjoikJek pappyDvs3 of
            Parsed jj pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed mtag pappyDvs7 pappyErr7 ->
                  case lojbanBO pappyDvs7 of
                    Parsed _ pappyDvs9 pappyErr9 ->
                      case lojbanselbri5 pappyDvs9 of
                        Parsed sb2 pappyDvs11 pappyErr11 ->
                          Parsed (
                             ConnectedSB False (jjJboCon mtag jj) (sb3tosb sb1) sb2 ) pappyDvs11 (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                        NoParse pappyErr11 -> pappyAlt1_2 (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                    NoParse pappyErr9 -> pappyAlt1_2 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_2 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case lojbantag pappyDvs5 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs5 pappyErr9
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbanselbri6 d of
        Parsed pappyVal3 pappyDvs3 pappyErr3 -> Parsed pappyVal3 pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanParseselbri6 :: LojbanDerivs -> Result LojbanDerivs (Selbri3)
lojbanParseselbri6 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbantanruUnit d of
        Parsed tu pappyDvs3 pappyErr3 ->
          case lojbanBO pappyDvs3 of
            Parsed _ pappyDvs5 pappyErr5 ->
              case lojbanselbri6 pappyDvs5 of
                Parsed sb pappyDvs7 pappyErr7 ->
                  Parsed (
                    SBTanru tu sb) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_2 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbantanruUnit d of
        Parsed pappyVal3 pappyDvs3 pappyErr3 -> Parsed pappyVal3 pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 =
      case pappyResult3 of
        Parsed mn pappyDvs3 pappyErr3 ->
          case lojbanguhek pappyDvs3 of
            Parsed pcon pappyDvs5 pappyErr5 ->
              case lojbanselbri pappyDvs5 of
                Parsed sb1 pappyDvs7 pappyErr7 ->
                  case lojbangik pappyDvs7 of
                    Parsed b pappyDvs9 pappyErr9 ->
                      case lojbanselbri6 pappyDvs9 of
                        Parsed sb2 pappyDvs11 pappyErr11 ->
                          Parsed (
                             maybe id ScalarNegatedSB mn $
                            	    ConnectedSB True (jboConnLogOrQ Nothing $ pcon b) sb1 sb2 ) pappyDvs11 (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                        NoParse pappyErr11 -> pappyAlt1_4 (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                    NoParse pappyErr9 -> pappyAlt1_4 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_4 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_4 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_4 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanNAhE d of
            Parsed pappyVal5 pappyDvs5 pappyErr5 -> Parsed (Just pappyVal5) pappyDvs5 pappyErr5
            NoParse pappyErr5 -> Parsed (Nothing) d pappyErr5
    pappyAlt1_4 pappyErr1 = NoParse pappyErr1

lojbanParsetanruUnitTail :: LojbanDerivs -> Result LojbanDerivs ((Selbri3 -> Selbri3))
lojbanParsetanruUnitTail d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case pappyResult3 of
        Parsed s pappyDvs3 pappyErr3 ->
          case lojbanpostClause pappyDvs3 of
            Parsed _ pappyDvs5 pappyErr5 ->
              case lojbantanruUnit1 pappyDvs5 of
                Parsed tu' pappyDvs7 pappyErr7 ->
                  case lojbantanruUnitTail pappyDvs7 of
                    Parsed pappyTail pappyDvs9 pappyErr9 ->
                      Parsed (
                        \tu -> pappyTail (BridiBinding tu tu')) pappyDvs9 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                    NoParse pappyErr9 -> pappyAlt1_2 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_2 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanChar d of
            Parsed 'c' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'e' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'i' pappyDvs9 _ ->
                      Parsed (
                        "cei") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos d) [])
    pappyAlt1_2 pappyErr1 =
      Parsed (
        \v -> v) d pappyErr1
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbantanruUnit :: LojbanDerivs -> Result LojbanDerivs (Selbri3)
lojbantanruUnit d =
  case lojbantanruUnit1 d of
    Parsed l pappyDvs1 pappyErr1 ->
      case lojbantanruUnitTail pappyDvs1 of
        Parsed t pappyDvs3 pappyErr3 ->
          Parsed (
            t l) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1

lojbanParseStarRule22 :: LojbanDerivs -> Result LojbanDerivs ([Free])
lojbanParseStarRule22 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanfree d of
        Parsed v pappyDvs3 pappyErr3 ->
          case lojbanStarRule22 pappyDvs3 of
            Parsed vs pappyDvs5 pappyErr5 ->
              Parsed (
                v : vs) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      Parsed (
        []) d pappyErr1
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbantanruUnit1 :: LojbanDerivs -> Result LojbanDerivs (Selbri3)
lojbantanruUnit1 d =
  case lojbantanruUnit2 d of
    Parsed tu pappyDvs1 pappyErr1 ->
      case pappyResult3 of
        Parsed k pappyDvs3 pappyErr3 ->
          case lojbanStarRule22 pappyDvs3 of
            Parsed fs pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed las pappyDvs7 pappyErr7 ->
                  Parsed (
                    TanruUnit fs (maybe tu (TUBridiQ . Just) k) (fromMaybe [] las)) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> NoParse (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case lojbanlinkargs pappyDvs5 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs5 pappyErr9
            NoParse pappyErr5 -> NoParse (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case pappyResult5 of
            Parsed pappyVal5 pappyDvs5 pappyErr5 -> Parsed (Just pappyVal5) pappyDvs5 pappyErr5
            NoParse pappyErr5 -> Parsed (Nothing) pappyDvs1 pappyErr5
          where
            pappyResult5 =
              case lojbanUI pappyDvs1 of
                Parsed "kau" pappyDvs7 pappyErr7 ->
                  case pappyResult9 of
                    Parsed x pappyDvs9 pappyErr9 ->
                      Parsed (
                        fromMaybe 1 x) pappyDvs9 (max pappyErr9 pappyErr7)
                    NoParse pappyErr9 -> NoParse (max pappyErr9 pappyErr7)
                  where
                    pappyResult9 =
                      case lojbanxiLit pappyDvs7 of
                        Parsed pappyVal11 pappyDvs11 pappyErr11 -> Parsed (Just pappyVal11) pappyDvs11 pappyErr11
                        NoParse pappyErr11 -> Parsed (Nothing) pappyDvs7 pappyErr11
                _ -> NoParse (ParseError (lojbanPos pappyDvs1) [Expected "kau"])
    NoParse pappyErr1 -> NoParse pappyErr1

lojbanParsePlusRule8 :: LojbanDerivs -> Result LojbanDerivs ([String])
lojbanParsePlusRule8 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanZEI d of
        Parsed _ pappyDvs3 pappyErr3 ->
          case lojbanValsi pappyDvs3 of
            Parsed v pappyDvs5 pappyErr5 ->
              case lojbanPlusRule8 pappyDvs5 of
                Parsed vs pappyDvs7 pappyErr7 ->
                  Parsed (
                    v : vs) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_2 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbanZEI d of
        Parsed _ pappyDvs3 pappyErr3 ->
          case lojbanValsi pappyDvs3 of
            Parsed v pappyDvs5 pappyErr5 ->
              Parsed (
                [v]) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_3 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanParsetanruUnit2 :: LojbanDerivs -> Result LojbanDerivs (TanruUnit)
lojbanParsetanruUnit2 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanValsi d of
        Parsed v pappyDvs3 pappyErr3 ->
          case lojbanPlusRule8 pappyDvs3 of
            Parsed vs pappyDvs5 pappyErr5 ->
              Parsed (
                TUZei $ v:vs) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbanCMENE d of
        NoParse pappyErr3 ->
          case pappyResult5 of
            NoParse pappyErr5 ->
              case lojbanValsi d of
                Parsed bv pappyDvs7 pappyErr7 ->
                  Parsed (
                    TUBrivla bv) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_3 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            Parsed _ _ pappyErr5 -> pappyAlt1_3 (maximum [pappyErr5,pappyErr3,pappyErr1])
          where
            pappyResult5 =
              pappyAlt7_1 (ParseError (lojbanPos d) []) where
                pappyAlt7_1 pappyErr7 =
                  case lojbanConsonant d of
                    Parsed c pappyDvs9 pappyErr9 ->
                      case lojbanStarRule30 pappyDvs9 of
                        Parsed vs pappyDvs11 pappyErr11 ->
                          case lojbanPlusRule13 pappyDvs11 of
                            Parsed _ pappyDvs13 pappyErr13 ->
                              Parsed (
                                c:vs) pappyDvs13 (maximum [pappyErr13,pappyErr11,pappyErr9,pappyErr7])
                            NoParse pappyErr13 -> pappyAlt7_2 (maximum [pappyErr13,pappyErr11,pappyErr9,pappyErr7])
                        NoParse pappyErr11 -> pappyAlt7_2 (maximum [pappyErr11,pappyErr9,pappyErr7])
                    NoParse pappyErr9 -> pappyAlt7_2 (max pappyErr9 pappyErr7)
                pappyAlt7_2 pappyErr7 =
                  case lojbanPlusRule16 d of
                    Parsed vs pappyDvs9 pappyErr9 ->
                      case lojbanPlusRule13 pappyDvs9 of
                        Parsed _ pappyDvs11 pappyErr11 ->
                          Parsed (vs) pappyDvs11 (maximum [pappyErr11,pappyErr9,pappyErr7])
                        NoParse pappyErr11 -> pappyAlt7_3 (maximum [pappyErr11,pappyErr9,pappyErr7])
                    NoParse pappyErr9 -> pappyAlt7_3 (max pappyErr9 pappyErr7)
                pappyAlt7_3 pappyErr7 = NoParse pappyErr7
        Parsed _ _ pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 =
      case lojbanGOhA d of
        Parsed "mo" pappyDvs3 pappyErr3 ->
          Parsed (
            TUBridiQ Nothing) pappyDvs3 (max pappyErr3 pappyErr1)
        _ -> pappyAlt1_4 (max (ParseError (lojbanPos d) [Expected "mo"]) pappyErr1)
    pappyAlt1_4 pappyErr1 =
      case lojbanGOhA d of
        Parsed g pappyDvs3 pappyErr3 ->
          case pappyResult5 of
            Parsed mn pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed _ pappyDvs7 pappyErr7 ->
                  Parsed (
                    TUGOhA g $ fromMaybe 1 mn) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_5 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case pappyResult9 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs5 pappyErr9
                  where
                    pappyResult9 =
                      case pappyResult11 of
                        Parsed s pappyDvs11 pappyErr11 ->
                          case lojbanpostClause pappyDvs11 of
                            Parsed _ pappyDvs13 pappyErr13 ->
                              Parsed (s) pappyDvs13 (max pappyErr13 pappyErr11)
                            NoParse pappyErr13 -> NoParse (max pappyErr13 pappyErr11)
                        NoParse pappyErr11 -> NoParse pappyErr11
                      where
                        pappyResult11 =
                          case lojbanChar pappyDvs5 of
                            Parsed 'r' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed 'a' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed '\'' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed 'o' pappyDvs19 _ ->
                                          Parsed (
                                            "ra'o") pappyDvs19 (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            NoParse pappyErr5 -> pappyAlt1_5 (maximum [pappyErr5,pappyErr3,pappyErr1])
          where
            pappyResult5 =
              case lojbanxiLit pappyDvs3 of
                Parsed pappyVal7 pappyDvs7 pappyErr7 -> Parsed (Just pappyVal7) pappyDvs7 pappyErr7
                NoParse pappyErr7 -> Parsed (Nothing) pappyDvs3 pappyErr7
        NoParse pappyErr3 -> pappyAlt1_5 (max pappyErr3 pappyErr1)
    pappyAlt1_5 pappyErr1 =
      case lojbanKE d of
        Parsed _ pappyDvs3 pappyErr3 ->
          case lojbanselbri3 pappyDvs3 of
            Parsed sb pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed _ pappyDvs7 pappyErr7 ->
                  Parsed (
                    TUSelbri3 sb) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_6 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case lojbanKEhE pappyDvs5 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs5 pappyErr9
            NoParse pappyErr5 -> pappyAlt1_6 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_6 (max pappyErr3 pappyErr1)
    pappyAlt1_6 pappyErr1 =
      case pappyResult3 of
        Parsed s pappyDvs3 pappyErr3 ->
          case lojbanpostClause pappyDvs3 of
            Parsed _ pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed s pappyDvs7 pappyErr7 ->
                  case pappyResult9 of
                    Parsed _ pappyDvs9 pappyErr9 ->
                      case pappyResult11 of
                        Parsed mmoi pappyDvs11 pappyErr11 ->
                          Parsed (
                            maybe (TUMe s) (TUMoi s) mmoi) pappyDvs11 (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                        NoParse pappyErr11 -> pappyAlt1_7 (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                      where
                        pappyResult11 =
                          case lojbanMOI pappyDvs9 of
                            Parsed pappyVal13 pappyDvs13 pappyErr13 -> Parsed (Just pappyVal13) pappyDvs13 pappyErr13
                            NoParse pappyErr13 -> Parsed (Nothing) pappyDvs9 pappyErr13
                    NoParse pappyErr9 -> pappyAlt1_7 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                  where
                    pappyResult9 =
                      case pappyResult11 of
                        Parsed pappyVal11 pappyDvs11 pappyErr11 -> Parsed (Just pappyVal11) pappyDvs11 pappyErr11
                        NoParse pappyErr11 -> Parsed (Nothing) pappyDvs7 pappyErr11
                      where
                        pappyResult11 =
                          case pappyResult13 of
                            Parsed s pappyDvs13 pappyErr13 ->
                              case lojbanpostClause pappyDvs13 of
                                Parsed _ pappyDvs15 pappyErr15 ->
                                  Parsed (s) pappyDvs15 (max pappyErr15 pappyErr13)
                                NoParse pappyErr15 -> NoParse (max pappyErr15 pappyErr13)
                            NoParse pappyErr13 -> NoParse pappyErr13
                          where
                            pappyResult13 =
                              case lojbanChar pappyDvs7 of
                                Parsed 'm' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'e' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed '\'' pappyDvs19 _ ->
                                          case lojbanChar pappyDvs19 of
                                            Parsed 'u' pappyDvs21 _ ->
                                              Parsed (
                                                "me'u") pappyDvs21 (ParseError (lojbanPos pappyDvs21) [])
                                            _ -> NoParse (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                NoParse pappyErr7 -> pappyAlt1_7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  pappyAlt9_1 (ParseError (lojbanPos pappyDvs5) []) where
                    pappyAlt9_1 pappyErr9 =
                      case lojbansumti pappyDvs5 of
                        Parsed pappyVal11 pappyDvs11 pappyErr11 -> Parsed pappyVal11 pappyDvs11 (max pappyErr11 pappyErr9)
                        NoParse pappyErr11 -> pappyAlt9_2 (max pappyErr11 pappyErr9)
                    pappyAlt9_2 pappyErr9 =
                      case lojbanlerfuString pappyDvs5 of
                        Parsed ls pappyDvs11 pappyErr11 ->
                          Parsed (
                            QAtom [] Nothing [] $ LerfuString ls) pappyDvs11 (max pappyErr11 pappyErr9)
                        NoParse pappyErr11 -> pappyAlt9_3 (max pappyErr11 pappyErr9)
                    pappyAlt9_3 pappyErr9 = NoParse pappyErr9
            NoParse pappyErr5 -> pappyAlt1_7 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_7 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanChar d of
            Parsed 'm' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'e' pappyDvs7 _ ->
                  Parsed (
                    "me") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos d) [])
    pappyAlt1_7 pappyErr1 =
      case lojbannumberOrLerfuString d of
        Parsed q pappyDvs3 pappyErr3 ->
          case lojbanMOI pappyDvs3 of
            Parsed moi pappyDvs5 pappyErr5 ->
              Parsed (
                TUMoi (QAtom [] Nothing [] $ MexLi q) moi) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_8 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_8 (max pappyErr3 pappyErr1)
    pappyAlt1_8 pappyErr1 =
      case pappyResult3 of
        Parsed s pappyDvs3 pappyErr3 ->
          case lojbanpostClause pappyDvs3 of
            Parsed _ pappyDvs5 pappyErr5 ->
              case lojbanmexOperator pappyDvs5 of
                Parsed op pappyDvs7 pappyErr7 ->
                  Parsed (
                    TUOperator op) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_9 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_9 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_9 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanChar d of
            Parsed 'n' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'u' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'a' pappyDvs11 _ ->
                          Parsed (
                            "nu'a") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos d) [])
    pappyAlt1_9 pappyErr1 =
      case lojbanconvSE d of
        Parsed n pappyDvs3 pappyErr3 ->
          case lojbantanruUnit2 pappyDvs3 of
            Parsed tu pappyDvs5 pappyErr5 ->
              Parsed (
                TUPermuted n tu) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_10 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_10 (max pappyErr3 pappyErr1)
    pappyAlt1_10 pappyErr1 =
      case pappyResult3 of
        Parsed s pappyDvs3 pappyErr3 ->
          case lojbanpostClause pappyDvs3 of
            Parsed _ pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed mt pappyDvs7 pappyErr7 ->
                  case lojbantanruUnit2 pappyDvs7 of
                    Parsed tu pappyDvs9 pappyErr9 ->
                      Parsed (
                        TUJai mt tu) pappyDvs9 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                    NoParse pappyErr9 -> pappyAlt1_11 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_11 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case lojbantag pappyDvs5 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs5 pappyErr9
            NoParse pappyErr5 -> pappyAlt1_11 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_11 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanChar d of
            Parsed 'j' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'a' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'i' pappyDvs9 _ ->
                      Parsed (
                        "jai") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos d) [])
    pappyAlt1_11 pappyErr1 =
      case lojbanNAhE d of
        Parsed n pappyDvs3 pappyErr3 ->
          case lojbantanruUnit2 pappyDvs3 of
            Parsed tu pappyDvs5 pappyErr5 ->
              Parsed (
                TUSelbri3 $ ScalarNegatedSB n $ TanruUnit [] tu []) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_12 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_12 (max pappyErr3 pappyErr1)
    pappyAlt1_12 pappyErr1 =
      case lojbanabstractor d of
        Parsed a pappyDvs3 pappyErr3 ->
          case lojbansubsentence pappyDvs3 of
            Parsed ss pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed _ pappyDvs7 pappyErr7 ->
                  Parsed (
                    TUAbstraction a ss) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_13 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case pappyResult9 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs5 pappyErr9
                  where
                    pappyResult9 =
                      case pappyResult11 of
                        Parsed s pappyDvs11 pappyErr11 ->
                          case lojbanpostClause pappyDvs11 of
                            Parsed _ pappyDvs13 pappyErr13 ->
                              Parsed (s) pappyDvs13 (max pappyErr13 pappyErr11)
                            NoParse pappyErr13 -> NoParse (max pappyErr13 pappyErr11)
                        NoParse pappyErr11 -> NoParse pappyErr11
                      where
                        pappyResult11 =
                          case lojbanChar pappyDvs5 of
                            Parsed 'k' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed 'e' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'i' pappyDvs17 _ ->
                                      Parsed (
                                        "kei") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            NoParse pappyErr5 -> pappyAlt1_13 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_13 (max pappyErr3 pappyErr1)
    pappyAlt1_13 pappyErr1 =
      case pappyResult3 of
        Parsed s pappyDvs3 pappyErr3 ->
          case lojbanpostClause pappyDvs3 of
            Parsed _ pappyDvs5 pappyErr5 ->
              case lojbantag pappyDvs5 of
                Parsed t pappyDvs7 pappyErr7 ->
                  Parsed (
                    TUXOhI t) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_14 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_14 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_14 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanChar d of
            Parsed 'x' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'o' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'i' pappyDvs11 _ ->
                          Parsed (
                            "xo'i") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos d) [])
    pappyAlt1_14 pappyErr1 = NoParse pappyErr1

lojbanconvSE :: LojbanDerivs -> Result LojbanDerivs (Int)
lojbanconvSE d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanSE d of
        Parsed _ pappyDvs3 pappyErr3 ->
          case lojbanxiLit pappyDvs3 of
            Parsed n pappyDvs5 pappyErr5 ->
              Parsed (n) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbanSE d of
        Parsed "se" pappyDvs3 pappyErr3 ->
          Parsed (
            2) pappyDvs3 (max pappyErr3 pappyErr1)
        _ -> pappyAlt1_3 (max (ParseError (lojbanPos d) [Expected "se"]) pappyErr1)
    pappyAlt1_3 pappyErr1 =
      case lojbanSE d of
        Parsed "te" pappyDvs3 pappyErr3 ->
          Parsed (
            3) pappyDvs3 (max pappyErr3 pappyErr1)
        _ -> pappyAlt1_4 (max (ParseError (lojbanPos d) [Expected "te"]) pappyErr1)
    pappyAlt1_4 pappyErr1 =
      case lojbanSE d of
        Parsed "ve" pappyDvs3 pappyErr3 ->
          Parsed (
            4) pappyDvs3 (max pappyErr3 pappyErr1)
        _ -> pappyAlt1_5 (max (ParseError (lojbanPos d) [Expected "ve"]) pappyErr1)
    pappyAlt1_5 pappyErr1 =
      case lojbanSE d of
        Parsed "xe" pappyDvs3 pappyErr3 ->
          Parsed (
            5) pappyDvs3 (max pappyErr3 pappyErr1)
        _ -> pappyAlt1_6 (max (ParseError (lojbanPos d) [Expected "xe"]) pappyErr1)
    pappyAlt1_6 pappyErr1 = NoParse pappyErr1

lojbanParseabstractor :: LojbanDerivs -> Result LojbanDerivs (Abstractor)
lojbanParseabstractor d =
  case pappyResult1 of
    Parsed n pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          case pappyResult5 of
            Parsed nai pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed mca pappyDvs7 pappyErr7 ->
                  Parsed (
                    let a1 = (if isJust nai then NegatedAbstractor else id) $ NU n
                    	    in case mca of
                    		Nothing -> a1
                    		Just (JJJoik joik,a2) -> JoiConnectedAbstractor joik a1 a2
                    		Just (JJJek lcon@(LogJboConnective _ 'i' _),a2) ->
                    		    JoiConnectedAbstractor "??" a1 a2
                    		Just (JJJek lcon,a2) -> LogConnectedAbstractor lcon a1 a2) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> NoParse (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case pappyResult9 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs5 pappyErr9
                  where
                    pappyResult9 =
                      case lojbanjoikJek pappyDvs5 of
                        Parsed jj pappyDvs11 pappyErr11 ->
                          case lojbanabstractor pappyDvs11 of
                            Parsed a pappyDvs13 pappyErr13 ->
                              Parsed (
                                (jj,a)) pappyDvs13 (max pappyErr13 pappyErr11)
                            NoParse pappyErr13 -> NoParse (max pappyErr13 pappyErr11)
                        NoParse pappyErr11 -> NoParse pappyErr11
            NoParse pappyErr5 -> NoParse (maximum [pappyErr5,pappyErr3,pappyErr1])
          where
            pappyResult5 =
              case lojbanNAI pappyDvs3 of
                Parsed pappyVal7 pappyDvs7 pappyErr7 -> Parsed (Just pappyVal7) pappyDvs7 pappyErr7
                NoParse pappyErr7 -> Parsed (Nothing) pappyDvs3 pappyErr7
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'n' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'i' pappyDvs5 _ ->
              Parsed (
                "ni") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'u' pappyDvs5 _ ->
              Parsed (
                "nu") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'd' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'u' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "du'u") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 's' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'i' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'o' pappyDvs9 _ ->
                      Parsed (
                        "si'o") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'u' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "su'u") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'l' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'i' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'i' pappyDvs9 _ ->
                      Parsed (
                        "li'i") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'k' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'a' pappyDvs5 _ ->
              Parsed (
                "ka") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'j' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'e' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'i' pappyDvs7 _ ->
                  Parsed (
                    "jei") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'z' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'u' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'o' pappyDvs9 _ ->
                      Parsed (
                        "zu'o") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'a' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'i' pappyDvs9 _ ->
                      Parsed (
                        "za'i") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'm' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'u' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'e' pappyDvs9 _ ->
                      Parsed (
                        "mu'e") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'p' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'u' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "pu'u") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'o' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'i' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'i' pappyDvs11 _ ->
                          Parsed (
                            "poi'i") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanlinkargs :: LojbanDerivs -> Result LojbanDerivs ([Term])
lojbanlinkargs d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          case lojbanterm pappyDvs3 of
            Parsed t pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed ts pappyDvs7 pappyErr7 ->
                  case pappyResult9 of
                    Parsed _ pappyDvs9 pappyErr9 ->
                      Parsed (
                        (t : (fromMaybe [] ts))) pappyDvs9 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                    NoParse pappyErr9 -> NoParse (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                  where
                    pappyResult9 =
                      case pappyResult11 of
                        Parsed pappyVal11 pappyDvs11 pappyErr11 -> Parsed (Just pappyVal11) pappyDvs11 pappyErr11
                        NoParse pappyErr11 -> Parsed (Nothing) pappyDvs7 pappyErr11
                      where
                        pappyResult11 =
                          case pappyResult13 of
                            Parsed s pappyDvs13 pappyErr13 ->
                              case lojbanpostClause pappyDvs13 of
                                Parsed _ pappyDvs15 pappyErr15 ->
                                  Parsed (s) pappyDvs15 (max pappyErr15 pappyErr13)
                                NoParse pappyErr15 -> NoParse (max pappyErr15 pappyErr13)
                            NoParse pappyErr13 -> NoParse pappyErr13
                          where
                            pappyResult13 =
                              case lojbanChar pappyDvs7 of
                                Parsed 'b' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'e' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed '\'' pappyDvs19 _ ->
                                          case lojbanChar pappyDvs19 of
                                            Parsed 'o' pappyDvs21 _ ->
                                              Parsed (
                                                "be'o") pappyDvs21 (ParseError (lojbanPos pappyDvs21) [])
                                            _ -> NoParse (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                NoParse pappyErr7 -> NoParse (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case lojbanlinks pappyDvs5 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs5 pappyErr9
            NoParse pappyErr5 -> NoParse (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'b' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'e' pappyDvs5 _ ->
              Parsed (
                "be") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanParselinks :: LojbanDerivs -> Result LojbanDerivs ([Term])
lojbanParselinks d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          case lojbanterm pappyDvs3 of
            Parsed t pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed ts pappyDvs7 pappyErr7 ->
                  Parsed (
                    (t : (fromMaybe [] ts))) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> NoParse (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case lojbanlinks pappyDvs5 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs5 pappyErr9
            NoParse pappyErr5 -> NoParse (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'b' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'e' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'i' pappyDvs7 _ ->
                  Parsed (
                    "bei") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanquantifier :: LojbanDerivs -> Result LojbanDerivs (Mex)
lojbanquantifier d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbannumber d of
        Parsed q pappyDvs3 pappyErr3 ->
          case lojbanMOI pappyDvs3 of
            NoParse pappyErr5 ->
              case pappyResult7 of
                Parsed _ pappyDvs7 pappyErr7 ->
                  Parsed (q) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_2 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case lojbanBOI pappyDvs3 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs3 pappyErr9
            Parsed _ _ pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbanVEI d of
        Parsed _ pappyDvs3 pappyErr3 ->
          case lojbanmex pappyDvs3 of
            Parsed m pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed _ pappyDvs7 pappyErr7 ->
                  Parsed (m) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_3 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case lojbanVEhO pappyDvs5 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs5 pappyErr9
            NoParse pappyErr5 -> pappyAlt1_3 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanParseStarRule23 :: LojbanDerivs -> Result LojbanDerivs ([Mex -> Mex])
lojbanParseStarRule23 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanoptail d of
        Parsed v pappyDvs3 pappyErr3 ->
          case lojbanStarRule23 pappyDvs3 of
            Parsed vs pappyDvs5 pappyErr5 ->
              Parsed (
                v : vs) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      Parsed (
        []) d pappyErr1
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanmex :: LojbanDerivs -> Result LojbanDerivs (Mex)
lojbanmex d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanmex1 d of
        Parsed m pappyDvs3 pappyErr3 ->
          case lojbanStarRule23 pappyDvs3 of
            Parsed opts pappyDvs5 pappyErr5 ->
              Parsed (
                foldl (flip ($)) m opts) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case pappyResult3 of
        Parsed s pappyDvs3 pappyErr3 ->
          case lojbanpostClause pappyDvs3 of
            Parsed _ pappyDvs5 pappyErr5 ->
              case lojbanrpExpression pappyDvs5 of
                Parsed e pappyDvs7 pappyErr7 ->
                  Parsed (e) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_3 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_3 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanChar d of
            Parsed 'f' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'u' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'a' pappyDvs11 _ ->
                          Parsed (
                            "fu'a") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos d) [])
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanoptail :: LojbanDerivs -> Result LojbanDerivs (Mex -> Mex)
lojbanoptail d =
  case lojbanoperator d of
    Parsed o pappyDvs1 pappyErr1 ->
      case lojbanmex1 pappyDvs1 of
        Parsed m pappyDvs3 pappyErr3 ->
          Parsed (
             \m1 -> Operation o [m1,m] ) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1

lojbanParsemex1 :: LojbanDerivs -> Result LojbanDerivs (Mex)
lojbanParsemex1 d =
  case lojbanmex2 d of
    Parsed m pappyDvs1 pappyErr1 ->
      case pappyResult3 of
        Parsed mopt pappyDvs3 pappyErr3 ->
          Parsed (
            maybe m ($m) mopt) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case pappyResult5 of
            Parsed pappyVal5 pappyDvs5 pappyErr5 -> Parsed (Just pappyVal5) pappyDvs5 pappyErr5
            NoParse pappyErr5 -> Parsed (Nothing) pappyDvs1 pappyErr5
          where
            pappyResult5 =
              case pappyResult7 of
                Parsed s pappyDvs7 pappyErr7 ->
                  case lojbanpostClause pappyDvs7 of
                    Parsed _ pappyDvs9 pappyErr9 ->
                      case lojbanoptail pappyDvs9 of
                        Parsed opt pappyDvs11 pappyErr11 ->
                          Parsed (opt) pappyDvs11 (maximum [pappyErr11,pappyErr9,pappyErr7])
                        NoParse pappyErr11 -> NoParse (maximum [pappyErr11,pappyErr9,pappyErr7])
                    NoParse pappyErr9 -> NoParse (max pappyErr9 pappyErr7)
                NoParse pappyErr7 -> NoParse pappyErr7
              where
                pappyResult7 =
                  case lojbanChar pappyDvs1 of
                    Parsed 'b' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'i' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed '\'' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed 'e' pappyDvs15 _ ->
                                  Parsed (
                                    "bi'e") pappyDvs15 (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs1) [])
    NoParse pappyErr1 -> NoParse pappyErr1

lojbanParsemex2 :: LojbanDerivs -> Result LojbanDerivs (Mex)
lojbanParsemex2 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanoperand d of
        Parsed pappyVal3 pappyDvs3 pappyErr3 -> Parsed pappyVal3 pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case pappyResult3 of
        Parsed _ pappyDvs3 pappyErr3 ->
          case lojbanoperator pappyDvs3 of
            Parsed op pappyDvs5 pappyErr5 ->
              case lojbanPlusRule10 pappyDvs5 of
                Parsed os pappyDvs7 pappyErr7 ->
                  case pappyResult9 of
                    Parsed _ pappyDvs9 pappyErr9 ->
                      Parsed (
                        Operation op os) pappyDvs9 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                    NoParse pappyErr9 -> pappyAlt1_3 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                  where
                    pappyResult9 =
                      case pappyResult11 of
                        Parsed pappyVal11 pappyDvs11 pappyErr11 -> Parsed (Just pappyVal11) pappyDvs11 pappyErr11
                        NoParse pappyErr11 -> Parsed (Nothing) pappyDvs7 pappyErr11
                      where
                        pappyResult11 =
                          case pappyResult13 of
                            Parsed s pappyDvs13 pappyErr13 ->
                              case lojbanpostClause pappyDvs13 of
                                Parsed _ pappyDvs15 pappyErr15 ->
                                  Parsed (s) pappyDvs15 (max pappyErr15 pappyErr13)
                                NoParse pappyErr15 -> NoParse (max pappyErr15 pappyErr13)
                            NoParse pappyErr13 -> NoParse pappyErr13
                          where
                            pappyResult13 =
                              case lojbanChar pappyDvs7 of
                                Parsed 'k' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'u' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed '\'' pappyDvs19 _ ->
                                          case lojbanChar pappyDvs19 of
                                            Parsed 'e' pappyDvs21 _ ->
                                              Parsed (
                                                "ku'e") pappyDvs21 (ParseError (lojbanPos pappyDvs21) [])
                                            _ -> NoParse (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                NoParse pappyErr7 -> pappyAlt1_3 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_3 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case pappyResult5 of
            Parsed pappyVal5 pappyDvs5 pappyErr5 -> Parsed (Just pappyVal5) pappyDvs5 pappyErr5
            NoParse pappyErr5 -> Parsed (Nothing) d pappyErr5
          where
            pappyResult5 =
              case pappyResult7 of
                Parsed s pappyDvs7 pappyErr7 ->
                  case lojbanpostClause pappyDvs7 of
                    Parsed _ pappyDvs9 pappyErr9 ->
                      Parsed (s) pappyDvs9 (max pappyErr9 pappyErr7)
                    NoParse pappyErr9 -> NoParse (max pappyErr9 pappyErr7)
                NoParse pappyErr7 -> NoParse pappyErr7
              where
                pappyResult7 =
                  case lojbanChar d of
                    Parsed 'p' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'e' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed '\'' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed 'o' pappyDvs15 _ ->
                                  Parsed (
                                    "pe'o") pappyDvs15 (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos d) [])
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanrpExpression :: LojbanDerivs -> Result LojbanDerivs (Mex)
lojbanrpExpression d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanoperand d of
        Parsed o pappyDvs3 pappyErr3 ->
          case lojbanrpExpressionTail pappyDvs3 of
            Parsed mt pappyDvs5 pappyErr5 ->
              Parsed (
                 mt o ) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbanoperand d of
        Parsed pappyVal3 pappyDvs3 pappyErr3 -> Parsed pappyVal3 pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanParserpExpressionTail :: LojbanDerivs -> Result LojbanDerivs (Mex -> Mex)
lojbanParserpExpressionTail d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanrpExpression d of
        Parsed m pappyDvs3 pappyErr3 ->
          case lojbanoperator pappyDvs3 of
            Parsed opr pappyDvs5 pappyErr5 ->
              case lojbanrpExpressionTail pappyDvs5 of
                Parsed t pappyDvs7 pappyErr7 ->
                  Parsed (
                     t . \m1 -> Operation opr [m1,m] ) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_2 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbanrpExpression d of
        Parsed m pappyDvs3 pappyErr3 ->
          case lojbanoperator pappyDvs3 of
            Parsed opr pappyDvs5 pappyErr5 ->
              Parsed (
                 \m1 -> Operation opr [m1,m] ) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_3 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanParseStarRule24 :: LojbanDerivs -> Result LojbanDerivs ([(Connective, Operator)])
lojbanParseStarRule24 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case pappyResult3 of
        Parsed v pappyDvs3 pappyErr3 ->
          case lojbanStarRule24 pappyDvs3 of
            Parsed vs pappyDvs5 pappyErr5 ->
              Parsed (
                v : vs) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          pappyAlt5_1 (ParseError (lojbanPos d) []) where
            pappyAlt5_1 pappyErr5 =
              case lojbanjoikJek d of
                Parsed jj pappyDvs7 pappyErr7 ->
                  case lojbanoperator1 pappyDvs7 of
                    Parsed op pappyDvs9 pappyErr9 ->
                      Parsed (
                        (jjJboCon Nothing jj,op)) pappyDvs9 (maximum [pappyErr9,pappyErr7,pappyErr5])
                    NoParse pappyErr9 -> pappyAlt5_2 (maximum [pappyErr9,pappyErr7,pappyErr5])
                NoParse pappyErr7 -> pappyAlt5_2 (max pappyErr7 pappyErr5)
            pappyAlt5_2 pappyErr5 =
              case lojbanjoik d of
                Parsed joik pappyDvs7 pappyErr7 ->
                  case pappyResult9 of
                    Parsed mtag pappyDvs9 pappyErr9 ->
                      case lojbanKE pappyDvs9 of
                        Parsed _ pappyDvs11 pappyErr11 ->
                          case lojbanoperator pappyDvs11 of
                            Parsed op pappyDvs13 pappyErr13 ->
                              case pappyResult15 of
                                Parsed _ pappyDvs15 pappyErr15 ->
                                  Parsed (
                                    (JboConnJoik mtag joik,op)) pappyDvs15 (maximum [pappyErr15,pappyErr13,pappyErr11,pappyErr9,pappyErr7,pappyErr5])
                                NoParse pappyErr15 -> pappyAlt5_3 (maximum [pappyErr15,pappyErr13,pappyErr11,pappyErr9,pappyErr7,pappyErr5])
                              where
                                pappyResult15 =
                                  case lojbanKEhE pappyDvs13 of
                                    Parsed pappyVal17 pappyDvs17 pappyErr17 -> Parsed (Just pappyVal17) pappyDvs17 pappyErr17
                                    NoParse pappyErr17 -> Parsed (Nothing) pappyDvs13 pappyErr17
                            NoParse pappyErr13 -> pappyAlt5_3 (maximum [pappyErr13,pappyErr11,pappyErr9,pappyErr7,pappyErr5])
                        NoParse pappyErr11 -> pappyAlt5_3 (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5])
                    NoParse pappyErr9 -> pappyAlt5_3 (maximum [pappyErr9,pappyErr7,pappyErr5])
                  where
                    pappyResult9 =
                      case lojbantag pappyDvs7 of
                        Parsed pappyVal11 pappyDvs11 pappyErr11 -> Parsed (Just pappyVal11) pappyDvs11 pappyErr11
                        NoParse pappyErr11 -> Parsed (Nothing) pappyDvs7 pappyErr11
                NoParse pappyErr7 -> pappyAlt5_3 (max pappyErr7 pappyErr5)
            pappyAlt5_3 pappyErr5 = NoParse pappyErr5
    pappyAlt1_2 pappyErr1 =
      Parsed (
        []) d pappyErr1
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanoperator :: LojbanDerivs -> Result LojbanDerivs (Operator)
lojbanoperator d =
  case lojbanoperator1 d of
    Parsed op pappyDvs1 pappyErr1 ->
      case lojbanStarRule24 pappyDvs1 of
        Parsed jekss pappyDvs3 pappyErr3 ->
          Parsed (
             foldl (\op1 -> \(con,op2) -> ConnectedOperator False con op1 op2) op jekss ) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1

lojbanParseoperator1 :: LojbanDerivs -> Result LojbanDerivs (Operator)
lojbanParseoperator1 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanoperator2 d of
        Parsed op1 pappyDvs3 pappyErr3 ->
          case lojbanjoikJek pappyDvs3 of
            Parsed jj pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed mtag pappyDvs7 pappyErr7 ->
                  case lojbanBO pappyDvs7 of
                    Parsed _ pappyDvs9 pappyErr9 ->
                      case lojbanoperator1 pappyDvs9 of
                        Parsed op2 pappyDvs11 pappyErr11 ->
                          Parsed (
                             ConnectedOperator False (jjJboCon mtag jj) op1 op2 ) pappyDvs11 (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                        NoParse pappyErr11 -> pappyAlt1_2 (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                    NoParse pappyErr9 -> pappyAlt1_2 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_2 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case lojbantag pappyDvs5 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs5 pappyErr9
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbanoperator2 d of
        Parsed pappyVal3 pappyDvs3 pappyErr3 -> Parsed pappyVal3 pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 =
      case lojbanguhek d of
        Parsed pcon pappyDvs3 pappyErr3 ->
          case lojbanoperator1 pappyDvs3 of
            Parsed op1 pappyDvs5 pappyErr5 ->
              case lojbangik pappyDvs5 of
                Parsed b pappyDvs7 pappyErr7 ->
                  case lojbanoperator2 pappyDvs7 of
                    Parsed op2 pappyDvs9 pappyErr9 ->
                      Parsed (
                         ConnectedOperator True (jboConnLogOrQ Nothing $ pcon b) op1 op2 ) pappyDvs9 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                    NoParse pappyErr9 -> pappyAlt1_4 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_4 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_4 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_4 (max pappyErr3 pappyErr1)
    pappyAlt1_4 pappyErr1 = NoParse pappyErr1

lojbanParseoperator2 :: LojbanDerivs -> Result LojbanDerivs (Operator)
lojbanParseoperator2 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanmexOperator d of
        Parsed pappyVal3 pappyDvs3 pappyErr3 -> Parsed pappyVal3 pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbanKE d of
        Parsed _ pappyDvs3 pappyErr3 ->
          case lojbanoperator pappyDvs3 of
            Parsed op pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed _ pappyDvs7 pappyErr7 ->
                  Parsed (op) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_3 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case lojbanKEhE pappyDvs5 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs5 pappyErr9
            NoParse pappyErr5 -> pappyAlt1_3 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanParsemexOperator :: LojbanDerivs -> Result LojbanDerivs (Operator)
lojbanParsemexOperator d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanconvSE d of
        Parsed c pappyDvs3 pappyErr3 ->
          case lojbanmexOperator pappyDvs3 of
            Parsed op pappyDvs5 pappyErr5 ->
              Parsed (
                 OpPermuted c op ) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbanNAhE d of
        Parsed n pappyDvs3 pappyErr3 ->
          case lojbanmexOperator pappyDvs3 of
            Parsed op pappyDvs5 pappyErr5 ->
              Parsed (
                 OpScalarNegated n op ) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_3 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 =
      case pappyResult3 of
        Parsed s pappyDvs3 pappyErr3 ->
          case lojbanpostClause pappyDvs3 of
            Parsed _ pappyDvs5 pappyErr5 ->
              case lojbanmex pappyDvs5 of
                Parsed m pappyDvs7 pappyErr7 ->
                  case pappyResult9 of
                    Parsed _ pappyDvs9 pappyErr9 ->
                      Parsed (
                        OpMex m) pappyDvs9 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                    NoParse pappyErr9 -> pappyAlt1_4 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                  where
                    pappyResult9 =
                      case lojbanTEhU pappyDvs7 of
                        Parsed pappyVal11 pappyDvs11 pappyErr11 -> Parsed (Just pappyVal11) pappyDvs11 pappyErr11
                        NoParse pappyErr11 -> Parsed (Nothing) pappyDvs7 pappyErr11
                NoParse pappyErr7 -> pappyAlt1_4 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_4 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_4 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanChar d of
            Parsed 'm' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'a' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'o' pappyDvs11 _ ->
                          Parsed (
                            "ma'o") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos d) [])
    pappyAlt1_4 pappyErr1 =
      case pappyResult3 of
        Parsed s pappyDvs3 pappyErr3 ->
          case lojbanpostClause pappyDvs3 of
            Parsed _ pappyDvs5 pappyErr5 ->
              case lojbanselbri pappyDvs5 of
                Parsed s pappyDvs7 pappyErr7 ->
                  case pappyResult9 of
                    Parsed _ pappyDvs9 pappyErr9 ->
                      Parsed (
                        OpSelbri s) pappyDvs9 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                    NoParse pappyErr9 -> pappyAlt1_5 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                  where
                    pappyResult9 =
                      case lojbanTEhU pappyDvs7 of
                        Parsed pappyVal11 pappyDvs11 pappyErr11 -> Parsed (Just pappyVal11) pappyDvs11 pappyErr11
                        NoParse pappyErr11 -> Parsed (Nothing) pappyDvs7 pappyErr11
                NoParse pappyErr7 -> pappyAlt1_5 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_5 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_5 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanChar d of
            Parsed 'n' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'a' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'u' pappyDvs11 _ ->
                          Parsed (
                            "na'u") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos d) [])
    pappyAlt1_5 pappyErr1 =
      case pappyResult3 of
        Parsed v pappyDvs3 pappyErr3 ->
          case lojbanpostClause pappyDvs3 of
            Parsed _ pappyDvs5 pappyErr5 ->
              Parsed (
                OpVUhU v) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_6 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_6 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanChar d of
            Parsed 'g' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'e' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'a' pappyDvs11 _ ->
                          Parsed (
                            "ge'a") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'i' pappyDvs9 _ ->
                      Parsed (
                        "gei") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'f' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'u' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'u' pappyDvs11 _ ->
                          Parsed (
                            "fu'u") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'e' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'i' pappyDvs11 _ ->
                          Parsed (
                            "fe'i") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        Parsed 'a' pappyDvs11 _ ->
                          Parsed (
                            "fe'a") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'a' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'i' pappyDvs11 _ ->
                          Parsed (
                            "fa'i") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'p' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'i' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'i' pappyDvs11 _ ->
                          Parsed (
                            "pi'i") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        Parsed 'a' pappyDvs11 _ ->
                          Parsed (
                            "pi'a") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'a' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'i' pappyDvs11 _ ->
                          Parsed (
                            "pa'i") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'v' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'u' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'u' pappyDvs11 _ ->
                          Parsed (
                            "vu'u") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'a' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'a' pappyDvs11 _ ->
                          Parsed (
                            "va'a") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 's' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'u' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'i' pappyDvs11 _ ->
                          Parsed (
                            "su'i") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'a' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'o' pappyDvs11 _ ->
                          Parsed (
                            "sa'o") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        Parsed 'i' pappyDvs11 _ ->
                          Parsed (
                            "sa'i") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'i' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'i' pappyDvs11 _ ->
                          Parsed (
                            "si'i") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'j' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'u' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'u' pappyDvs11 _ ->
                          Parsed (
                            "ju'u") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 't' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'e' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'a' pappyDvs11 _ ->
                          Parsed (
                            "te'a") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'c' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'u' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'a' pappyDvs11 _ ->
                          Parsed (
                            "cu'a") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'n' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'e' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'o' pappyDvs11 _ ->
                          Parsed (
                            "ne'o") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'd' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'e' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'o' pappyDvs11 _ ->
                          Parsed (
                            "de'o") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'r' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'e' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'a' pappyDvs11 _ ->
                          Parsed (
                            "re'a") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'i' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'o' pappyDvs11 _ ->
                          Parsed (
                            "ri'o") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos d) [])
    pappyAlt1_6 pappyErr1 = NoParse pappyErr1

lojbanParseoperand :: LojbanDerivs -> Result LojbanDerivs (Mex)
lojbanParseoperand d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanoperand1 d of
        Parsed o1 pappyDvs3 pappyErr3 ->
          case lojbanjoikEk pappyDvs3 of
            Parsed jj pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed mtag pappyDvs7 pappyErr7 ->
                  case lojbanKE pappyDvs7 of
                    Parsed _ pappyDvs9 pappyErr9 ->
                      case lojbanoperand pappyDvs9 of
                        Parsed o2 pappyDvs11 pappyErr11 ->
                          case pappyResult13 of
                            Parsed _ pappyDvs13 pappyErr13 ->
                              Parsed (
                                 ConnectedMex False (jjJboCon mtag jj) o1 o2 ) pappyDvs13 (maximum [pappyErr13,pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                            NoParse pappyErr13 -> pappyAlt1_2 (maximum [pappyErr13,pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                          where
                            pappyResult13 =
                              case lojbanKEhE pappyDvs11 of
                                Parsed pappyVal15 pappyDvs15 pappyErr15 -> Parsed (Just pappyVal15) pappyDvs15 pappyErr15
                                NoParse pappyErr15 -> Parsed (Nothing) pappyDvs11 pappyErr15
                        NoParse pappyErr11 -> pappyAlt1_2 (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                    NoParse pappyErr9 -> pappyAlt1_2 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_2 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case lojbantag pappyDvs5 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs5 pappyErr9
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbanoperand1 d of
        Parsed pappyVal3 pappyDvs3 pappyErr3 -> Parsed pappyVal3 pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanParseStarRule25 :: LojbanDerivs -> Result LojbanDerivs ([Mex -> Mex])
lojbanParseStarRule25 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case pappyResult3 of
        Parsed v pappyDvs3 pappyErr3 ->
          case lojbanStarRule25 pappyDvs3 of
            Parsed vs pappyDvs5 pappyErr5 ->
              Parsed (
                v : vs) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanjoikEk d of
            Parsed jj pappyDvs5 pappyErr5 ->
              case lojbanoperand2 pappyDvs5 of
                Parsed o2 pappyDvs7 pappyErr7 ->
                  Parsed (
                     \o1 -> ConnectedMex False (jjJboCon Nothing jj) o1 o2 ) pappyDvs7 (max pappyErr7 pappyErr5)
                NoParse pappyErr7 -> NoParse (max pappyErr7 pappyErr5)
            NoParse pappyErr5 -> NoParse pappyErr5
    pappyAlt1_2 pappyErr1 =
      Parsed (
        []) d pappyErr1
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanoperand1 :: LojbanDerivs -> Result LojbanDerivs (Mex)
lojbanoperand1 d =
  case lojbanoperand2 d of
    Parsed o pappyDvs1 pappyErr1 ->
      case lojbanStarRule25 pappyDvs1 of
        Parsed jekss pappyDvs3 pappyErr3 ->
          Parsed (
            foldl (flip ($)) o jekss) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1

lojbanParseoperand2 :: LojbanDerivs -> Result LojbanDerivs (Mex)
lojbanParseoperand2 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanoperand3 d of
        Parsed o1 pappyDvs3 pappyErr3 ->
          case lojbanjoikEk pappyDvs3 of
            Parsed jj pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed mtag pappyDvs7 pappyErr7 ->
                  case lojbanBO pappyDvs7 of
                    Parsed _ pappyDvs9 pappyErr9 ->
                      case lojbanoperand2 pappyDvs9 of
                        Parsed o2 pappyDvs11 pappyErr11 ->
                          Parsed (
                             ConnectedMex False (jjJboCon mtag jj) o1 o2 ) pappyDvs11 (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                        NoParse pappyErr11 -> pappyAlt1_2 (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                    NoParse pappyErr9 -> pappyAlt1_2 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_2 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case lojbantag pappyDvs5 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs5 pappyErr9
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbanoperand3 d of
        Parsed pappyVal3 pappyDvs3 pappyErr3 -> Parsed pappyVal3 pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanParsePlusRule10 :: LojbanDerivs -> Result LojbanDerivs ([Mex])
lojbanParsePlusRule10 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanmex2 d of
        Parsed v pappyDvs3 pappyErr3 ->
          case lojbanPlusRule10 pappyDvs3 of
            Parsed vs pappyDvs5 pappyErr5 ->
              Parsed (
                v : vs) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbanmex2 d of
        Parsed v pappyDvs3 pappyErr3 ->
          Parsed (
            [v]) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanParseoperand3 :: LojbanDerivs -> Result LojbanDerivs (Mex)
lojbanParseoperand3 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanquantifier d of
        Parsed pappyVal3 pappyDvs3 pappyErr3 -> Parsed pappyVal3 pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbanlerfuString d of
        Parsed ls pappyDvs3 pappyErr3 ->
          case lojbanMOI pappyDvs3 of
            NoParse pappyErr5 ->
              case pappyResult7 of
                Parsed _ pappyDvs7 pappyErr7 ->
                  Parsed (
                    MexLerfuString ls) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_3 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case lojbanBOI pappyDvs3 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs3 pappyErr9
            Parsed _ _ pappyErr5 -> pappyAlt1_3 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 =
      case pappyResult3 of
        Parsed s pappyDvs3 pappyErr3 ->
          case lojbanpostClause pappyDvs3 of
            Parsed _ pappyDvs5 pappyErr5 ->
              case lojbanselbri pappyDvs5 of
                Parsed s pappyDvs7 pappyErr7 ->
                  case pappyResult9 of
                    Parsed _ pappyDvs9 pappyErr9 ->
                      Parsed (
                        MexSelbri s) pappyDvs9 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                    NoParse pappyErr9 -> pappyAlt1_4 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                  where
                    pappyResult9 =
                      case lojbanTEhU pappyDvs7 of
                        Parsed pappyVal11 pappyDvs11 pappyErr11 -> Parsed (Just pappyVal11) pappyDvs11 pappyErr11
                        NoParse pappyErr11 -> Parsed (Nothing) pappyDvs7 pappyErr11
                NoParse pappyErr7 -> pappyAlt1_4 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_4 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_4 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanChar d of
            Parsed 'n' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'i' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'e' pappyDvs11 _ ->
                          Parsed (
                            "ni'e") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos d) [])
    pappyAlt1_4 pappyErr1 =
      case pappyResult3 of
        Parsed s pappyDvs3 pappyErr3 ->
          case lojbanpostClause pappyDvs3 of
            Parsed _ pappyDvs5 pappyErr5 ->
              case lojbansumti pappyDvs5 of
                Parsed s pappyDvs7 pappyErr7 ->
                  case pappyResult9 of
                    Parsed _ pappyDvs9 pappyErr9 ->
                      Parsed (
                        MexSumti s) pappyDvs9 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                    NoParse pappyErr9 -> pappyAlt1_5 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                  where
                    pappyResult9 =
                      case lojbanTEhU pappyDvs7 of
                        Parsed pappyVal11 pappyDvs11 pappyErr11 -> Parsed (Just pappyVal11) pappyDvs11 pappyErr11
                        NoParse pappyErr11 -> Parsed (Nothing) pappyDvs7 pappyErr11
                NoParse pappyErr7 -> pappyAlt1_5 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_5 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_5 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanChar d of
            Parsed 'm' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'o' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'e' pappyDvs11 _ ->
                          Parsed (
                            "mo'e") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos d) [])
    pappyAlt1_5 pappyErr1 =
      case pappyResult3 of
        Parsed s pappyDvs3 pappyErr3 ->
          case lojbanpostClause pappyDvs3 of
            Parsed _ pappyDvs5 pappyErr5 ->
              case lojbanPlusRule10 pappyDvs5 of
                Parsed ms pappyDvs7 pappyErr7 ->
                  case pappyResult9 of
                    Parsed _ pappyDvs9 pappyErr9 ->
                      Parsed (
                        MexArray ms) pappyDvs9 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                    NoParse pappyErr9 -> pappyAlt1_6 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                  where
                    pappyResult9 =
                      case lojbanTEhU pappyDvs7 of
                        Parsed pappyVal11 pappyDvs11 pappyErr11 -> Parsed (Just pappyVal11) pappyDvs11 pappyErr11
                        NoParse pappyErr11 -> Parsed (Nothing) pappyDvs7 pappyErr11
                NoParse pappyErr7 -> pappyAlt1_6 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_6 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_6 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanChar d of
            Parsed 'j' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'o' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'i' pappyDvs11 _ ->
                          Parsed (
                            "jo'i") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos d) [])
    pappyAlt1_6 pappyErr1 =
      case lojbangek d of
        Parsed pcon pappyDvs3 pappyErr3 ->
          case lojbanoperand pappyDvs3 of
            Parsed o1 pappyDvs5 pappyErr5 ->
              case lojbangik pappyDvs5 of
                Parsed b pappyDvs7 pappyErr7 ->
                  case lojbanoperand3 pappyDvs7 of
                    Parsed o2 pappyDvs9 pappyErr9 ->
                      Parsed (
                        ConnectedMex True (pcon b) o1 o2) pappyDvs9 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                    NoParse pappyErr9 -> pappyAlt1_7 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_7 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_7 (max pappyErr3 pappyErr1)
    pappyAlt1_7 pappyErr1 =
      case lojbanqualifier d of
        Parsed qual pappyDvs3 pappyErr3 ->
          case lojbanoperand pappyDvs3 of
            Parsed o pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed _ pappyDvs7 pappyErr7 ->
                  Parsed (
                    QualifiedMex qual o) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_8 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case lojbanLUhU pappyDvs5 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs5 pappyErr9
            NoParse pappyErr5 -> pappyAlt1_8 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_8 (max pappyErr3 pappyErr1)
    pappyAlt1_8 pappyErr1 = NoParse pappyErr1

lojbannumberOrLerfuString :: LojbanDerivs -> Result LojbanDerivs (Mex)
lojbannumberOrLerfuString d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbannumber d of
        Parsed pappyVal3 pappyDvs3 pappyErr3 -> Parsed pappyVal3 pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbanlerfuString d of
        Parsed ls pappyDvs3 pappyErr3 ->
          Parsed (
            MexLerfuString ls) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanParseStarRule26 :: LojbanDerivs -> Result LojbanDerivs ([Numeral])
lojbanParseStarRule26 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbannumeral d of
        Parsed v pappyDvs3 pappyErr3 ->
          case lojbanStarRule26 pappyDvs3 of
            Parsed vs pappyDvs5 pappyErr5 ->
              Parsed (
                v : vs) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      Parsed (
        []) d pappyErr1
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbannumber :: LojbanDerivs -> Result LojbanDerivs (Mex)
lojbannumber d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case pappyResult3 of
        Parsed n pappyDvs3 pappyErr3 ->
          case lojbannumeral pappyDvs3 of
            NoParse pappyErr5 ->
              Parsed (
                MexInt n) pappyDvs3 (maximum [pappyErr5,pappyErr3,pappyErr1])
            Parsed _ _ pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanPlusRule11 d of
            Parsed ds pappyDvs5 pappyErr5 ->
              Parsed (
                
                	let calc [] = 0
                	    calc (d:ds) = (10*calc ds) + d
                        in calc (reverse ds)) pappyDvs5 pappyErr5
            NoParse pappyErr5 -> NoParse pappyErr5
    pappyAlt1_2 pappyErr1 =
      case lojbanPA d of
        Parsed p pappyDvs3 pappyErr3 ->
          case lojbanStarRule26 pappyDvs3 of
            Parsed t pappyDvs5 pappyErr5 ->
              Parsed (
                 MexNumeralString $ (PA p):t ) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_3 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbannumeral :: LojbanDerivs -> Result LojbanDerivs (Numeral)
lojbannumeral d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanPA d of
        Parsed p pappyDvs3 pappyErr3 ->
          Parsed (
            PA p) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbanlerfuWord d of
        Parsed l pappyDvs3 pappyErr3 ->
          Parsed (
            NumeralLerfu l) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanParsePlusRule11 :: LojbanDerivs -> Result LojbanDerivs ([Int])
lojbanParsePlusRule11 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbandigit d of
        Parsed v pappyDvs3 pappyErr3 ->
          case lojbanPlusRule11 pappyDvs3 of
            Parsed vs pappyDvs5 pappyErr5 ->
              Parsed (
                v : vs) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbandigit d of
        Parsed v pappyDvs3 pappyErr3 ->
          Parsed (
            [v]) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbandigit :: LojbanDerivs -> Result LojbanDerivs (Int)
lojbandigit d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanPA d of
        Parsed "no" pappyDvs3 pappyErr3 ->
          Parsed (
            0) pappyDvs3 (max pappyErr3 pappyErr1)
        _ -> pappyAlt1_2 (max (ParseError (lojbanPos d) [Expected "no"]) pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbanPA d of
        Parsed "pa" pappyDvs3 pappyErr3 ->
          Parsed (
            1) pappyDvs3 (max pappyErr3 pappyErr1)
        _ -> pappyAlt1_3 (max (ParseError (lojbanPos d) [Expected "pa"]) pappyErr1)
    pappyAlt1_3 pappyErr1 =
      case lojbanPA d of
        Parsed "re" pappyDvs3 pappyErr3 ->
          Parsed (
            2) pappyDvs3 (max pappyErr3 pappyErr1)
        _ -> pappyAlt1_4 (max (ParseError (lojbanPos d) [Expected "re"]) pappyErr1)
    pappyAlt1_4 pappyErr1 =
      case lojbanPA d of
        Parsed "ci" pappyDvs3 pappyErr3 ->
          Parsed (
            3) pappyDvs3 (max pappyErr3 pappyErr1)
        _ -> pappyAlt1_5 (max (ParseError (lojbanPos d) [Expected "ci"]) pappyErr1)
    pappyAlt1_5 pappyErr1 =
      case lojbanPA d of
        Parsed "vo" pappyDvs3 pappyErr3 ->
          Parsed (
            4) pappyDvs3 (max pappyErr3 pappyErr1)
        _ -> pappyAlt1_6 (max (ParseError (lojbanPos d) [Expected "vo"]) pappyErr1)
    pappyAlt1_6 pappyErr1 =
      case lojbanPA d of
        Parsed "mu" pappyDvs3 pappyErr3 ->
          Parsed (
            5) pappyDvs3 (max pappyErr3 pappyErr1)
        _ -> pappyAlt1_7 (max (ParseError (lojbanPos d) [Expected "mu"]) pappyErr1)
    pappyAlt1_7 pappyErr1 =
      case lojbanPA d of
        Parsed "xa" pappyDvs3 pappyErr3 ->
          Parsed (
            6) pappyDvs3 (max pappyErr3 pappyErr1)
        _ -> pappyAlt1_8 (max (ParseError (lojbanPos d) [Expected "xa"]) pappyErr1)
    pappyAlt1_8 pappyErr1 =
      case lojbanPA d of
        Parsed "ze" pappyDvs3 pappyErr3 ->
          Parsed (
            7) pappyDvs3 (max pappyErr3 pappyErr1)
        _ -> pappyAlt1_9 (max (ParseError (lojbanPos d) [Expected "ze"]) pappyErr1)
    pappyAlt1_9 pappyErr1 =
      case lojbanPA d of
        Parsed "bi" pappyDvs3 pappyErr3 ->
          Parsed (
            8) pappyDvs3 (max pappyErr3 pappyErr1)
        _ -> pappyAlt1_10 (max (ParseError (lojbanPos d) [Expected "bi"]) pappyErr1)
    pappyAlt1_10 pappyErr1 =
      case lojbanPA d of
        Parsed "so" pappyDvs3 pappyErr3 ->
          Parsed (
            9) pappyDvs3 (max pappyErr3 pappyErr1)
        _ -> pappyAlt1_11 (max (ParseError (lojbanPos d) [Expected "so"]) pappyErr1)
    pappyAlt1_11 pappyErr1 =
      case lojbanChar d of
        Parsed c pappyDvs3 pappyErr3 ->
          case (isDigit c) of
            True ->
              Parsed (
                digitToInt c) pappyDvs3 (max pappyErr3 pappyErr1)
            False -> pappyAlt1_12 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_12 (max pappyErr3 pappyErr1)
    pappyAlt1_12 pappyErr1 = NoParse pappyErr1

lojbanxiLit :: LojbanDerivs -> Result LojbanDerivs (Int)
lojbanxiLit d =
  case lojbanXI d of
    Parsed _ pappyDvs1 pappyErr1 ->
      case pappyResult3 of
        Parsed n pappyDvs3 pappyErr3 ->
          case lojbannumeral pappyDvs3 of
            NoParse pappyErr5 ->
              Parsed (n) pappyDvs3 (maximum [pappyErr5,pappyErr3,pappyErr1])
            Parsed _ _ pappyErr5 -> NoParse (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanPlusRule11 pappyDvs1 of
            Parsed ds pappyDvs5 pappyErr5 ->
              Parsed (
                
                	let calc [] = 0
                	    calc (d:ds) = (10*calc ds) + d
                        in calc (reverse ds)) pappyDvs5 pappyErr5
            NoParse pappyErr5 -> NoParse pappyErr5
    NoParse pappyErr1 -> NoParse pappyErr1

lojbanParseStarRule27 :: LojbanDerivs -> Result LojbanDerivs ([Lerfu])
lojbanParseStarRule27 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case pappyResult3 of
        Parsed v pappyDvs3 pappyErr3 ->
          case lojbanStarRule27 pappyDvs3 of
            Parsed vs pappyDvs5 pappyErr5 ->
              Parsed (
                v : vs) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          pappyAlt5_1 (ParseError (lojbanPos d) []) where
            pappyAlt5_1 pappyErr5 =
              case lojbanlerfuWord d of
                Parsed pappyVal7 pappyDvs7 pappyErr7 -> Parsed pappyVal7 pappyDvs7 (max pappyErr7 pappyErr5)
                NoParse pappyErr7 -> pappyAlt5_2 (max pappyErr7 pappyErr5)
            pappyAlt5_2 pappyErr5 =
              case lojbandigit d of
                Parsed d pappyDvs7 pappyErr7 ->
                  Parsed (
                    LerfuChar $ head $ show d) pappyDvs7 (max pappyErr7 pappyErr5)
                NoParse pappyErr7 -> pappyAlt5_3 (max pappyErr7 pappyErr5)
            pappyAlt5_3 pappyErr5 =
              case lojbanPA d of
                Parsed p pappyDvs7 pappyErr7 ->
                  Parsed (
                    LerfuPA p) pappyDvs7 (max pappyErr7 pappyErr5)
                NoParse pappyErr7 -> pappyAlt5_4 (max pappyErr7 pappyErr5)
            pappyAlt5_4 pappyErr5 = NoParse pappyErr5
    pappyAlt1_2 pappyErr1 =
      Parsed (
        []) d pappyErr1
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanlerfuString :: LojbanDerivs -> Result LojbanDerivs ([Lerfu])
lojbanlerfuString d =
  case lojbanlerfuWord d of
    Parsed c pappyDvs1 pappyErr1 ->
      case lojbanStarRule27 pappyDvs1 of
        Parsed cs pappyDvs3 pappyErr3 ->
          Parsed (
            c:cs) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1

lojbanParselerfuWord :: LojbanDerivs -> Result LojbanDerivs (Lerfu)
lojbanParselerfuWord d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case pappyResult3 of
        Parsed s pappyDvs3 pappyErr3 ->
          case lojbanpostClause pappyDvs3 of
            Parsed _ pappyDvs5 pappyErr5 ->
              Parsed (
                case s of
                	"y'y" -> LerfuChar 'h' 
                	s:"y" -> LerfuChar s
                	_ -> LerfuShift s) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanChar d of
            Parsed 'j' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'o' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'o' pappyDvs11 _ ->
                          Parsed (
                            "jo'o") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'e' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'o' pappyDvs11 _ ->
                          Parsed (
                            "je'o") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'y' pappyDvs7 _ ->
                  Parsed (
                    "jy") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'r' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'u' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'o' pappyDvs11 _ ->
                          Parsed (
                            "ru'o") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'y' pappyDvs7 _ ->
                  Parsed (
                    "ry") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'g' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'e' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'o' pappyDvs11 _ ->
                          Parsed (
                            "ge'o") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'a' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'e' pappyDvs11 _ ->
                          Parsed (
                            "ga'e") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'y' pappyDvs7 _ ->
                  Parsed (
                    "gy") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'l' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'o' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'a' pappyDvs11 _ ->
                          Parsed (
                            "lo'a") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'y' pappyDvs7 _ ->
                  Parsed (
                    "ly") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'n' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'a' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'a' pappyDvs11 _ ->
                          Parsed (
                            "na'a") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'y' pappyDvs7 _ ->
                  Parsed (
                    "ny") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 's' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'e' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'e' pappyDvs11 _ ->
                          Parsed (
                            "se'e") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'y' pappyDvs7 _ ->
                  Parsed (
                    "sy") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 't' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'o' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'a' pappyDvs11 _ ->
                          Parsed (
                            "to'a") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'y' pappyDvs7 _ ->
                  Parsed (
                    "ty") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'y' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'y' pappyDvs9 _ ->
                      Parsed (
                        "y'y") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'b' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'y' pappyDvs7 _ ->
                  Parsed (
                    "by") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'c' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'y' pappyDvs7 _ ->
                  Parsed (
                    "cy") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'd' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'y' pappyDvs7 _ ->
                  Parsed (
                    "dy") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'f' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'y' pappyDvs7 _ ->
                  Parsed (
                    "fy") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'k' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'y' pappyDvs7 _ ->
                  Parsed (
                    "ky") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'm' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'y' pappyDvs7 _ ->
                  Parsed (
                    "my") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'p' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'y' pappyDvs7 _ ->
                  Parsed (
                    "py") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'v' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'y' pappyDvs7 _ ->
                  Parsed (
                    "vy") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'x' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'y' pappyDvs7 _ ->
                  Parsed (
                    "xy") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'z' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'y' pappyDvs7 _ ->
                  Parsed (
                    "zy") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos d) [])
    pappyAlt1_2 pappyErr1 =
      case lojbanVowel d of
        Parsed v pappyDvs3 pappyErr3 ->
          case lojbanPlusRule13 pappyDvs3 of
            Parsed _ pappyDvs5 pappyErr5 ->
              case lojbanBU pappyDvs5 of
                Parsed _ pappyDvs7 pappyErr7 ->
                  Parsed (
                     LerfuChar v ) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_3 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_3 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 =
      case lojbanValsi d of
        Parsed v pappyDvs3 pappyErr3 ->
          case lojbanBU pappyDvs3 of
            Parsed _ pappyDvs5 pappyErr5 ->
              Parsed (
                 LerfuValsi v ) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_4 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_4 (max pappyErr3 pappyErr1)
    pappyAlt1_4 pappyErr1 =
      case pappyResult3 of
        Parsed lau pappyDvs3 pappyErr3 ->
          case lojbanpostClause pappyDvs3 of
            Parsed _ pappyDvs5 pappyErr5 ->
              case lojbanlerfuWord pappyDvs5 of
                Parsed l pappyDvs7 pappyErr7 ->
                  Parsed (
                     LerfuShifted lau l ) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_5 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_5 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_5 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanChar d of
            Parsed 'c' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'e' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'a' pappyDvs11 _ ->
                          Parsed (
                            "ce'a") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'l' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'a' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "lau") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'z' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'a' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'i' pappyDvs9 _ ->
                      Parsed (
                        "zai") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 't' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'a' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "tau") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos d) [])
    pappyAlt1_5 pappyErr1 =
      case pappyResult3 of
        Parsed s pappyDvs3 pappyErr3 ->
          case lojbanpostClause pappyDvs3 of
            Parsed _ pappyDvs5 pappyErr5 ->
              case lojbanlerfuString pappyDvs5 of
                Parsed ls pappyDvs7 pappyErr7 ->
                  case pappyResult9 of
                    Parsed s pappyDvs9 pappyErr9 ->
                      case lojbanpostClause pappyDvs9 of
                        Parsed _ pappyDvs11 pappyErr11 ->
                          Parsed (
                             LerfuComposite ls ) pappyDvs11 (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                        NoParse pappyErr11 -> pappyAlt1_6 (maximum [pappyErr11,pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                    NoParse pappyErr9 -> pappyAlt1_6 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                  where
                    pappyResult9 =
                      case lojbanChar pappyDvs7 of
                        Parsed 'f' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed 'o' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed 'i' pappyDvs15 _ ->
                                  Parsed (
                                    "foi") pappyDvs15 (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                NoParse pappyErr7 -> pappyAlt1_6 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_6 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_6 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanChar d of
            Parsed 't' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'e' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'i' pappyDvs9 _ ->
                      Parsed (
                        "tei") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos d) [])
    pappyAlt1_6 pappyErr1 = NoParse pappyErr1

lojbanParseek :: LojbanDerivs -> Result LojbanDerivs (LogJboConnective)
lojbanParseek d =
  case pappyResult1 of
    Parsed ln pappyDvs1 pappyErr1 ->
      case pappyResult3 of
        Parsed se pappyDvs3 pappyErr3 ->
          case pappyResult5 of
            Parsed conchar pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed rn pappyDvs7 pappyErr7 ->
                  Parsed (
                     LogJboConnective (ln /= Just "na")
                    		    (if (isJust se) && conchar=='u' then 'U' else conchar)
                    		    (isNothing rn) ) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> NoParse (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case lojbanNAI pappyDvs5 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs5 pappyErr9
            NoParse pappyErr5 -> NoParse (maximum [pappyErr5,pappyErr3,pappyErr1])
          where
            pappyResult5 =
              pappyAlt7_1 (ParseError (lojbanPos pappyDvs3) []) where
                pappyAlt7_1 pappyErr7 =
                  case lojbanA pappyDvs3 of
                    Parsed "a" pappyDvs9 pappyErr9 ->
                      Parsed (
                        'a') pappyDvs9 (max pappyErr9 pappyErr7)
                    _ -> pappyAlt7_2 (max (ParseError (lojbanPos pappyDvs3) [Expected "a"]) pappyErr7)
                pappyAlt7_2 pappyErr7 =
                  case lojbanA pappyDvs3 of
                    Parsed "e" pappyDvs9 pappyErr9 ->
                      Parsed (
                        'e') pappyDvs9 (max pappyErr9 pappyErr7)
                    _ -> pappyAlt7_3 (max (ParseError (lojbanPos pappyDvs3) [Expected "e"]) pappyErr7)
                pappyAlt7_3 pappyErr7 =
                  case lojbanA pappyDvs3 of
                    Parsed "o" pappyDvs9 pappyErr9 ->
                      Parsed (
                        'o') pappyDvs9 (max pappyErr9 pappyErr7)
                    _ -> pappyAlt7_4 (max (ParseError (lojbanPos pappyDvs3) [Expected "o"]) pappyErr7)
                pappyAlt7_4 pappyErr7 =
                  case lojbanA pappyDvs3 of
                    Parsed "u" pappyDvs9 pappyErr9 ->
                      Parsed (
                        'u') pappyDvs9 (max pappyErr9 pappyErr7)
                    _ -> pappyAlt7_5 (max (ParseError (lojbanPos pappyDvs3) [Expected "u"]) pappyErr7)
                pappyAlt7_5 pappyErr7 =
                  case lojbanA pappyDvs3 of
                    Parsed "ji" pappyDvs9 pappyErr9 ->
                      Parsed (
                        'i') pappyDvs9 (max pappyErr9 pappyErr7)
                    _ -> pappyAlt7_6 (max (ParseError (lojbanPos pappyDvs3) [Expected "ji"]) pappyErr7)
                pappyAlt7_6 pappyErr7 = NoParse pappyErr7
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanSE pappyDvs1 of
            Parsed pappyVal5 pappyDvs5 pappyErr5 -> Parsed (Just pappyVal5) pappyDvs5 pappyErr5
            NoParse pappyErr5 -> Parsed (Nothing) pappyDvs1 pappyErr5
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanNA d of
        Parsed pappyVal3 pappyDvs3 pappyErr3 -> Parsed (Just pappyVal3) pappyDvs3 pappyErr3
        NoParse pappyErr3 -> Parsed (Nothing) d pappyErr3

lojbanParsegihek :: LojbanDerivs -> Result LojbanDerivs (LogJboConnective)
lojbanParsegihek d =
  case pappyResult1 of
    Parsed ln pappyDvs1 pappyErr1 ->
      case pappyResult3 of
        Parsed se pappyDvs3 pappyErr3 ->
          case pappyResult5 of
            Parsed conchar pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed rn pappyDvs7 pappyErr7 ->
                  Parsed (
                     LogJboConnective (ln /= Just "na")
                    		    (if (isJust se) && conchar=='u' then 'U' else conchar)
                    		    (isNothing rn) ) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> NoParse (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case lojbanNAI pappyDvs5 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs5 pappyErr9
            NoParse pappyErr5 -> NoParse (maximum [pappyErr5,pappyErr3,pappyErr1])
          where
            pappyResult5 =
              pappyAlt7_1 (ParseError (lojbanPos pappyDvs3) []) where
                pappyAlt7_1 pappyErr7 =
                  case lojbanGIhA pappyDvs3 of
                    Parsed "gi'a" pappyDvs9 pappyErr9 ->
                      Parsed (
                        'a') pappyDvs9 (max pappyErr9 pappyErr7)
                    _ -> pappyAlt7_2 (max (ParseError (lojbanPos pappyDvs3) [Expected "gi'a"]) pappyErr7)
                pappyAlt7_2 pappyErr7 =
                  case lojbanGIhA pappyDvs3 of
                    Parsed "gi'e" pappyDvs9 pappyErr9 ->
                      Parsed (
                        'e') pappyDvs9 (max pappyErr9 pappyErr7)
                    _ -> pappyAlt7_3 (max (ParseError (lojbanPos pappyDvs3) [Expected "gi'e"]) pappyErr7)
                pappyAlt7_3 pappyErr7 =
                  case lojbanGIhA pappyDvs3 of
                    Parsed "gi'o" pappyDvs9 pappyErr9 ->
                      Parsed (
                        'o') pappyDvs9 (max pappyErr9 pappyErr7)
                    _ -> pappyAlt7_4 (max (ParseError (lojbanPos pappyDvs3) [Expected "gi'o"]) pappyErr7)
                pappyAlt7_4 pappyErr7 =
                  case lojbanGIhA pappyDvs3 of
                    Parsed "gi'u" pappyDvs9 pappyErr9 ->
                      Parsed (
                        'u') pappyDvs9 (max pappyErr9 pappyErr7)
                    _ -> pappyAlt7_5 (max (ParseError (lojbanPos pappyDvs3) [Expected "gi'u"]) pappyErr7)
                pappyAlt7_5 pappyErr7 =
                  case lojbanGIhA pappyDvs3 of
                    Parsed "gi'i" pappyDvs9 pappyErr9 ->
                      Parsed (
                        'i') pappyDvs9 (max pappyErr9 pappyErr7)
                    _ -> pappyAlt7_6 (max (ParseError (lojbanPos pappyDvs3) [Expected "gi'i"]) pappyErr7)
                pappyAlt7_6 pappyErr7 = NoParse pappyErr7
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanSE pappyDvs1 of
            Parsed pappyVal5 pappyDvs5 pappyErr5 -> Parsed (Just pappyVal5) pappyDvs5 pappyErr5
            NoParse pappyErr5 -> Parsed (Nothing) pappyDvs1 pappyErr5
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanNA d of
        Parsed pappyVal3 pappyDvs3 pappyErr3 -> Parsed (Just pappyVal3) pappyDvs3 pappyErr3
        NoParse pappyErr3 -> Parsed (Nothing) d pappyErr3

lojbanParsejek :: LojbanDerivs -> Result LojbanDerivs (LogJboConnective)
lojbanParsejek d =
  case pappyResult1 of
    Parsed ln pappyDvs1 pappyErr1 ->
      case pappyResult3 of
        Parsed se pappyDvs3 pappyErr3 ->
          case pappyResult5 of
            Parsed conchar pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed rn pappyDvs7 pappyErr7 ->
                  Parsed (
                     LogJboConnective (ln /= Just "na") 
                    		    (if (isJust se) && conchar=='u' then 'U' else conchar)
                    		    (isNothing rn) ) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> NoParse (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case lojbanNAI pappyDvs5 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs5 pappyErr9
            NoParse pappyErr5 -> NoParse (maximum [pappyErr5,pappyErr3,pappyErr1])
          where
            pappyResult5 =
              pappyAlt7_1 (ParseError (lojbanPos pappyDvs3) []) where
                pappyAlt7_1 pappyErr7 =
                  case lojbanJA pappyDvs3 of
                    Parsed "ja" pappyDvs9 pappyErr9 ->
                      Parsed (
                        'a') pappyDvs9 (max pappyErr9 pappyErr7)
                    _ -> pappyAlt7_2 (max (ParseError (lojbanPos pappyDvs3) [Expected "ja"]) pappyErr7)
                pappyAlt7_2 pappyErr7 =
                  case lojbanJA pappyDvs3 of
                    Parsed "je" pappyDvs9 pappyErr9 ->
                      Parsed (
                        'e') pappyDvs9 (max pappyErr9 pappyErr7)
                    _ -> pappyAlt7_3 (max (ParseError (lojbanPos pappyDvs3) [Expected "je"]) pappyErr7)
                pappyAlt7_3 pappyErr7 =
                  case lojbanJA pappyDvs3 of
                    Parsed "jo" pappyDvs9 pappyErr9 ->
                      Parsed (
                        'o') pappyDvs9 (max pappyErr9 pappyErr7)
                    _ -> pappyAlt7_4 (max (ParseError (lojbanPos pappyDvs3) [Expected "jo"]) pappyErr7)
                pappyAlt7_4 pappyErr7 =
                  case lojbanJA pappyDvs3 of
                    Parsed "ju" pappyDvs9 pappyErr9 ->
                      Parsed (
                        'u') pappyDvs9 (max pappyErr9 pappyErr7)
                    _ -> pappyAlt7_5 (max (ParseError (lojbanPos pappyDvs3) [Expected "ju"]) pappyErr7)
                pappyAlt7_5 pappyErr7 =
                  case lojbanJA pappyDvs3 of
                    Parsed "je'i" pappyDvs9 pappyErr9 ->
                      Parsed (
                        'i') pappyDvs9 (max pappyErr9 pappyErr7)
                    _ -> pappyAlt7_6 (max (ParseError (lojbanPos pappyDvs3) [Expected "je'i"]) pappyErr7)
                pappyAlt7_6 pappyErr7 = NoParse pappyErr7
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanSE pappyDvs1 of
            Parsed pappyVal5 pappyDvs5 pappyErr5 -> Parsed (Just pappyVal5) pappyDvs5 pappyErr5
            NoParse pappyErr5 -> Parsed (Nothing) pappyDvs1 pappyErr5
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanNA d of
        Parsed pappyVal3 pappyDvs3 pappyErr3 -> Parsed (Just pappyVal3) pappyDvs3 pappyErr3
        NoParse pappyErr3 -> Parsed (Nothing) d pappyErr3

lojbanParsejoik :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanParsejoik d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case pappyResult3 of
        Parsed se pappyDvs3 pappyErr3 ->
          case pappyResult5 of
            Parsed joi pappyDvs5 pappyErr5 ->
              case lojbanpostClause pappyDvs5 of
                Parsed _ pappyDvs7 pappyErr7 ->
                  case pappyResult9 of
                    Parsed nai pappyDvs9 pappyErr9 ->
                      Parsed (
                         (fromMaybe "" se) ++ joi ++ (fromMaybe "" nai) ) pappyDvs9 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                    NoParse pappyErr9 -> pappyAlt1_2 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                  where
                    pappyResult9 =
                      case lojbanNAI pappyDvs7 of
                        Parsed pappyVal11 pappyDvs11 pappyErr11 -> Parsed (Just pappyVal11) pappyDvs11 pappyErr11
                        NoParse pappyErr11 -> Parsed (Nothing) pappyDvs7 pappyErr11
                NoParse pappyErr7 -> pappyAlt1_2 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
          where
            pappyResult5 =
              case lojbanChar pappyDvs3 of
                Parsed 'f' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'a' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed '\'' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed 'u' pappyDvs13 _ ->
                              Parsed (
                                "fa'u") pappyDvs13 (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'p' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'i' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed '\'' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed 'u' pappyDvs13 _ ->
                              Parsed (
                                "pi'u") pappyDvs13 (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'j' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'o' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'i' pappyDvs11 _ ->
                          Parsed (
                            "joi") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        Parsed '\'' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed 'u' pappyDvs13 _ ->
                              Parsed (
                                "jo'u") pappyDvs13 (ParseError (lojbanPos pappyDvs13) [])
                            Parsed 'e' pappyDvs13 _ ->
                              Parsed (
                                "jo'e") pappyDvs13 (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'u' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed '\'' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed 'e' pappyDvs13 _ ->
                              Parsed (
                                "ju'e") pappyDvs13 (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'c' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'e' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed '\'' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed 'o' pappyDvs13 _ ->
                              Parsed (
                                "ce'o") pappyDvs13 (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        _ ->
                          Parsed (
                            "ce") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'k' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'u' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed '\'' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed 'a' pappyDvs13 _ ->
                              Parsed (
                                "ku'a") pappyDvs13 (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanSE d of
            Parsed pappyVal5 pappyDvs5 pappyErr5 -> Parsed (Just pappyVal5) pappyDvs5 pappyErr5
            NoParse pappyErr5 -> Parsed (Nothing) d pappyErr5
    pappyAlt1_2 pappyErr1 =
      case lojbaninterval d of
        Parsed pappyVal3 pappyDvs3 pappyErr3 -> Parsed pappyVal3 pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 =
      case lojbanGAhO d of
        Parsed g1 pappyDvs3 pappyErr3 ->
          case lojbaninterval pappyDvs3 of
            Parsed i pappyDvs5 pappyErr5 ->
              case lojbanGAhO pappyDvs5 of
                Parsed g2 pappyDvs7 pappyErr7 ->
                  Parsed (
                     g1 ++ i ++ g2 ) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_4 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_4 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_4 (max pappyErr3 pappyErr1)
    pappyAlt1_4 pappyErr1 = NoParse pappyErr1

lojbanParseinterval :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanParseinterval d =
  case pappyResult1 of
    Parsed se pappyDvs1 pappyErr1 ->
      case pappyResult3 of
        Parsed bihi pappyDvs3 pappyErr3 ->
          case lojbanpostClause pappyDvs3 of
            Parsed _ pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed nai pappyDvs7 pappyErr7 ->
                  Parsed (
                     (fromMaybe "" se) ++ bihi ++ (fromMaybe "" nai) ) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> NoParse (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case lojbanNAI pappyDvs5 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs5 pappyErr9
            NoParse pappyErr5 -> NoParse (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanChar pappyDvs1 of
            Parsed 'm' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'i' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'i' pappyDvs11 _ ->
                          Parsed (
                            "mi'i") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'b' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'i' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed '\'' pappyDvs9 _ ->
                      case lojbanChar pappyDvs9 of
                        Parsed 'o' pappyDvs11 _ ->
                          Parsed (
                            "bi'o") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        Parsed 'i' pappyDvs11 _ ->
                          Parsed (
                            "bi'i") pappyDvs11 (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs1) [])
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanSE d of
        Parsed pappyVal3 pappyDvs3 pappyErr3 -> Parsed (Just pappyVal3) pappyDvs3 pappyErr3
        NoParse pappyErr3 -> Parsed (Nothing) d pappyErr3

lojbanjoikEk :: LojbanDerivs -> Result LojbanDerivs (JekJoik)
lojbanjoikEk d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanek d of
        Parsed jj pappyDvs3 pappyErr3 ->
          Parsed (
             JJJek jj ) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbanjoik d of
        Parsed jj pappyDvs3 pappyErr3 ->
          Parsed (
             JJJoik jj ) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanjoikJek :: LojbanDerivs -> Result LojbanDerivs (JekJoik)
lojbanjoikJek d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanjek d of
        Parsed jj pappyDvs3 pappyErr3 ->
          Parsed (
             JJJek jj ) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbanjoik d of
        Parsed jj pappyDvs3 pappyErr3 ->
          Parsed (
             JJJoik jj ) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanParsegek :: LojbanDerivs -> Result LojbanDerivs (Bool -> Connective)
lojbanParsegek d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case pappyResult3 of
        Parsed se pappyDvs3 pappyErr3 ->
          case pappyResult5 of
            Parsed conchar pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed ln pappyDvs7 pappyErr7 ->
                  Parsed (
                     jboConnLogOrQ Nothing . LogJboConnective (isNothing ln) 
                    		    (if (isJust se) && conchar=='u' then 'U' else conchar) ) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_2 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case lojbanNAI pappyDvs5 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs5 pappyErr9
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
          where
            pappyResult5 =
              pappyAlt7_1 (ParseError (lojbanPos pappyDvs3) []) where
                pappyAlt7_1 pappyErr7 =
                  case lojbanGA pappyDvs3 of
                    Parsed "ga" pappyDvs9 pappyErr9 ->
                      Parsed (
                        'a') pappyDvs9 (max pappyErr9 pappyErr7)
                    _ -> pappyAlt7_2 (max (ParseError (lojbanPos pappyDvs3) [Expected "ga"]) pappyErr7)
                pappyAlt7_2 pappyErr7 =
                  case lojbanGA pappyDvs3 of
                    Parsed "ge" pappyDvs9 pappyErr9 ->
                      Parsed (
                        'e') pappyDvs9 (max pappyErr9 pappyErr7)
                    _ -> pappyAlt7_3 (max (ParseError (lojbanPos pappyDvs3) [Expected "ge"]) pappyErr7)
                pappyAlt7_3 pappyErr7 =
                  case lojbanGA pappyDvs3 of
                    Parsed "go" pappyDvs9 pappyErr9 ->
                      Parsed (
                        'o') pappyDvs9 (max pappyErr9 pappyErr7)
                    _ -> pappyAlt7_4 (max (ParseError (lojbanPos pappyDvs3) [Expected "go"]) pappyErr7)
                pappyAlt7_4 pappyErr7 =
                  case lojbanGA pappyDvs3 of
                    Parsed "gu" pappyDvs9 pappyErr9 ->
                      Parsed (
                        'u') pappyDvs9 (max pappyErr9 pappyErr7)
                    _ -> pappyAlt7_5 (max (ParseError (lojbanPos pappyDvs3) [Expected "gu"]) pappyErr7)
                pappyAlt7_5 pappyErr7 =
                  case lojbanGA pappyDvs3 of
                    Parsed "ge'i" pappyDvs9 pappyErr9 ->
                      Parsed (
                        'i') pappyDvs9 (max pappyErr9 pappyErr7)
                    _ -> pappyAlt7_6 (max (ParseError (lojbanPos pappyDvs3) [Expected "ge'i"]) pappyErr7)
                pappyAlt7_6 pappyErr7 = NoParse pappyErr7
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanSE d of
            Parsed pappyVal5 pappyDvs5 pappyErr5 -> Parsed (Just pappyVal5) pappyDvs5 pappyErr5
            NoParse pappyErr5 -> Parsed (Nothing) d pappyErr5
    pappyAlt1_2 pappyErr1 =
      case lojbanjoik d of
        Parsed joik pappyDvs3 pappyErr3 ->
          case lojbanGI pappyDvs3 of
            Parsed _ pappyDvs5 pappyErr5 ->
              Parsed (
                 \_ -> JboConnJoik Nothing joik ) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_3 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 =
      case lojbantag d of
        Parsed tag pappyDvs3 pappyErr3 ->
          case lojbangik pappyDvs3 of
            Parsed _ pappyDvs5 pappyErr5 ->
              Parsed (
                 \_ -> jboConnLogOrQ (Just tag) (LogJboConnective True 'e' True) ) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_4 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_4 (max pappyErr3 pappyErr1)
    pappyAlt1_4 pappyErr1 = NoParse pappyErr1

lojbanParseguhek :: LojbanDerivs -> Result LojbanDerivs (Bool -> LogJboConnective)
lojbanParseguhek d =
  case pappyResult1 of
    Parsed se pappyDvs1 pappyErr1 ->
      case pappyResult3 of
        Parsed conchar pappyDvs3 pappyErr3 ->
          case pappyResult5 of
            Parsed ln pappyDvs5 pappyErr5 ->
              Parsed (
                 LogJboConnective (isNothing ln) 
                		    (if (isJust se) && conchar=='u' then 'U' else conchar) ) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> NoParse (maximum [pappyErr5,pappyErr3,pappyErr1])
          where
            pappyResult5 =
              case lojbanNAI pappyDvs3 of
                Parsed pappyVal7 pappyDvs7 pappyErr7 -> Parsed (Just pappyVal7) pappyDvs7 pappyErr7
                NoParse pappyErr7 -> Parsed (Nothing) pappyDvs3 pappyErr7
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          pappyAlt5_1 (ParseError (lojbanPos pappyDvs1) []) where
            pappyAlt5_1 pappyErr5 =
              case lojbanGUhA pappyDvs1 of
                Parsed "gu'a" pappyDvs7 pappyErr7 ->
                  Parsed (
                    'a') pappyDvs7 (max pappyErr7 pappyErr5)
                _ -> pappyAlt5_2 (max (ParseError (lojbanPos pappyDvs1) [Expected "gu'a"]) pappyErr5)
            pappyAlt5_2 pappyErr5 =
              case lojbanGUhA pappyDvs1 of
                Parsed "gu'e" pappyDvs7 pappyErr7 ->
                  Parsed (
                    'e') pappyDvs7 (max pappyErr7 pappyErr5)
                _ -> pappyAlt5_3 (max (ParseError (lojbanPos pappyDvs1) [Expected "gu'e"]) pappyErr5)
            pappyAlt5_3 pappyErr5 =
              case lojbanGUhA pappyDvs1 of
                Parsed "gu'o" pappyDvs7 pappyErr7 ->
                  Parsed (
                    'o') pappyDvs7 (max pappyErr7 pappyErr5)
                _ -> pappyAlt5_4 (max (ParseError (lojbanPos pappyDvs1) [Expected "gu'o"]) pappyErr5)
            pappyAlt5_4 pappyErr5 =
              case lojbanGUhA pappyDvs1 of
                Parsed "gu'u" pappyDvs7 pappyErr7 ->
                  Parsed (
                    'u') pappyDvs7 (max pappyErr7 pappyErr5)
                _ -> pappyAlt5_5 (max (ParseError (lojbanPos pappyDvs1) [Expected "gu'u"]) pappyErr5)
            pappyAlt5_5 pappyErr5 =
              case lojbanGUhA pappyDvs1 of
                Parsed "gu'i" pappyDvs7 pappyErr7 ->
                  Parsed (
                    'i') pappyDvs7 (max pappyErr7 pappyErr5)
                _ -> pappyAlt5_6 (max (ParseError (lojbanPos pappyDvs1) [Expected "gu'i"]) pappyErr5)
            pappyAlt5_6 pappyErr5 = NoParse pappyErr5
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanSE d of
        Parsed pappyVal3 pappyDvs3 pappyErr3 -> Parsed (Just pappyVal3) pappyDvs3 pappyErr3
        NoParse pappyErr3 -> Parsed (Nothing) d pappyErr3

lojbangik :: LojbanDerivs -> Result LojbanDerivs (Bool)
lojbangik d =
  case lojbanGI d of
    Parsed _ pappyDvs1 pappyErr1 ->
      case pappyResult3 of
        Parsed rn pappyDvs3 pappyErr3 ->
          Parsed (
             isNothing rn ) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanNAI pappyDvs1 of
            Parsed pappyVal5 pappyDvs5 pappyErr5 -> Parsed (Just pappyVal5) pappyDvs5 pappyErr5
            NoParse pappyErr5 -> Parsed (Nothing) pappyDvs1 pappyErr5
    NoParse pappyErr1 -> NoParse pappyErr1

lojbantagFA :: LojbanDerivs -> Result LojbanDerivs (Int)
lojbantagFA d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanFA d of
        Parsed _ pappyDvs3 pappyErr3 ->
          case lojbanxiLit pappyDvs3 of
            Parsed n pappyDvs5 pappyErr5 ->
              Parsed (n) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbanFA d of
        Parsed "fa" pappyDvs3 pappyErr3 ->
          Parsed (
            1) pappyDvs3 (max pappyErr3 pappyErr1)
        _ -> pappyAlt1_3 (max (ParseError (lojbanPos d) [Expected "fa"]) pappyErr1)
    pappyAlt1_3 pappyErr1 =
      case lojbanFA d of
        Parsed "fe" pappyDvs3 pappyErr3 ->
          Parsed (
            2) pappyDvs3 (max pappyErr3 pappyErr1)
        _ -> pappyAlt1_4 (max (ParseError (lojbanPos d) [Expected "fe"]) pappyErr1)
    pappyAlt1_4 pappyErr1 =
      case lojbanFA d of
        Parsed "fi" pappyDvs3 pappyErr3 ->
          Parsed (
            3) pappyDvs3 (max pappyErr3 pappyErr1)
        _ -> pappyAlt1_5 (max (ParseError (lojbanPos d) [Expected "fi"]) pappyErr1)
    pappyAlt1_5 pappyErr1 =
      case lojbanFA d of
        Parsed "fo" pappyDvs3 pappyErr3 ->
          Parsed (
            4) pappyDvs3 (max pappyErr3 pappyErr1)
        _ -> pappyAlt1_6 (max (ParseError (lojbanPos d) [Expected "fo"]) pappyErr1)
    pappyAlt1_6 pappyErr1 =
      case lojbanFA d of
        Parsed "fu" pappyDvs3 pappyErr3 ->
          Parsed (
            5) pappyDvs3 (max pappyErr3 pappyErr1)
        _ -> pappyAlt1_7 (max (ParseError (lojbanPos d) [Expected "fu"]) pappyErr1)
    pappyAlt1_7 pappyErr1 = NoParse pappyErr1

lojbanParseStarRule28 :: LojbanDerivs -> Result LojbanDerivs ([(Connective, Tag)])
lojbanParseStarRule28 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case pappyResult3 of
        Parsed v pappyDvs3 pappyErr3 ->
          case lojbanStarRule28 pappyDvs3 of
            Parsed vs pappyDvs5 pappyErr5 ->
              Parsed (
                v : vs) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanjoikJek d of
            Parsed jj pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed tag pappyDvs7 pappyErr7 ->
                  Parsed (
                    (jjJboCon Nothing jj,tag)) pappyDvs7 (max pappyErr7 pappyErr5)
                NoParse pappyErr7 -> NoParse (max pappyErr7 pappyErr5)
              where
                pappyResult7 =
                  case lojbanPlusRule12 pappyDvs5 of
                    Parsed dtus pappyDvs9 pappyErr9 ->
                      Parsed (
                        DecoratedTagUnits dtus) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> NoParse pappyErr9
            NoParse pappyErr5 -> NoParse pappyErr5
    pappyAlt1_2 pappyErr1 =
      Parsed (
        []) d pappyErr1
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbantag :: LojbanDerivs -> Result LojbanDerivs (Tag)
lojbantag d =
  case pappyResult1 of
    Parsed tag pappyDvs1 pappyErr1 ->
      case lojbanStarRule28 pappyDvs1 of
        Parsed jekts pappyDvs3 pappyErr3 ->
          Parsed (
             foldl (\t1 -> \(con,t2) -> ConnectedTag con t1 t2) tag jekts ) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanPlusRule12 d of
        Parsed dtus pappyDvs3 pappyErr3 ->
          Parsed (
            DecoratedTagUnits dtus) pappyDvs3 pappyErr3
        NoParse pappyErr3 -> NoParse pappyErr3

lojbanParsePlusRule12 :: LojbanDerivs -> Result LojbanDerivs ([DecoratedTagUnit])
lojbanParsePlusRule12 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbandecoratedTagUnit d of
        Parsed v pappyDvs3 pappyErr3 ->
          case lojbanPlusRule12 pappyDvs3 of
            Parsed vs pappyDvs5 pappyErr5 ->
              Parsed (
                v : vs) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbandecoratedTagUnit d of
        Parsed v pappyDvs3 pappyErr3 ->
          Parsed (
            [v]) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanParsedecoratedTagUnit :: LojbanDerivs -> Result LojbanDerivs (DecoratedTagUnit)
lojbanParsedecoratedTagUnit d =
  case pappyResult1 of
    Parsed nahe pappyDvs1 pappyErr1 ->
      case pappyResult3 of
        Parsed se pappyDvs3 pappyErr3 ->
          case pappyResult5 of
            Parsed tu pappyDvs5 pappyErr5 ->
              case pappyResult7 of
                Parsed nai pappyDvs7 pappyErr7 ->
                  Parsed (
                     DecoratedTagUnit nahe se (isJust nai) tu ) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> NoParse (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
              where
                pappyResult7 =
                  case lojbanNAI pappyDvs5 of
                    Parsed pappyVal9 pappyDvs9 pappyErr9 -> Parsed (Just pappyVal9) pappyDvs9 pappyErr9
                    NoParse pappyErr9 -> Parsed (Nothing) pappyDvs5 pappyErr9
            NoParse pappyErr5 -> NoParse (maximum [pappyErr5,pappyErr3,pappyErr1])
          where
            pappyResult5 =
              pappyAlt7_1 (ParseError (lojbanPos pappyDvs3) []) where
                pappyAlt7_1 pappyErr7 =
                  case pappyResult9 of
                    Parsed s pappyDvs9 pappyErr9 ->
                      Parsed (
                        TenseCmavo s) pappyDvs9 (max pappyErr9 pappyErr7)
                    NoParse pappyErr9 -> pappyAlt7_2 (max pappyErr9 pappyErr7)
                  where
                    pappyResult9 =
                      pappyAlt11_1 (ParseError (lojbanPos pappyDvs3) []) where
                        pappyAlt11_1 pappyErr11 =
                          case pappyResult13 of
                            Parsed s pappyDvs13 pappyErr13 ->
                              case lojbanpostClause pappyDvs13 of
                                Parsed _ pappyDvs15 pappyErr15 ->
                                  Parsed (s) pappyDvs15 (maximum [pappyErr15,pappyErr13,pappyErr11])
                                NoParse pappyErr15 -> pappyAlt11_2 (maximum [pappyErr15,pappyErr13,pappyErr11])
                            NoParse pappyErr13 -> pappyAlt11_2 (max pappyErr13 pappyErr11)
                          where
                            pappyResult13 =
                              case lojbanChar pappyDvs3 of
                                Parsed 'b' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'a' pappyDvs17 _ ->
                                      Parsed (
                                        "ba") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                Parsed 'p' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'u' pappyDvs17 _ ->
                                      Parsed (
                                        "pu") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                Parsed 'c' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'a' pappyDvs17 _ ->
                                      Parsed (
                                        "ca") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
                        pappyAlt11_2 pappyErr11 =
                          case pappyResult13 of
                            Parsed s pappyDvs13 pappyErr13 ->
                              case lojbanpostClause pappyDvs13 of
                                Parsed _ pappyDvs15 pappyErr15 ->
                                  Parsed (s) pappyDvs15 (maximum [pappyErr15,pappyErr13,pappyErr11])
                                NoParse pappyErr15 -> pappyAlt11_3 (maximum [pappyErr15,pappyErr13,pappyErr11])
                            NoParse pappyErr13 -> pappyAlt11_3 (max pappyErr13 pappyErr11)
                          where
                            pappyResult13 =
                              case lojbanChar pappyDvs3 of
                                Parsed 'z' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'u' pappyDvs17 _ ->
                                      Parsed (
                                        "zu") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    Parsed 'a' pappyDvs17 _ ->
                                      Parsed (
                                        "za") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    Parsed 'i' pappyDvs17 _ ->
                                      Parsed (
                                        "zi") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
                        pappyAlt11_3 pappyErr11 =
                          case pappyResult13 of
                            Parsed s pappyDvs13 pappyErr13 ->
                              case lojbanpostClause pappyDvs13 of
                                Parsed _ pappyDvs15 pappyErr15 ->
                                  Parsed (s) pappyDvs15 (maximum [pappyErr15,pappyErr13,pappyErr11])
                                NoParse pappyErr15 -> pappyAlt11_4 (maximum [pappyErr15,pappyErr13,pappyErr11])
                            NoParse pappyErr13 -> pappyAlt11_4 (max pappyErr13 pappyErr11)
                          where
                            pappyResult13 =
                              case lojbanChar pappyDvs3 of
                                Parsed 'z' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'e' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed '\'' pappyDvs19 _ ->
                                          case lojbanChar pappyDvs19 of
                                            Parsed 'u' pappyDvs21 _ ->
                                              Parsed (
                                                "ze'u") pappyDvs21 (ParseError (lojbanPos pappyDvs21) [])
                                            Parsed 'a' pappyDvs21 _ ->
                                              Parsed (
                                                "ze'a") pappyDvs21 (ParseError (lojbanPos pappyDvs21) [])
                                            Parsed 'i' pappyDvs21 _ ->
                                              Parsed (
                                                "ze'i") pappyDvs21 (ParseError (lojbanPos pappyDvs21) [])
                                            Parsed 'e' pappyDvs21 _ ->
                                              Parsed (
                                                "ze'e") pappyDvs21 (ParseError (lojbanPos pappyDvs21) [])
                                            _ -> NoParse (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
                        pappyAlt11_4 pappyErr11 =
                          case pappyResult13 of
                            Parsed s pappyDvs13 pappyErr13 ->
                              case lojbanpostClause pappyDvs13 of
                                Parsed _ pappyDvs15 pappyErr15 ->
                                  Parsed (s) pappyDvs15 (maximum [pappyErr15,pappyErr13,pappyErr11])
                                NoParse pappyErr15 -> pappyAlt11_5 (maximum [pappyErr15,pappyErr13,pappyErr11])
                            NoParse pappyErr13 -> pappyAlt11_5 (max pappyErr13 pappyErr11)
                          where
                            pappyResult13 =
                              case lojbanChar pappyDvs3 of
                                Parsed 'v' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'i' pappyDvs17 _ ->
                                      Parsed (
                                        "vi") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    Parsed 'a' pappyDvs17 _ ->
                                      Parsed (
                                        "va") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    Parsed 'u' pappyDvs17 _ ->
                                      Parsed (
                                        "vu") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
                        pappyAlt11_5 pappyErr11 =
                          case pappyResult13 of
                            Parsed s pappyDvs13 pappyErr13 ->
                              case lojbanpostClause pappyDvs13 of
                                Parsed _ pappyDvs15 pappyErr15 ->
                                  Parsed (s) pappyDvs15 (maximum [pappyErr15,pappyErr13,pappyErr11])
                                NoParse pappyErr15 -> pappyAlt11_6 (maximum [pappyErr15,pappyErr13,pappyErr11])
                            NoParse pappyErr13 -> pappyAlt11_6 (max pappyErr13 pappyErr11)
                          where
                            pappyResult13 =
                              case lojbanChar pappyDvs3 of
                                Parsed 'v' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'e' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed '\'' pappyDvs19 _ ->
                                          case lojbanChar pappyDvs19 of
                                            Parsed 'u' pappyDvs21 _ ->
                                              Parsed (
                                                "ve'u") pappyDvs21 (ParseError (lojbanPos pappyDvs21) [])
                                            Parsed 'a' pappyDvs21 _ ->
                                              Parsed (
                                                "ve'a") pappyDvs21 (ParseError (lojbanPos pappyDvs21) [])
                                            Parsed 'i' pappyDvs21 _ ->
                                              Parsed (
                                                "ve'i") pappyDvs21 (ParseError (lojbanPos pappyDvs21) [])
                                            Parsed 'e' pappyDvs21 _ ->
                                              Parsed (
                                                "ve'e") pappyDvs21 (ParseError (lojbanPos pappyDvs21) [])
                                            _ -> NoParse (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
                        pappyAlt11_6 pappyErr11 =
                          case pappyResult13 of
                            Parsed s pappyDvs13 pappyErr13 ->
                              case lojbanpostClause pappyDvs13 of
                                Parsed _ pappyDvs15 pappyErr15 ->
                                  Parsed (s) pappyDvs15 (maximum [pappyErr15,pappyErr13,pappyErr11])
                                NoParse pappyErr15 -> pappyAlt11_7 (maximum [pappyErr15,pappyErr13,pappyErr11])
                            NoParse pappyErr13 -> pappyAlt11_7 (max pappyErr13 pappyErr11)
                          where
                            pappyResult13 =
                              case lojbanChar pappyDvs3 of
                                Parsed 'v' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'i' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed '\'' pappyDvs19 _ ->
                                          case lojbanChar pappyDvs19 of
                                            Parsed 'i' pappyDvs21 _ ->
                                              Parsed (
                                                "vi'i") pappyDvs21 (ParseError (lojbanPos pappyDvs21) [])
                                            Parsed 'a' pappyDvs21 _ ->
                                              Parsed (
                                                "vi'a") pappyDvs21 (ParseError (lojbanPos pappyDvs21) [])
                                            Parsed 'u' pappyDvs21 _ ->
                                              Parsed (
                                                "vi'u") pappyDvs21 (ParseError (lojbanPos pappyDvs21) [])
                                            Parsed 'e' pappyDvs21 _ ->
                                              Parsed (
                                                "vi'e") pappyDvs21 (ParseError (lojbanPos pappyDvs21) [])
                                            _ -> NoParse (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
                        pappyAlt11_7 pappyErr11 = NoParse pappyErr11
                pappyAlt7_2 pappyErr7 =
                  case pappyResult9 of
                    Parsed s pappyDvs9 pappyErr9 ->
                      case lojbanpostClause pappyDvs9 of
                        Parsed _ pappyDvs11 pappyErr11 ->
                          Parsed (
                            CAhA s) pappyDvs11 (maximum [pappyErr11,pappyErr9,pappyErr7])
                        NoParse pappyErr11 -> pappyAlt7_3 (maximum [pappyErr11,pappyErr9,pappyErr7])
                    NoParse pappyErr9 -> pappyAlt7_3 (max pappyErr9 pappyErr7)
                  where
                    pappyResult9 =
                      case lojbanChar pappyDvs3 of
                        Parsed 'c' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed 'a' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed '\'' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'a' pappyDvs17 _ ->
                                      Parsed (
                                        "ca'a") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        Parsed 'p' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed 'u' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed '\'' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'i' pappyDvs17 _ ->
                                      Parsed (
                                        "pu'i") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        Parsed 'n' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed 'u' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed '\'' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'o' pappyDvs17 _ ->
                                      Parsed (
                                        "nu'o") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        Parsed 'k' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed 'a' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed '\'' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'e' pappyDvs17 _ ->
                                      Parsed (
                                        "ka'e") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
                pappyAlt7_3 pappyErr7 =
                  case pappyResult9 of
                    Parsed s pappyDvs9 pappyErr9 ->
                      case lojbanpostClause pappyDvs9 of
                        Parsed _ pappyDvs11 pappyErr11 ->
                          Parsed (
                            BAI s) pappyDvs11 (maximum [pappyErr11,pappyErr9,pappyErr7])
                        NoParse pappyErr11 -> pappyAlt7_4 (maximum [pappyErr11,pappyErr9,pappyErr7])
                    NoParse pappyErr9 -> pappyAlt7_4 (max pappyErr9 pappyErr7)
                  where
                    pappyResult9 =
                      case lojbanChar pappyDvs3 of
                        Parsed 'd' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed 'u' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed '\'' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'o' pappyDvs17 _ ->
                                      Parsed (
                                        "du'o") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    Parsed 'i' pappyDvs17 _ ->
                                      Parsed (
                                        "du'i") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            Parsed 'i' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed '\'' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'o' pappyDvs17 _ ->
                                      Parsed (
                                        "di'o") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            Parsed 'e' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed '\'' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'i' pappyDvs17 _ ->
                                      Parsed (
                                        "de'i") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            Parsed 'o' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed '\'' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'e' pappyDvs17 _ ->
                                      Parsed (
                                        "do'e") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        Parsed 's' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed 'i' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed '\'' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'u' pappyDvs17 _ ->
                                      Parsed (
                                        "si'u") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            Parsed 'a' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed 'u' pappyDvs15 _ ->
                                  Parsed (
                                    "sau") pappyDvs15 (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        Parsed 'z' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed 'a' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed 'u' pappyDvs15 _ ->
                                  Parsed (
                                    "zau") pappyDvs15 (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            Parsed 'u' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed '\'' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'e' pappyDvs17 _ ->
                                      Parsed (
                                        "zu'e") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        Parsed 'k' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed 'i' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed '\'' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'i' pappyDvs17 _ ->
                                      Parsed (
                                        "ki'i") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    Parsed 'u' pappyDvs17 _ ->
                                      Parsed (
                                        "ki'u") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            Parsed 'o' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed 'i' pappyDvs15 _ ->
                                  Parsed (
                                    "koi") pappyDvs15 (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            Parsed 'a' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed 'i' pappyDvs15 _ ->
                                  Parsed (
                                    "kai") pappyDvs15 (ParseError (lojbanPos pappyDvs15) [])
                                Parsed '\'' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'a' pappyDvs17 _ ->
                                      Parsed (
                                        "ka'a") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    Parsed 'i' pappyDvs17 _ ->
                                      Parsed (
                                        "ka'i") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            Parsed 'u' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed '\'' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'u' pappyDvs17 _ ->
                                      Parsed (
                                        "ku'u") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        Parsed 'c' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed 'u' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed '\'' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'u' pappyDvs17 _ ->
                                      Parsed (
                                        "cu'u") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            Parsed 'a' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed '\'' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'i' pappyDvs17 _ ->
                                      Parsed (
                                        "ca'i") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                Parsed 'u' pappyDvs15 _ ->
                                  Parsed (
                                    "cau") pappyDvs15 (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            Parsed 'i' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed '\'' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'o' pappyDvs17 _ ->
                                      Parsed (
                                        "ci'o") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    Parsed 'e' pappyDvs17 _ ->
                                      Parsed (
                                        "ci'e") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    Parsed 'u' pappyDvs17 _ ->
                                      Parsed (
                                        "ci'u") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        Parsed 't' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed 'u' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed '\'' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'i' pappyDvs17 _ ->
                                      Parsed (
                                        "tu'i") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            Parsed 'i' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed '\'' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'u' pappyDvs17 _ ->
                                      Parsed (
                                        "ti'u") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    Parsed 'i' pappyDvs17 _ ->
                                      Parsed (
                                        "ti'i") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            Parsed 'a' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed '\'' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'i' pappyDvs17 _ ->
                                      Parsed (
                                        "ta'i") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                Parsed 'i' pappyDvs15 _ ->
                                  Parsed (
                                    "tai") pappyDvs15 (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        Parsed 'j' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed 'i' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed '\'' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'u' pappyDvs17 _ ->
                                      Parsed (
                                        "ji'u") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    Parsed 'o' pappyDvs17 _ ->
                                      Parsed (
                                        "ji'o") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    Parsed 'e' pappyDvs17 _ ->
                                      Parsed (
                                        "ji'e") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            Parsed 'a' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed '\'' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'i' pappyDvs17 _ ->
                                      Parsed (
                                        "ja'i") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    Parsed 'e' pappyDvs17 _ ->
                                      Parsed (
                                        "ja'e") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        Parsed 'r' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed 'i' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed '\'' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'a' pappyDvs17 _ ->
                                      Parsed (
                                        "ri'a") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    Parsed 'i' pappyDvs17 _ ->
                                      Parsed (
                                        "ri'i") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            Parsed 'a' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed '\'' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'i' pappyDvs17 _ ->
                                      Parsed (
                                        "ra'i") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    Parsed 'a' pappyDvs17 _ ->
                                      Parsed (
                                        "ra'a") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                Parsed 'i' pappyDvs15 _ ->
                                  Parsed (
                                    "rai") pappyDvs15 (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        Parsed 'n' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed 'i' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed '\'' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'i' pappyDvs17 _ ->
                                      Parsed (
                                        "ni'i") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        Parsed 'm' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed 'u' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed '\'' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'i' pappyDvs17 _ ->
                                      Parsed (
                                        "mu'i") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    Parsed 'u' pappyDvs17 _ ->
                                      Parsed (
                                        "mu'u") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            Parsed 'a' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed 'u' pappyDvs15 _ ->
                                  Parsed (
                                    "mau") pappyDvs15 (ParseError (lojbanPos pappyDvs15) [])
                                Parsed '\'' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'i' pappyDvs17 _ ->
                                      Parsed (
                                        "ma'i") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    Parsed 'e' pappyDvs17 _ ->
                                      Parsed (
                                        "ma'e") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            Parsed 'e' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed '\'' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'a' pappyDvs17 _ ->
                                      Parsed (
                                        "me'a") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    Parsed 'e' pappyDvs17 _ ->
                                      Parsed (
                                        "me'e") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        Parsed 'v' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed 'a' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed '\'' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'u' pappyDvs17 _ ->
                                      Parsed (
                                        "va'u") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    Parsed 'o' pappyDvs17 _ ->
                                      Parsed (
                                        "va'o") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        Parsed 'p' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed 'u' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed '\'' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'e' pappyDvs17 _ ->
                                      Parsed (
                                        "pu'e") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    Parsed 'a' pappyDvs17 _ ->
                                      Parsed (
                                        "pu'a") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            Parsed 'a' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed '\'' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'u' pappyDvs17 _ ->
                                      Parsed (
                                        "pa'u") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    Parsed 'a' pappyDvs17 _ ->
                                      Parsed (
                                        "pa'a") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            Parsed 'o' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed '\'' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'i' pappyDvs17 _ ->
                                      Parsed (
                                        "po'i") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            Parsed 'i' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed '\'' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'o' pappyDvs17 _ ->
                                      Parsed (
                                        "pi'o") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        Parsed 'b' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed 'a' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed 'i' pappyDvs15 _ ->
                                  Parsed (
                                    "bai") pappyDvs15 (ParseError (lojbanPos pappyDvs15) [])
                                Parsed 'u' pappyDvs15 _ ->
                                  Parsed (
                                    "bau") pappyDvs15 (ParseError (lojbanPos pappyDvs15) [])
                                Parsed '\'' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'i' pappyDvs17 _ ->
                                      Parsed (
                                        "ba'i") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            Parsed 'e' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed '\'' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'i' pappyDvs17 _ ->
                                      Parsed (
                                        "be'i") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        Parsed 'f' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed 'i' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed '\'' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'e' pappyDvs17 _ ->
                                      Parsed (
                                        "fi'e") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            Parsed 'a' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed 'u' pappyDvs15 _ ->
                                  Parsed (
                                    "fau") pappyDvs15 (ParseError (lojbanPos pappyDvs15) [])
                                Parsed '\'' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'e' pappyDvs17 _ ->
                                      Parsed (
                                        "fa'e") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        Parsed 'l' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed 'e' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed '\'' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'a' pappyDvs17 _ ->
                                      Parsed (
                                        "le'a") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            Parsed 'i' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed '\'' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'e' pappyDvs17 _ ->
                                      Parsed (
                                        "li'e") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            Parsed 'a' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed '\'' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'u' pappyDvs17 _ ->
                                      Parsed (
                                        "la'u") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        Parsed 'g' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed 'a' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed '\'' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'a' pappyDvs17 _ ->
                                      Parsed (
                                        "ga'a") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                Parsed 'u' pappyDvs15 _ ->
                                  Parsed (
                                    "gau") pappyDvs15 (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
                pappyAlt7_4 pappyErr7 =
                  case pappyResult9 of
                    Parsed m pappyDvs9 pappyErr9 ->
                      case pappyResult11 of
                        Parsed f pappyDvs11 pappyErr11 ->
                          case lojbanpostClause pappyDvs11 of
                            Parsed _ pappyDvs13 pappyErr13 ->
                              Parsed (
                                 FAhA (isJust m) f ) pappyDvs13 (maximum [pappyErr13,pappyErr11,pappyErr9,pappyErr7])
                            NoParse pappyErr13 -> pappyAlt7_5 (maximum [pappyErr13,pappyErr11,pappyErr9,pappyErr7])
                        NoParse pappyErr11 -> pappyAlt7_5 (maximum [pappyErr11,pappyErr9,pappyErr7])
                      where
                        pappyResult11 =
                          case lojbanChar pappyDvs9 of
                            Parsed 'd' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed 'u' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed '\'' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed 'a' pappyDvs19 _ ->
                                          Parsed (
                                            "du'a") pappyDvs19 (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            Parsed 'b' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed 'e' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed '\'' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed 'a' pappyDvs19 _ ->
                                          Parsed (
                                            "be'a") pappyDvs19 (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                Parsed 'u' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed '\'' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed 'u' pappyDvs19 _ ->
                                          Parsed (
                                            "bu'u") pappyDvs19 (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            Parsed 'n' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed 'e' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed '\'' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed 'u' pappyDvs19 _ ->
                                          Parsed (
                                            "ne'u") pappyDvs19 (ParseError (lojbanPos pappyDvs19) [])
                                        Parsed 'a' pappyDvs19 _ ->
                                          Parsed (
                                            "ne'a") pappyDvs19 (ParseError (lojbanPos pappyDvs19) [])
                                        Parsed 'i' pappyDvs19 _ ->
                                          Parsed (
                                            "ne'i") pappyDvs19 (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                Parsed 'i' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed '\'' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed 'a' pappyDvs19 _ ->
                                          Parsed (
                                            "ni'a") pappyDvs19 (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            Parsed 'v' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed 'u' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed '\'' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed 'a' pappyDvs19 _ ->
                                          Parsed (
                                            "vu'a") pappyDvs19 (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            Parsed 'g' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed 'a' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed '\'' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed 'u' pappyDvs19 _ ->
                                          Parsed (
                                            "ga'u") pappyDvs19 (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            Parsed 't' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed 'i' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed '\'' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed 'a' pappyDvs19 _ ->
                                          Parsed (
                                            "ti'a") pappyDvs19 (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                Parsed 'e' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed '\'' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed 'e' pappyDvs19 _ ->
                                          Parsed (
                                            "te'e") pappyDvs19 (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                Parsed 'o' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed '\'' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed 'o' pappyDvs19 _ ->
                                          Parsed (
                                            "to'o") pappyDvs19 (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            Parsed 'c' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed 'a' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed '\'' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed 'u' pappyDvs19 _ ->
                                          Parsed (
                                            "ca'u") pappyDvs19 (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            Parsed 'z' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed 'u' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed '\'' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed 'a' pappyDvs19 _ ->
                                          Parsed (
                                            "zu'a") pappyDvs19 (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                Parsed 'o' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed '\'' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed 'i' pappyDvs19 _ ->
                                          Parsed (
                                            "zo'i") pappyDvs19 (ParseError (lojbanPos pappyDvs19) [])
                                        Parsed 'a' pappyDvs19 _ ->
                                          Parsed (
                                            "zo'a") pappyDvs19 (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                Parsed 'e' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed '\'' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed 'o' pappyDvs19 _ ->
                                          Parsed (
                                            "ze'o") pappyDvs19 (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            Parsed 'r' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed 'i' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed '\'' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed 'u' pappyDvs19 _ ->
                                          Parsed (
                                            "ri'u") pappyDvs19 (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                Parsed 'u' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed '\'' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed 'u' pappyDvs19 _ ->
                                          Parsed (
                                            "ru'u") pappyDvs19 (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                Parsed 'e' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed '\'' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed 'o' pappyDvs19 _ ->
                                          Parsed (
                                            "re'o") pappyDvs19 (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            Parsed 'p' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed 'a' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed '\'' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed 'o' pappyDvs19 _ ->
                                          Parsed (
                                            "pa'o") pappyDvs19 (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            Parsed 'f' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed 'a' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed '\'' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed 'a' pappyDvs19 _ ->
                                          Parsed (
                                            "fa'a") pappyDvs19 (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                    NoParse pappyErr9 -> pappyAlt7_5 (max pappyErr9 pappyErr7)
                  where
                    pappyResult9 =
                      case pappyResult11 of
                        Parsed pappyVal11 pappyDvs11 pappyErr11 -> Parsed (Just pappyVal11) pappyDvs11 pappyErr11
                        NoParse pappyErr11 -> Parsed (Nothing) pappyDvs3 pappyErr11
                      where
                        pappyResult11 =
                          case pappyResult13 of
                            Parsed s pappyDvs13 pappyErr13 ->
                              case lojbanpostClause pappyDvs13 of
                                Parsed _ pappyDvs15 pappyErr15 ->
                                  Parsed (s) pappyDvs15 (max pappyErr15 pappyErr13)
                                NoParse pappyErr15 -> NoParse (max pappyErr15 pappyErr13)
                            NoParse pappyErr13 -> NoParse pappyErr13
                          where
                            pappyResult13 =
                              case lojbanChar pappyDvs3 of
                                Parsed 'm' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'o' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed '\'' pappyDvs19 _ ->
                                          case lojbanChar pappyDvs19 of
                                            Parsed 'i' pappyDvs21 _ ->
                                              Parsed (
                                                "mo'i") pappyDvs21 (ParseError (lojbanPos pappyDvs21) [])
                                            _ -> NoParse (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
                pappyAlt7_5 pappyErr7 =
                  case pappyResult9 of
                    Parsed f pappyDvs9 pappyErr9 ->
                      case lojbannumber pappyDvs9 of
                        Parsed q pappyDvs11 pappyErr11 ->
                          case pappyResult13 of
                            Parsed r pappyDvs13 pappyErr13 ->
                              case lojbanpostClause pappyDvs13 of
                                Parsed _ pappyDvs15 pappyErr15 ->
                                  Parsed (
                                     ROI r (isJust f) q ) pappyDvs15 (maximum [pappyErr15,pappyErr13,pappyErr11,pappyErr9,pappyErr7])
                                NoParse pappyErr15 -> pappyAlt7_6 (maximum [pappyErr15,pappyErr13,pappyErr11,pappyErr9,pappyErr7])
                            NoParse pappyErr13 -> pappyAlt7_6 (maximum [pappyErr13,pappyErr11,pappyErr9,pappyErr7])
                          where
                            pappyResult13 =
                              case lojbanChar pappyDvs11 of
                                Parsed 'r' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'e' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed '\'' pappyDvs19 _ ->
                                          case lojbanChar pappyDvs19 of
                                            Parsed 'u' pappyDvs21 _ ->
                                              Parsed (
                                                "re'u") pappyDvs21 (ParseError (lojbanPos pappyDvs21) [])
                                            _ -> NoParse (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs17) [])
                                    Parsed 'o' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed 'i' pappyDvs19 _ ->
                                          Parsed (
                                            "roi") pappyDvs19 (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        NoParse pappyErr11 -> pappyAlt7_6 (maximum [pappyErr11,pappyErr9,pappyErr7])
                    NoParse pappyErr9 -> pappyAlt7_6 (max pappyErr9 pappyErr7)
                  where
                    pappyResult9 =
                      case lojbanFEhE pappyDvs3 of
                        Parsed pappyVal11 pappyDvs11 pappyErr11 -> Parsed (Just pappyVal11) pappyDvs11 pappyErr11
                        NoParse pappyErr11 -> Parsed (Nothing) pappyDvs3 pappyErr11
                pappyAlt7_6 pappyErr7 =
                  case pappyResult9 of
                    Parsed f pappyDvs9 pappyErr9 ->
                      case pappyResult11 of
                        Parsed s pappyDvs11 pappyErr11 ->
                          Parsed (
                             TAhE_ZAhO (isJust f) s ) pappyDvs11 (maximum [pappyErr11,pappyErr9,pappyErr7])
                        NoParse pappyErr11 -> pappyAlt7_7 (maximum [pappyErr11,pappyErr9,pappyErr7])
                      where
                        pappyResult11 =
                          pappyAlt13_1 (ParseError (lojbanPos pappyDvs9) []) where
                            pappyAlt13_1 pappyErr13 =
                              case pappyResult15 of
                                Parsed s pappyDvs15 pappyErr15 ->
                                  case lojbanpostClause pappyDvs15 of
                                    Parsed _ pappyDvs17 pappyErr17 ->
                                      Parsed (s) pappyDvs17 (maximum [pappyErr17,pappyErr15,pappyErr13])
                                    NoParse pappyErr17 -> pappyAlt13_2 (maximum [pappyErr17,pappyErr15,pappyErr13])
                                NoParse pappyErr15 -> pappyAlt13_2 (max pappyErr15 pappyErr13)
                              where
                                pappyResult15 =
                                  case lojbanChar pappyDvs9 of
                                    Parsed 'r' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed 'u' pappyDvs19 _ ->
                                          case lojbanChar pappyDvs19 of
                                            Parsed '\'' pappyDvs21 _ ->
                                              case lojbanChar pappyDvs21 of
                                                Parsed 'i' pappyDvs23 _ ->
                                                  Parsed (
                                                    "ru'i") pappyDvs23 (ParseError (lojbanPos pappyDvs23) [])
                                                _ -> NoParse (ParseError (lojbanPos pappyDvs21) [])
                                            _ -> NoParse (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs17) [])
                                    Parsed 't' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed 'a' pappyDvs19 _ ->
                                          case lojbanChar pappyDvs19 of
                                            Parsed '\'' pappyDvs21 _ ->
                                              case lojbanChar pappyDvs21 of
                                                Parsed 'e' pappyDvs23 _ ->
                                                  Parsed (
                                                    "ta'e") pappyDvs23 (ParseError (lojbanPos pappyDvs23) [])
                                                _ -> NoParse (ParseError (lojbanPos pappyDvs21) [])
                                            _ -> NoParse (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs17) [])
                                    Parsed 'd' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed 'i' pappyDvs19 _ ->
                                          case lojbanChar pappyDvs19 of
                                            Parsed '\'' pappyDvs21 _ ->
                                              case lojbanChar pappyDvs21 of
                                                Parsed 'i' pappyDvs23 _ ->
                                                  Parsed (
                                                    "di'i") pappyDvs23 (ParseError (lojbanPos pappyDvs23) [])
                                                _ -> NoParse (ParseError (lojbanPos pappyDvs21) [])
                                            _ -> NoParse (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs17) [])
                                    Parsed 'n' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed 'a' pappyDvs19 _ ->
                                          case lojbanChar pappyDvs19 of
                                            Parsed '\'' pappyDvs21 _ ->
                                              case lojbanChar pappyDvs21 of
                                                Parsed 'o' pappyDvs23 _ ->
                                                  Parsed (
                                                    "na'o") pappyDvs23 (ParseError (lojbanPos pappyDvs23) [])
                                                _ -> NoParse (ParseError (lojbanPos pappyDvs21) [])
                                            _ -> NoParse (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                            pappyAlt13_2 pappyErr13 =
                              case pappyResult15 of
                                Parsed s pappyDvs15 pappyErr15 ->
                                  case lojbanpostClause pappyDvs15 of
                                    Parsed _ pappyDvs17 pappyErr17 ->
                                      Parsed (s) pappyDvs17 (maximum [pappyErr17,pappyErr15,pappyErr13])
                                    NoParse pappyErr17 -> pappyAlt13_3 (maximum [pappyErr17,pappyErr15,pappyErr13])
                                NoParse pappyErr15 -> pappyAlt13_3 (max pappyErr15 pappyErr13)
                              where
                                pappyResult15 =
                                  case lojbanChar pappyDvs9 of
                                    Parsed 'c' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed 'o' pappyDvs19 _ ->
                                          case lojbanChar pappyDvs19 of
                                            Parsed '\'' pappyDvs21 _ ->
                                              case lojbanChar pappyDvs21 of
                                                Parsed 'i' pappyDvs23 _ ->
                                                  Parsed (
                                                    "co'i") pappyDvs23 (ParseError (lojbanPos pappyDvs23) [])
                                                Parsed 'u' pappyDvs23 _ ->
                                                  Parsed (
                                                    "co'u") pappyDvs23 (ParseError (lojbanPos pappyDvs23) [])
                                                Parsed 'a' pappyDvs23 _ ->
                                                  Parsed (
                                                    "co'a") pappyDvs23 (ParseError (lojbanPos pappyDvs23) [])
                                                _ -> NoParse (ParseError (lojbanPos pappyDvs21) [])
                                            _ -> NoParse (ParseError (lojbanPos pappyDvs19) [])
                                        Parsed 'a' pappyDvs19 _ ->
                                          case lojbanChar pappyDvs19 of
                                            Parsed '\'' pappyDvs21 _ ->
                                              case lojbanChar pappyDvs21 of
                                                Parsed 'o' pappyDvs23 _ ->
                                                  Parsed (
                                                    "ca'o") pappyDvs23 (ParseError (lojbanPos pappyDvs23) [])
                                                _ -> NoParse (ParseError (lojbanPos pappyDvs21) [])
                                            _ -> NoParse (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs17) [])
                                    Parsed 'p' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed 'u' pappyDvs19 _ ->
                                          case lojbanChar pappyDvs19 of
                                            Parsed '\'' pappyDvs21 _ ->
                                              case lojbanChar pappyDvs21 of
                                                Parsed 'o' pappyDvs23 _ ->
                                                  Parsed (
                                                    "pu'o") pappyDvs23 (ParseError (lojbanPos pappyDvs23) [])
                                                _ -> NoParse (ParseError (lojbanPos pappyDvs21) [])
                                            _ -> NoParse (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs17) [])
                                    Parsed 'm' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed 'o' pappyDvs19 _ ->
                                          case lojbanChar pappyDvs19 of
                                            Parsed '\'' pappyDvs21 _ ->
                                              case lojbanChar pappyDvs21 of
                                                Parsed 'u' pappyDvs23 _ ->
                                                  Parsed (
                                                    "mo'u") pappyDvs23 (ParseError (lojbanPos pappyDvs23) [])
                                                _ -> NoParse (ParseError (lojbanPos pappyDvs21) [])
                                            _ -> NoParse (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs17) [])
                                    Parsed 'd' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed 'e' pappyDvs19 _ ->
                                          case lojbanChar pappyDvs19 of
                                            Parsed '\'' pappyDvs21 _ ->
                                              case lojbanChar pappyDvs21 of
                                                Parsed 'a' pappyDvs23 _ ->
                                                  Parsed (
                                                    "de'a") pappyDvs23 (ParseError (lojbanPos pappyDvs23) [])
                                                _ -> NoParse (ParseError (lojbanPos pappyDvs21) [])
                                            _ -> NoParse (ParseError (lojbanPos pappyDvs19) [])
                                        Parsed 'i' pappyDvs19 _ ->
                                          case lojbanChar pappyDvs19 of
                                            Parsed '\'' pappyDvs21 _ ->
                                              case lojbanChar pappyDvs21 of
                                                Parsed 'a' pappyDvs23 _ ->
                                                  Parsed (
                                                    "di'a") pappyDvs23 (ParseError (lojbanPos pappyDvs23) [])
                                                _ -> NoParse (ParseError (lojbanPos pappyDvs21) [])
                                            _ -> NoParse (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs17) [])
                                    Parsed 'b' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed 'a' pappyDvs19 _ ->
                                          case lojbanChar pappyDvs19 of
                                            Parsed '\'' pappyDvs21 _ ->
                                              case lojbanChar pappyDvs21 of
                                                Parsed 'o' pappyDvs23 _ ->
                                                  Parsed (
                                                    "ba'o") pappyDvs23 (ParseError (lojbanPos pappyDvs23) [])
                                                _ -> NoParse (ParseError (lojbanPos pappyDvs21) [])
                                            _ -> NoParse (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs17) [])
                                    Parsed 'z' pappyDvs17 _ ->
                                      case lojbanChar pappyDvs17 of
                                        Parsed 'a' pappyDvs19 _ ->
                                          case lojbanChar pappyDvs19 of
                                            Parsed '\'' pappyDvs21 _ ->
                                              case lojbanChar pappyDvs21 of
                                                Parsed 'o' pappyDvs23 _ ->
                                                  Parsed (
                                                    "za'o") pappyDvs23 (ParseError (lojbanPos pappyDvs23) [])
                                                _ -> NoParse (ParseError (lojbanPos pappyDvs21) [])
                                            _ -> NoParse (ParseError (lojbanPos pappyDvs19) [])
                                        _ -> NoParse (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs9) [])
                            pappyAlt13_3 pappyErr13 = NoParse pappyErr13
                    NoParse pappyErr9 -> pappyAlt7_7 (max pappyErr9 pappyErr7)
                  where
                    pappyResult9 =
                      case lojbanFEhE pappyDvs3 of
                        Parsed pappyVal11 pappyDvs11 pappyErr11 -> Parsed (Just pappyVal11) pappyDvs11 pappyErr11
                        NoParse pappyErr11 -> Parsed (Nothing) pappyDvs3 pappyErr11
                pappyAlt7_7 pappyErr7 =
                  case pappyResult9 of
                    Parsed s pappyDvs9 pappyErr9 ->
                      case lojbanpostClause pappyDvs9 of
                        Parsed _ pappyDvs11 pappyErr11 ->
                          case lojbanselbri pappyDvs11 of
                            Parsed s pappyDvs13 pappyErr13 ->
                              case pappyResult15 of
                                Parsed _ pappyDvs15 pappyErr15 ->
                                  Parsed (
                                     FIhO s ) pappyDvs15 (maximum [pappyErr15,pappyErr13,pappyErr11,pappyErr9,pappyErr7])
                                NoParse pappyErr15 -> pappyAlt7_8 (maximum [pappyErr15,pappyErr13,pappyErr11,pappyErr9,pappyErr7])
                              where
                                pappyResult15 =
                                  case pappyResult17 of
                                    Parsed pappyVal17 pappyDvs17 pappyErr17 -> Parsed (Just pappyVal17) pappyDvs17 pappyErr17
                                    NoParse pappyErr17 -> Parsed (Nothing) pappyDvs13 pappyErr17
                                  where
                                    pappyResult17 =
                                      case pappyResult19 of
                                        Parsed s pappyDvs19 pappyErr19 ->
                                          case lojbanpostClause pappyDvs19 of
                                            Parsed _ pappyDvs21 pappyErr21 ->
                                              Parsed (s) pappyDvs21 (max pappyErr21 pappyErr19)
                                            NoParse pappyErr21 -> NoParse (max pappyErr21 pappyErr19)
                                        NoParse pappyErr19 -> NoParse pappyErr19
                                      where
                                        pappyResult19 =
                                          case lojbanChar pappyDvs13 of
                                            Parsed 'f' pappyDvs21 _ ->
                                              case lojbanChar pappyDvs21 of
                                                Parsed 'e' pappyDvs23 _ ->
                                                  case lojbanChar pappyDvs23 of
                                                    Parsed '\'' pappyDvs25 _ ->
                                                      case lojbanChar pappyDvs25 of
                                                        Parsed 'u' pappyDvs27 _ ->
                                                          Parsed (
                                                            "fe'u") pappyDvs27 (ParseError (lojbanPos pappyDvs27) [])
                                                        _ -> NoParse (ParseError (lojbanPos pappyDvs25) [])
                                                    _ -> NoParse (ParseError (lojbanPos pappyDvs23) [])
                                                _ -> NoParse (ParseError (lojbanPos pappyDvs21) [])
                                            _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            NoParse pappyErr13 -> pappyAlt7_8 (maximum [pappyErr13,pappyErr11,pappyErr9,pappyErr7])
                        NoParse pappyErr11 -> pappyAlt7_8 (maximum [pappyErr11,pappyErr9,pappyErr7])
                    NoParse pappyErr9 -> pappyAlt7_8 (max pappyErr9 pappyErr7)
                  where
                    pappyResult9 =
                      case lojbanChar pappyDvs3 of
                        Parsed 'f' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed 'i' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed '\'' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'o' pappyDvs17 _ ->
                                      Parsed (
                                        "fi'o") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
                pappyAlt7_8 pappyErr7 =
                  case pappyResult9 of
                    Parsed c pappyDvs9 pappyErr9 ->
                      case lojbanpostClause pappyDvs9 of
                        Parsed _ pappyDvs11 pappyErr11 ->
                          Parsed (
                             CUhE c ) pappyDvs11 (maximum [pappyErr11,pappyErr9,pappyErr7])
                        NoParse pappyErr11 -> pappyAlt7_9 (maximum [pappyErr11,pappyErr9,pappyErr7])
                    NoParse pappyErr9 -> pappyAlt7_9 (max pappyErr9 pappyErr7)
                  where
                    pappyResult9 =
                      case lojbanChar pappyDvs3 of
                        Parsed 'c' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed 'u' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed '\'' pappyDvs15 _ ->
                                  case lojbanChar pappyDvs15 of
                                    Parsed 'e' pappyDvs17 _ ->
                                      Parsed (
                                        "cu'e") pappyDvs17 (ParseError (lojbanPos pappyDvs17) [])
                                    _ -> NoParse (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        Parsed 'n' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed 'a' pappyDvs13 _ ->
                              case lojbanChar pappyDvs13 of
                                Parsed 'u' pappyDvs15 _ ->
                                  Parsed (
                                    "nau") pappyDvs15 (ParseError (lojbanPos pappyDvs15) [])
                                _ -> NoParse (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
                pappyAlt7_9 pappyErr7 =
                  case pappyResult9 of
                    Parsed s pappyDvs9 pappyErr9 ->
                      case lojbanpostClause pappyDvs9 of
                        Parsed _ pappyDvs11 pappyErr11 ->
                          Parsed (
                             KI ) pappyDvs11 (maximum [pappyErr11,pappyErr9,pappyErr7])
                        NoParse pappyErr11 -> pappyAlt7_10 (maximum [pappyErr11,pappyErr9,pappyErr7])
                    NoParse pappyErr9 -> pappyAlt7_10 (max pappyErr9 pappyErr7)
                  where
                    pappyResult9 =
                      case lojbanChar pappyDvs3 of
                        Parsed 'k' pappyDvs11 _ ->
                          case lojbanChar pappyDvs11 of
                            Parsed 'i' pappyDvs13 _ ->
                              Parsed (
                                "ki") pappyDvs13 (ParseError (lojbanPos pappyDvs13) [])
                            _ -> NoParse (ParseError (lojbanPos pappyDvs11) [])
                        _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
                pappyAlt7_10 pappyErr7 = NoParse pappyErr7
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          case lojbanconvSE pappyDvs1 of
            Parsed pappyVal5 pappyDvs5 pappyErr5 -> Parsed (Just pappyVal5) pappyDvs5 pappyErr5
            NoParse pappyErr5 -> Parsed (Nothing) pappyDvs1 pappyErr5
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanNAhE d of
        Parsed pappyVal3 pappyDvs3 pappyErr3 -> Parsed (Just pappyVal3) pappyDvs3 pappyErr3
        NoParse pappyErr3 -> Parsed (Nothing) d pappyErr3

lojbanLojbanLetter :: LojbanDerivs -> Result LojbanDerivs (Char)
lojbanLojbanLetter d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanConsonant d of
        Parsed pappyVal3 pappyDvs3 pappyErr3 -> Parsed pappyVal3 pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbanVowel d of
        Parsed pappyVal3 pappyDvs3 pappyErr3 -> Parsed pappyVal3 pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 =
      case lojbanChar d of
        Parsed c pappyDvs3 pappyErr3 ->
          case (c `elem` "',") of
            True ->
              Parsed (c) pappyDvs3 (max pappyErr3 pappyErr1)
            False -> pappyAlt1_4 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_4 (max pappyErr3 pappyErr1)
    pappyAlt1_4 pappyErr1 = NoParse pappyErr1

lojbanVowel :: LojbanDerivs -> Result LojbanDerivs (Char)
lojbanVowel d =
  case lojbanChar d of
    Parsed c pappyDvs1 pappyErr1 ->
      case (c `elem` "aeiouy") of
        True ->
          Parsed (c) pappyDvs1 pappyErr1
        False -> NoParse pappyErr1
    NoParse pappyErr1 -> NoParse pappyErr1

lojbanConsonant :: LojbanDerivs -> Result LojbanDerivs (Char)
lojbanConsonant d =
  case lojbanChar d of
    Parsed c pappyDvs1 pappyErr1 ->
      case (c `elem` "bcdfgjklmnprstvxz") of
        True ->
          Parsed (c) pappyDvs1 pappyErr1
        False -> NoParse pappyErr1
    NoParse pappyErr1 -> NoParse pappyErr1

lojbanSpace :: LojbanDerivs -> Result LojbanDerivs (())
lojbanSpace d =
  case lojbanChar d of
    Parsed c pappyDvs1 pappyErr1 ->
      case (isSpace c) of
        True ->
          Parsed (
            ()) pappyDvs1 pappyErr1
        False -> NoParse pappyErr1
    NoParse pappyErr1 -> NoParse pappyErr1

lojbanParsePlusRule13 :: LojbanDerivs -> Result LojbanDerivs ([()])
lojbanParsePlusRule13 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanSpace d of
        Parsed v pappyDvs3 pappyErr3 ->
          case lojbanPlusRule13 pappyDvs3 of
            Parsed vs pappyDvs5 pappyErr5 ->
              Parsed (
                v : vs) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbanSpace d of
        Parsed v pappyDvs3 pappyErr3 ->
          Parsed (
            [v]) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanParsePlusRule14 :: LojbanDerivs -> Result LojbanDerivs ([Char])
lojbanParsePlusRule14 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanLojbanLetter d of
        Parsed v pappyDvs3 pappyErr3 ->
          case lojbanPlusRule14 pappyDvs3 of
            Parsed vs pappyDvs5 pappyErr5 ->
              Parsed (
                v : vs) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbanLojbanLetter d of
        Parsed v pappyDvs3 pappyErr3 ->
          Parsed (
            [v]) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanValsi :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanValsi d =
  case lojbanPlusRule14 d of
    Parsed cs pappyDvs1 pappyErr1 ->
      case lojbanPlusRule13 pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (cs) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1

lojbanParsePlusRule15 :: LojbanDerivs -> Result LojbanDerivs ([Char])
lojbanParsePlusRule15 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanSpace d of
        NoParse pappyErr3 ->
          case pappyResult5 of
            NoParse pappyErr5 ->
              case lojbanChar d of
                Parsed v pappyDvs7 pappyErr7 ->
                  case lojbanPlusRule15 pappyDvs7 of
                    Parsed vs pappyDvs9 pappyErr9 ->
                      Parsed (
                        v : vs) pappyDvs9 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                    NoParse pappyErr9 -> pappyAlt1_2 (maximum [pappyErr9,pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_2 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            Parsed _ _ pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
          where
            pappyResult5 =
              case lojbanChar d of
                Parsed '.' pappyDvs7 _ ->
                  Parsed (
                    ".") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos d) [])
        Parsed _ _ pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      case lojbanSpace d of
        NoParse pappyErr3 ->
          case pappyResult5 of
            NoParse pappyErr5 ->
              case lojbanChar d of
                Parsed v pappyDvs7 pappyErr7 ->
                  Parsed (
                    [v]) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_3 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            Parsed _ _ pappyErr5 -> pappyAlt1_3 (maximum [pappyErr5,pappyErr3,pappyErr1])
          where
            pappyResult5 =
              case lojbanChar d of
                Parsed '.' pappyDvs7 _ ->
                  Parsed (
                    ".") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos d) [])
        Parsed _ _ pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanWord :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanWord d =
  case lojbanPlusRule15 d of
    Parsed cs pappyDvs1 pappyErr1 ->
      case lojbanPlusRule13 pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (cs) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1

lojbanParseStarRule29 :: LojbanDerivs -> Result LojbanDerivs ([Char])
lojbanParseStarRule29 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case lojbanLojbanLetter d of
        Parsed v pappyDvs3 pappyErr3 ->
          case pappyResult5 of
            NoParse pappyErr5 ->
              case lojbanStarRule29 pappyDvs3 of
                Parsed vs pappyDvs7 pappyErr7 ->
                  Parsed (
                    v : vs) pappyDvs7 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
                NoParse pappyErr7 -> pappyAlt1_2 (maximum [pappyErr7,pappyErr5,pappyErr3,pappyErr1])
            Parsed _ _ pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
          where
            pappyResult5 =
              case lojbanPlusRule13 pappyDvs3 of
                Parsed _ pappyDvs7 pappyErr7 ->
                  Parsed (
                    ()) pappyDvs7 pappyErr7
                NoParse pappyErr7 -> NoParse pappyErr7
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
    pappyAlt1_2 pappyErr1 =
      Parsed (
        []) d pappyErr1
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanCMENE :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanCMENE d =
  case lojbanStarRule29 d of
    Parsed ls pappyDvs1 pappyErr1 ->
      case lojbanConsonant pappyDvs1 of
        Parsed c pappyDvs3 pappyErr3 ->
          case lojbanPlusRule13 pappyDvs3 of
            Parsed _ pappyDvs5 pappyErr5 ->
              Parsed (
                ls++[c]) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> NoParse (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1

lojbanParseStarRule30 :: LojbanDerivs -> Result LojbanDerivs ([Char])
lojbanParseStarRule30 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case pappyResult3 of
        Parsed v pappyDvs3 pappyErr3 ->
          case lojbanStarRule30 pappyDvs3 of
            Parsed vs pappyDvs5 pappyErr5 ->
              Parsed (
                v : vs) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          pappyAlt5_1 (ParseError (lojbanPos d) []) where
            pappyAlt5_1 pappyErr5 =
              case lojbanVowel d of
                Parsed pappyVal7 pappyDvs7 pappyErr7 -> Parsed pappyVal7 pappyDvs7 (max pappyErr7 pappyErr5)
                NoParse pappyErr7 -> pappyAlt5_2 (max pappyErr7 pappyErr5)
            pappyAlt5_2 pappyErr5 =
              case lojbanChar d of
                r @ (Parsed '\'' _ _) -> r
                _ -> pappyAlt5_3 pappyErr5
            pappyAlt5_3 pappyErr5 = NoParse pappyErr5
    pappyAlt1_2 pappyErr1 =
      Parsed (
        []) d pappyErr1
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanParsePlusRule16 :: LojbanDerivs -> Result LojbanDerivs ([Char])
lojbanParsePlusRule16 d =
  pappyAlt1_1 (ParseError (lojbanPos d) []) where
    pappyAlt1_1 pappyErr1 =
      case pappyResult3 of
        Parsed v pappyDvs3 pappyErr3 ->
          case lojbanPlusRule16 pappyDvs3 of
            Parsed vs pappyDvs5 pappyErr5 ->
              Parsed (
                v : vs) pappyDvs5 (maximum [pappyErr5,pappyErr3,pappyErr1])
            NoParse pappyErr5 -> pappyAlt1_2 (maximum [pappyErr5,pappyErr3,pappyErr1])
        NoParse pappyErr3 -> pappyAlt1_2 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          pappyAlt5_1 (ParseError (lojbanPos d) []) where
            pappyAlt5_1 pappyErr5 =
              case lojbanVowel d of
                Parsed pappyVal7 pappyDvs7 pappyErr7 -> Parsed pappyVal7 pappyDvs7 (max pappyErr7 pappyErr5)
                NoParse pappyErr7 -> pappyAlt5_2 (max pappyErr7 pappyErr5)
            pappyAlt5_2 pappyErr5 =
              case lojbanChar d of
                r @ (Parsed '\'' _ _) -> r
                _ -> pappyAlt5_3 pappyErr5
            pappyAlt5_3 pappyErr5 = NoParse pappyErr5
    pappyAlt1_2 pappyErr1 =
      case pappyResult3 of
        Parsed v pappyDvs3 pappyErr3 ->
          Parsed (
            [v]) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> pappyAlt1_3 (max pappyErr3 pappyErr1)
      where
        pappyResult3 =
          pappyAlt5_1 (ParseError (lojbanPos d) []) where
            pappyAlt5_1 pappyErr5 =
              case lojbanVowel d of
                Parsed pappyVal7 pappyDvs7 pappyErr7 -> Parsed pappyVal7 pappyDvs7 (max pappyErr7 pappyErr5)
                NoParse pappyErr7 -> pappyAlt5_2 (max pappyErr7 pappyErr5)
            pappyAlt5_2 pappyErr5 =
              case lojbanChar d of
                r @ (Parsed '\'' _ _) -> r
                _ -> pappyAlt5_3 pappyErr5
            pappyAlt5_3 pappyErr5 = NoParse pappyErr5
    pappyAlt1_3 pappyErr1 = NoParse pappyErr1

lojbanpostClause :: LojbanDerivs -> Result LojbanDerivs (())
lojbanpostClause d =
  case lojbanPlusRule13 d of
    Parsed _ pappyDvs1 pappyErr1 ->
      case lojbanBU pappyDvs1 of
        NoParse pappyErr3 ->
          Parsed (
            ()) pappyDvs1 (max pappyErr3 pappyErr1)
        Parsed _ _ pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1

lojbanA :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanA d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'a' pappyDvs3 _ ->
          Parsed (
            "a") pappyDvs3 (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'e' pappyDvs3 _ ->
          Parsed (
            "e") pappyDvs3 (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'j' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'i' pappyDvs5 _ ->
              Parsed (
                "ji") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'o' pappyDvs3 _ ->
          Parsed (
            "o") pappyDvs3 (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'u' pappyDvs3 _ ->
          Parsed (
            "u") pappyDvs3 (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanBO :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanBO d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'b' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'o' pappyDvs5 _ ->
              Parsed (
                "bo") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanBOI :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanBOI d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'b' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'o' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'i' pappyDvs7 _ ->
                  Parsed (
                    "boi") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanParseBU :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanParseBU d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'b' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'u' pappyDvs5 _ ->
              Parsed (
                "bu") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanCEhE :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanCEhE d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'c' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'e' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'e' pappyDvs9 _ ->
                      Parsed (
                        "ce'e") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanCU :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanCU d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'c' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'u' pappyDvs5 _ ->
              Parsed (
                "cu") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanDOhU :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanDOhU d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'd' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'o' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "do'u") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanFA :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanFA d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'f' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'a' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'i' pappyDvs7 _ ->
                  Parsed (
                    "fai") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ ->
                  Parsed (
                    "fa") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'i' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'a' pappyDvs9 _ ->
                      Parsed (
                        "fi'a") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ ->
                  Parsed (
                    "fi") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'e' pappyDvs5 _ ->
              Parsed (
                "fe") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'o' pappyDvs5 _ ->
              Parsed (
                "fo") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'u' pappyDvs5 _ ->
              Parsed (
                "fu") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanFEhE :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanFEhE d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'f' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'e' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'e' pappyDvs9 _ ->
                      Parsed (
                        "fe'e") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanGA :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanGA d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'g' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'e' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'i' pappyDvs9 _ ->
                      Parsed (
                        "ge'i") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ ->
                  Parsed (
                    "ge") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'o' pappyDvs5 _ ->
              Parsed (
                "go") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'a' pappyDvs5 _ ->
              Parsed (
                "ga") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'u' pappyDvs5 _ ->
              Parsed (
                "gu") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanGAhO :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanGAhO d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'k' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'e' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'i' pappyDvs9 _ ->
                      Parsed (
                        "ke'i") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'g' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'a' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'o' pappyDvs9 _ ->
                      Parsed (
                        "ga'o") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanGEhU :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanGEhU d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'g' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'e' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "ge'u") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanGI :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanGI d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'g' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'i' pappyDvs5 _ ->
              Parsed (
                "gi") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanGIhA :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanGIhA d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'g' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'i' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'e' pappyDvs9 _ ->
                      Parsed (
                        "gi'e") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'i' pappyDvs9 _ ->
                      Parsed (
                        "gi'i") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'o' pappyDvs9 _ ->
                      Parsed (
                        "gi'o") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'a' pappyDvs9 _ ->
                      Parsed (
                        "gi'a") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "gi'u") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanGOI :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanGOI d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'n' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'o' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "no'u") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'e' pappyDvs5 _ ->
              Parsed (
                "ne") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'g' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'o' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'i' pappyDvs7 _ ->
                  Parsed (
                    "goi") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'p' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'o' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "po'u") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'e' pappyDvs9 _ ->
                      Parsed (
                        "po'e") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ ->
                  Parsed (
                    "po") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'e' pappyDvs5 _ ->
              Parsed (
                "pe") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanParseGOhA :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanParseGOhA d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'm' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'o' pappyDvs5 _ ->
              Parsed (
                "mo") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'n' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'e' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'i' pappyDvs7 _ ->
                  Parsed (
                    "nei") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'o' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'a' pappyDvs9 _ ->
                      Parsed (
                        "no'a") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'g' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'o' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "go'u") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'o' pappyDvs9 _ ->
                      Parsed (
                        "go'o") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'i' pappyDvs9 _ ->
                      Parsed (
                        "go'i") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'e' pappyDvs9 _ ->
                      Parsed (
                        "go'e") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'a' pappyDvs9 _ ->
                      Parsed (
                        "go'a") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'd' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'u' pappyDvs5 _ ->
              Parsed (
                "du") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'b' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'u' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'a' pappyDvs9 _ ->
                      Parsed (
                        "bu'a") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'e' pappyDvs9 _ ->
                      Parsed (
                        "bu'e") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'i' pappyDvs9 _ ->
                      Parsed (
                        "bu'i") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'c' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'o' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'e' pappyDvs9 _ ->
                      Parsed (
                        "co'e") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanGUhA :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanGUhA d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'g' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'u' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'e' pappyDvs9 _ ->
                      Parsed (
                        "gu'e") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'i' pappyDvs9 _ ->
                      Parsed (
                        "gu'i") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'o' pappyDvs9 _ ->
                      Parsed (
                        "gu'o") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'a' pappyDvs9 _ ->
                      Parsed (
                        "gu'a") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "gu'u") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanI :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanI d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'i' pappyDvs3 _ ->
          Parsed (
            "i") pappyDvs3 (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanJA :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanJA d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'j' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'e' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'i' pappyDvs9 _ ->
                      Parsed (
                        "je'i") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ ->
                  Parsed (
                    "je") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'o' pappyDvs5 _ ->
              Parsed (
                "jo") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'a' pappyDvs5 _ ->
              Parsed (
                "ja") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'u' pappyDvs5 _ ->
              Parsed (
                "ju") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanKE :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanKE d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'k' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'e' pappyDvs5 _ ->
              Parsed (
                "ke") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanKEhE :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanKEhE d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'k' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'e' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'e' pappyDvs9 _ ->
                      Parsed (
                        "ke'e") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanParseKOhA :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanParseKOhA d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'd' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'a' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "da'u") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'e' pappyDvs9 _ ->
                      Parsed (
                        "da'e") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ ->
                  Parsed (
                    "da") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'i' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "di'u") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'e' pappyDvs9 _ ->
                      Parsed (
                        "di'e") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ ->
                  Parsed (
                    "di") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'e' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "de'u") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'e' pappyDvs9 _ ->
                      Parsed (
                        "de'e") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'i' pappyDvs7 _ ->
                  Parsed (
                    "dei") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ ->
                  Parsed (
                    "de") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'o' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'i' pappyDvs9 _ ->
                      Parsed (
                        "do'i") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'o' pappyDvs9 _ ->
                      Parsed (
                        "do'o") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ ->
                  Parsed (
                    "do") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'm' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'i' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'o' pappyDvs9 _ ->
                      Parsed (
                        "mi'o") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'a' pappyDvs9 _ ->
                      Parsed (
                        "mi'a") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ ->
                  Parsed (
                    "mi") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'a' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'a' pappyDvs9 _ ->
                      Parsed (
                        "ma'a") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ ->
                  Parsed (
                    "ma") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'k' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'o' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'a' pappyDvs9 _ ->
                      Parsed (
                        "ko'a") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'e' pappyDvs9 _ ->
                      Parsed (
                        "ko'e") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'i' pappyDvs9 _ ->
                      Parsed (
                        "ko'i") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'o' pappyDvs9 _ ->
                      Parsed (
                        "ko'o") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "ko'u") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ ->
                  Parsed (
                    "ko") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'e' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'a' pappyDvs9 _ ->
                      Parsed (
                        "ke'a") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'f' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'o' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "fo'u") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'a' pappyDvs9 _ ->
                      Parsed (
                        "fo'a") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'e' pappyDvs9 _ ->
                      Parsed (
                        "fo'e") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'i' pappyDvs9 _ ->
                      Parsed (
                        "fo'i") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'o' pappyDvs9 _ ->
                      Parsed (
                        "fo'o") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'v' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'o' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'a' pappyDvs9 _ ->
                      Parsed (
                        "vo'a") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'e' pappyDvs9 _ ->
                      Parsed (
                        "vo'e") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'i' pappyDvs9 _ ->
                      Parsed (
                        "vo'i") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'o' pappyDvs9 _ ->
                      Parsed (
                        "vo'o") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "vo'u") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'z' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'i' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'o' pappyDvs9 _ ->
                      Parsed (
                        "zi'o") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'u' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'i' pappyDvs9 _ ->
                      Parsed (
                        "zu'i") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'o' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'e' pappyDvs9 _ ->
                      Parsed (
                        "zo'e") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'c' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'e' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "ce'u") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'r' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'u' pappyDvs5 _ ->
              Parsed (
                "ru") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'i' pappyDvs5 _ ->
              Parsed (
                "ri") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'a' pappyDvs5 _ ->
              Parsed (
                "ra") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 't' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'a' pappyDvs5 _ ->
              Parsed (
                "ta") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'u' pappyDvs5 _ ->
              Parsed (
                "tu") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'i' pappyDvs5 _ ->
              Parsed (
                "ti") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanKU :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanKU d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'k' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'u' pappyDvs5 _ ->
              Parsed (
                "ku") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanKUhO :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanKUhO d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'k' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'u' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'o' pappyDvs9 _ ->
                      Parsed (
                        "ku'o") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanLA :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanLA d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'l' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'a' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'i' pappyDvs7 _ ->
                  Parsed (
                    "lai") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'i' pappyDvs9 _ ->
                      Parsed (
                        "la'i") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ ->
                  Parsed (
                    "la") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanLEhU :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanLEhU d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'l' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'e' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "le'u") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanLI :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanLI d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'm' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'e' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'o' pappyDvs9 _ ->
                      Parsed (
                        "me'o") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'l' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'i' pappyDvs5 _ ->
              Parsed (
                "li") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanLOhO :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanLOhO d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'l' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'o' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'o' pappyDvs9 _ ->
                      Parsed (
                        "lo'o") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanLUhU :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanLUhU d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'l' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'u' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "lu'u") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanMOI :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanMOI d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'm' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'e' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'i' pappyDvs7 _ ->
                  Parsed (
                    "mei") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'o' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'i' pappyDvs7 _ ->
                  Parsed (
                    "moi") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 's' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'i' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'e' pappyDvs9 _ ->
                      Parsed (
                        "si'e") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'c' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'u' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'o' pappyDvs9 _ ->
                      Parsed (
                        "cu'o") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'v' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'a' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'e' pappyDvs9 _ ->
                      Parsed (
                        "va'e") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanNA :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanNA d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'j' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'a' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'a' pappyDvs9 _ ->
                      Parsed (
                        "ja'a") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'n' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'a' pappyDvs5 _ ->
              Parsed (
                "na") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanNAI :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanNAI d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'n' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'a' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'i' pappyDvs7 _ ->
                  Parsed (
                    "nai") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanNAhE :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanNAhE d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 't' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'o' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'e' pappyDvs9 _ ->
                      Parsed (
                        "to'e") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'j' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'e' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'a' pappyDvs9 _ ->
                      Parsed (
                        "je'a") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'n' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'a' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'e' pappyDvs9 _ ->
                      Parsed (
                        "na'e") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'o' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'e' pappyDvs9 _ ->
                      Parsed (
                        "no'e") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanNIhO :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanNIhO d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'n' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'i' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'o' pappyDvs9 _ ->
                      Parsed (
                        "ni'o") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'o' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'i' pappyDvs9 _ ->
                      Parsed (
                        "no'i") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanNOI :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanNOI d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'v' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'o' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'i' pappyDvs7 _ ->
                  Parsed (
                    "voi") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'n' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'o' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'i' pappyDvs7 _ ->
                  Parsed (
                    "noi") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'p' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'o' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'i' pappyDvs7 _ ->
                  Parsed (
                    "poi") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanNUhI :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanNUhI d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'n' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'u' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'i' pappyDvs9 _ ->
                      Parsed (
                        "nu'i") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanNUhU :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanNUhU d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'n' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'u' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "nu'u") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanParsePA :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanParsePA d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'p' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'i' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'e' pappyDvs9 _ ->
                      Parsed (
                        "pi'e") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ ->
                  Parsed (
                    "pi") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'a' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'i' pappyDvs7 _ ->
                  Parsed (
                    "pai") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ ->
                  Parsed (
                    "pa") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'f' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'i' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "fi'u") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'e' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'i' pappyDvs7 _ ->
                  Parsed (
                    "fei") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'z' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'a' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "za'u") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'e' pappyDvs5 _ ->
              Parsed (
                "ze") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'm' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'e' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'i' pappyDvs9 _ ->
                      Parsed (
                        "me'i") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'a' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "ma'u") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'o' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'a' pappyDvs9 _ ->
                      Parsed (
                        "mo'a") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'u' pappyDvs5 _ ->
              Parsed (
                "mu") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'n' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'i' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "ni'u") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'o' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'o' pappyDvs9 _ ->
                      Parsed (
                        "no'o") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ ->
                  Parsed (
                    "no") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'k' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'i' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'o' pappyDvs9 _ ->
                      Parsed (
                        "ki'o") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'a' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'o' pappyDvs9 _ ->
                      Parsed (
                        "ka'o") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'c' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'e' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'i' pappyDvs9 _ ->
                      Parsed (
                        "ce'i") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'i' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'i' pappyDvs9 _ ->
                      Parsed (
                        "ci'i") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ ->
                  Parsed (
                    "ci") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'r' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'a' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'e' pappyDvs9 _ ->
                      Parsed (
                        "ra'e") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'u' pappyDvs7 _ ->
                  Parsed (
                    "rau") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'e' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'i' pappyDvs7 _ ->
                  Parsed (
                    "rei") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ ->
                  Parsed (
                    "re") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'o' pappyDvs5 _ ->
              Parsed (
                "ro") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'd' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'a' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'a' pappyDvs9 _ ->
                      Parsed (
                        "da'a") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'u' pappyDvs7 _ ->
                  Parsed (
                    "dau") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'u' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'e' pappyDvs9 _ ->
                      Parsed (
                        "du'e") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 's' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'o' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'a' pappyDvs9 _ ->
                      Parsed (
                        "so'a") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "so'u") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'i' pappyDvs9 _ ->
                      Parsed (
                        "so'i") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'e' pappyDvs9 _ ->
                      Parsed (
                        "so'e") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'o' pappyDvs9 _ ->
                      Parsed (
                        "so'o") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ ->
                  Parsed (
                    "so") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'u' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'o' pappyDvs9 _ ->
                      Parsed (
                        "su'o") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'e' pappyDvs9 _ ->
                      Parsed (
                        "su'e") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'j' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'i' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'i' pappyDvs9 _ ->
                      Parsed (
                        "ji'i") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'a' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'u' pappyDvs7 _ ->
                  Parsed (
                    "jau") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 't' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'e' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'o' pappyDvs9 _ ->
                      Parsed (
                        "te'o") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'u' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'o' pappyDvs9 _ ->
                      Parsed (
                        "tu'o") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'g' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'a' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'i' pappyDvs7 _ ->
                  Parsed (
                    "gai") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'v' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'a' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'i' pappyDvs7 _ ->
                  Parsed (
                    "vai") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'o' pappyDvs5 _ ->
              Parsed (
                "vo") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'x' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'o' pappyDvs5 _ ->
              Parsed (
                "xo") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'a' pappyDvs5 _ ->
              Parsed (
                "xa") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'b' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'i' pappyDvs5 _ ->
              Parsed (
                "bi") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanSE :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanSE d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 's' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'e' pappyDvs5 _ ->
              Parsed (
                "se") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 't' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'e' pappyDvs5 _ ->
              Parsed (
                "te") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'v' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'e' pappyDvs5 _ ->
              Parsed (
                "ve") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'x' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'e' pappyDvs5 _ ->
              Parsed (
                "xe") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanSEI :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanSEI d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 's' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'e' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'i' pappyDvs7 _ ->
                  Parsed (
                    "sei") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 't' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'i' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'o' pappyDvs9 _ ->
                      Parsed (
                        "ti'o") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanSEhU :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanSEhU d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 's' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'e' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "se'u") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanTEhU :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanTEhU d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 't' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'e' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "te'u") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanParseUI :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanParseUI d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'i' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed '\'' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'a' pappyDvs7 _ ->
                  Parsed (
                    "i'a") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'o' pappyDvs7 _ ->
                  Parsed (
                    "i'o") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'e' pappyDvs7 _ ->
                  Parsed (
                    "i'e") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'u' pappyDvs7 _ ->
                  Parsed (
                    "i'u") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'i' pappyDvs7 _ ->
                  Parsed (
                    "i'i") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'e' pappyDvs5 _ ->
              Parsed (
                "ie") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'a' pappyDvs5 _ ->
              Parsed (
                "ia") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'i' pappyDvs5 _ ->
              Parsed (
                "ii") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'u' pappyDvs5 _ ->
              Parsed (
                "iu") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'o' pappyDvs5 _ ->
              Parsed (
                "io") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'a' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed '\'' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'e' pappyDvs7 _ ->
                  Parsed (
                    "a'e") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'a' pappyDvs7 _ ->
                  Parsed (
                    "a'a") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'i' pappyDvs7 _ ->
                  Parsed (
                    "a'i") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'o' pappyDvs7 _ ->
                  Parsed (
                    "a'o") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'u' pappyDvs7 _ ->
                  Parsed (
                    "a'u") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'u' pappyDvs5 _ ->
              Parsed (
                "au") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'i' pappyDvs5 _ ->
              Parsed (
                "ai") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'u' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed '\'' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'i' pappyDvs7 _ ->
                  Parsed (
                    "u'i") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'o' pappyDvs7 _ ->
                  Parsed (
                    "u'o") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'a' pappyDvs7 _ ->
                  Parsed (
                    "u'a") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'u' pappyDvs7 _ ->
                  Parsed (
                    "u'u") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'e' pappyDvs7 _ ->
                  Parsed (
                    "u'e") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'o' pappyDvs5 _ ->
              Parsed (
                "uo") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'a' pappyDvs5 _ ->
              Parsed (
                "ua") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'i' pappyDvs5 _ ->
              Parsed (
                "ui") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'u' pappyDvs5 _ ->
              Parsed (
                "uu") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'e' pappyDvs5 _ ->
              Parsed (
                "ue") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'o' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed '\'' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'i' pappyDvs7 _ ->
                  Parsed (
                    "o'i") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'e' pappyDvs7 _ ->
                  Parsed (
                    "o'e") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'o' pappyDvs7 _ ->
                  Parsed (
                    "o'o") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'a' pappyDvs7 _ ->
                  Parsed (
                    "o'a") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'u' pappyDvs7 _ ->
                  Parsed (
                    "o'u") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'i' pappyDvs5 _ ->
              Parsed (
                "oi") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'e' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed '\'' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'e' pappyDvs7 _ ->
                  Parsed (
                    "e'e") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'i' pappyDvs7 _ ->
                  Parsed (
                    "e'i") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'a' pappyDvs7 _ ->
                  Parsed (
                    "e'a") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'o' pappyDvs7 _ ->
                  Parsed (
                    "e'o") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'u' pappyDvs7 _ ->
                  Parsed (
                    "e'u") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'i' pappyDvs5 _ ->
              Parsed (
                "ei") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'b' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'a' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'a' pappyDvs9 _ ->
                      Parsed (
                        "ba'a") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "ba'u") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'i' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "bi'u") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'e' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "be'u") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'u' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'o' pappyDvs9 _ ->
                      Parsed (
                        "bu'o") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'j' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'a' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'o' pappyDvs9 _ ->
                      Parsed (
                        "ja'o") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'u' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'a' pappyDvs9 _ ->
                      Parsed (
                        "ju'a") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'o' pappyDvs9 _ ->
                      Parsed (
                        "ju'o") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'e' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "je'u") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'o' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'a' pappyDvs9 _ ->
                      Parsed (
                        "jo'a") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'i' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'a' pappyDvs9 _ ->
                      Parsed (
                        "ji'a") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'c' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'a' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'e' pappyDvs9 _ ->
                      Parsed (
                        "ca'e") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 's' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'u' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'a' pappyDvs9 _ ->
                      Parsed (
                        "su'a") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'e' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'o' pappyDvs9 _ ->
                      Parsed (
                        "se'o") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'i' pappyDvs9 _ ->
                      Parsed (
                        "se'i") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'a' pappyDvs9 _ ->
                      Parsed (
                        "se'a") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'a' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'e' pappyDvs9 _ ->
                      Parsed (
                        "sa'e") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "sa'u") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'a' pappyDvs9 _ ->
                      Parsed (
                        "sa'a") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'i' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'a' pappyDvs9 _ ->
                      Parsed (
                        "si'a") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 't' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'i' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'e' pappyDvs9 _ ->
                      Parsed (
                        "ti'e") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'a' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'o' pappyDvs9 _ ->
                      Parsed (
                        "ta'o") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "ta'u") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'o' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "to'u") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'k' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'a' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "ka'u") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'u' pappyDvs7 _ ->
                  Parsed (
                    "kau") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'e' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "ke'u") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'u' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'i' pappyDvs9 _ ->
                      Parsed (
                        "ku'i") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'i' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'a' pappyDvs9 _ ->
                      Parsed (
                        "ki'a") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'z' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'a' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'a' pappyDvs9 _ ->
                      Parsed (
                        "za'a") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'u' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "zu'u") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'o' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'o' pappyDvs9 _ ->
                      Parsed (
                        "zo'o") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'p' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'e' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'i' pappyDvs9 _ ->
                      Parsed (
                        "pe'i") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'a' pappyDvs9 _ ->
                      Parsed (
                        "pe'a") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'a' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'e' pappyDvs9 _ ->
                      Parsed (
                        "pa'e") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'u' pappyDvs7 _ ->
                  Parsed (
                    "pau") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'o' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'o' pappyDvs9 _ ->
                      Parsed (
                        "po'o") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'r' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'u' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'a' pappyDvs9 _ ->
                      Parsed (
                        "ru'a") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'a' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "ra'u") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'o' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'i' pappyDvs9 _ ->
                      Parsed (
                        "ro'i") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'e' pappyDvs9 _ ->
                      Parsed (
                        "ro'e") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'o' pappyDvs9 _ ->
                      Parsed (
                        "ro'o") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "ro'u") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'a' pappyDvs9 _ ->
                      Parsed (
                        "ro'a") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'e' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'e' pappyDvs9 _ ->
                      Parsed (
                        "re'e") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'i' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'e' pappyDvs9 _ ->
                      Parsed (
                        "ri'e") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'l' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'i' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'a' pappyDvs9 _ ->
                      Parsed (
                        "li'a") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    Parsed 'o' pappyDvs9 _ ->
                      Parsed (
                        "li'o") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'a' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'a' pappyDvs9 _ ->
                      Parsed (
                        "la'a") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'e' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'o' pappyDvs9 _ ->
                      Parsed (
                        "le'o") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'm' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'u' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'a' pappyDvs9 _ ->
                      Parsed (
                        "mu'a") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'i' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'u' pappyDvs9 _ ->
                      Parsed (
                        "mi'u") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'd' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'o' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'a' pappyDvs9 _ ->
                      Parsed (
                        "do'a") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'a' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'i' pappyDvs9 _ ->
                      Parsed (
                        "da'i") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                Parsed 'i' pappyDvs7 _ ->
                  Parsed (
                    "dai") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'v' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'a' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'i' pappyDvs9 _ ->
                      Parsed (
                        "va'i") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'u' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'e' pappyDvs9 _ ->
                      Parsed (
                        "vu'e") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'n' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'a' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'i' pappyDvs9 _ ->
                      Parsed (
                        "na'i") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'f' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'u' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'i' pappyDvs9 _ ->
                      Parsed (
                        "fu'i") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'g' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'a' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'i' pappyDvs9 _ ->
                      Parsed (
                        "ga'i") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            Parsed 'e' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'e' pappyDvs9 _ ->
                      Parsed (
                        "ge'e") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        Parsed 'x' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'u' pappyDvs5 _ ->
              Parsed (
                "xu") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanVAU :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanVAU d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'v' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'a' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'u' pappyDvs7 _ ->
                  Parsed (
                    "vau") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanVEI :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanVEI d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'v' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'e' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'i' pappyDvs7 _ ->
                  Parsed (
                    "vei") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanVEhO :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanVEhO d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'v' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'e' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed '\'' pappyDvs7 _ ->
                  case lojbanChar pappyDvs7 of
                    Parsed 'o' pappyDvs9 _ ->
                      Parsed (
                        "ve'o") pappyDvs9 (ParseError (lojbanPos pappyDvs9) [])
                    _ -> NoParse (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanXI :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanXI d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanpostClause pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'x' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'i' pappyDvs5 _ ->
              Parsed (
                "xi") pappyDvs5 (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])

lojbanZEI :: LojbanDerivs -> Result LojbanDerivs (String)
lojbanZEI d =
  case pappyResult1 of
    Parsed s pappyDvs1 pappyErr1 ->
      case lojbanPlusRule13 pappyDvs1 of
        Parsed _ pappyDvs3 pappyErr3 ->
          Parsed (s) pappyDvs3 (max pappyErr3 pappyErr1)
        NoParse pappyErr3 -> NoParse (max pappyErr3 pappyErr1)
    NoParse pappyErr1 -> NoParse pappyErr1
  where
    pappyResult1 =
      case lojbanChar d of
        Parsed 'z' pappyDvs3 _ ->
          case lojbanChar pappyDvs3 of
            Parsed 'e' pappyDvs5 _ ->
              case lojbanChar pappyDvs5 of
                Parsed 'i' pappyDvs7 _ ->
                  Parsed (
                    "zei") pappyDvs7 (ParseError (lojbanPos pappyDvs7) [])
                _ -> NoParse (ParseError (lojbanPos pappyDvs5) [])
            _ -> NoParse (ParseError (lojbanPos pappyDvs3) [])
        _ -> NoParse (ParseError (lojbanPos d) [])


